C             Program COVFORM   (Source code, Fortran-90)

C                    Last revised:  30 December 2002

C Set parameters for writing ASCII KOV-files by GENSCOR and SAMPLCOV:
C   LLEN, Max chars in line.  ND, No. decimals.  LT: Lower triangle (1) vs.
C   square (0).  LWRP, line breaks only at line limit (1) vs. break before
C   each var's string (0)
      LOGICAL QY
      CHARACTER*12 CF, F1, TX(0:1)*15, TY(0:1)*8 ! , FMT*40
      DATA LLEN,ND,LT,LWRP/150,3,1,1/, TY/'triangle','square  '/
      DATA TX/'full squares   ','lower triangles'/
      COMMON /CF/ CF
      EXTERNAL SCAN
      OPEN(2,STATUS='SCRATCH')
      F1 = 'KOVFMT'
      INQUIRE(FILE=F1,EXIST=QY)
      IF(QY) THEN ! >>> Blank entry is read as 0 before branching to ERR
        OPEN(7,FILE=F1)
        READ(7,*,ERR=10) M; M = MAX(10,MIN(240,LLEN))
        READ(7,*,ERR=10) M; ND = MAX(3,MIN(5,M))
        READ(7,*,ERR=10) M;  LT = MAX(0,MIN(1,LT))
        READ(7,*,ERR=10) M; LWRP = MAX(0,MIN(1,LWRP))
CC        MXL = LLEN/(ND+1)  ! Code for program reading this input
CC        FMT = '('//CF(:JF(MXL))//'I'//CF(:JF(ND+1))//')'
10      CLOSE(7)
      END IF

c                 Ŀ
c                     COVFORM: A Brief Encounter    
c                 
C Before you can test source recovery from simulation data, either the data
C scores or their covariances must of course be uploaded by your solution
C program.  Gendata cannot format its output with assurance that it fully
C complies with your program's input requirements; but it can try to put you
C close enough that if necessary you can bridge the gap by text editing of
C the ASCII datafile.  Here, you set covariance-format parameters that
C cannot easily be edited after data production:

C 1. the maximum line length LLEN (number of characters) your SEM program can
C      read or, if that is large, the maximum you choose to allow.
C 2. The number ND of leading decimals to record for each correlation.  These
C     will be written to 2  ND  5 places with the decimal point omitted.
C 3. Whether (a) to write just the lower triangle of this correlation matrix,
C     or (b) its complete symmetric square.  [ LT = 1,0 ]
C 4. Whether (a) the array can be written as a continuous line with spaces
C     between adjacent elements but line breaks only when required by length
C     limit, or (b) a new line must be started after completing entry of each
C     matrix row.  [Note: choice (b) is fail-safe but ugly.]  [ LWRP = 1,0 ]
C     matrix row. [Choice (b) is fail-safe but ugly and probably unnecessary.]

C    Maximum line length is now ",A," characters.  Hit RETURN if OK, or
C    or enter another choice of LLEN.
C
C    The number of the correlations' leading decimals to record is now ",A,"."
C    Hit RETURN if OK, or enter another choice of ND.
C                                          full squares
C    If correlation matrices are to be recorded as lower triangles, hit RETURN.
C    Otherwise, enter anything to choose square.
C    If correlation matrices are to be recorded as full squares, hit RETURN.
C    Otherwise, enter anything to choose triangle.
C                                        square
C    If line wrap is needed only where length limit requires, hit RETURN.
C    Otherwise, enter anything to break also at end of each array row.
C    If line wrap is needed only where length limit requires, enter something.
C    Otherwise, hit RETURN to break also at end of each array row.

      CALL SYSTEM('CLS')
      WRITE(6,'(/14X,"",42(""),""/14X,"",8X,"COVFORM: A Brief En",
     +  "counter",8X,""/14X,"",42(""),"")')
      WRITE(6,'(/" Before you can test source recovery from simulatio",
     +  "n data, either the data"/" scores or their covariances must ",
     +  "of course be uploaded by your solution"/" program.  Gendata ",
     +  "cannot format its output with assurance that it fully"/" co",
     +  "mplies with your program''s input requirements; but it can ",
     +  "try to put you"/" close enough that if necessary you can br",
     +  "idge the gap by text editing of"/" the ASCII datafile.  ",
     +  "Here, you set covariance-format parameters that"/" cannot ",
     +  "easily be edited after data production:"/)')

      WRITE(6,'(" 1. the maximum line length LLEN (number of charact",
     +  "ers) your SEM program can"/6X," read or, if that is large, ",
     +  "the maximum you choose to allow."/" 2. The number ND of lea",
     +  "ding decimals to record for each correlation.  These"/6X,"w",
     +  "ill be written to 2  ND  5 places with the decimal point ",
     +  "omitted."/" 3. Whether (a) to write just the lower triangle",
     +  " of this correlation matrix,"/6X,"or (b) its complete symmet",
     +  "ric square."/" 4. Whether (a) the array can be written as a ",
     +  "continuous line with spaces"/6X,"between adjacent elements b",
     +  "ut line breaks only when required by line"/6X,"limit, or (b)",
     +  " a new line must be started after completing entry of each"/
     +  6X,"matrix row.  [Choice (b) is fail-safe but ugly and proba",
     +  "bly unnecessary.]")'); CALL WAIT(1)

20    WRITE(6,'(4X,"Maximum line length is now ",A," characters.  Hit",
     +  " RETURN if OK, or"/4X,"enter another choice of LLEN."/)')
     +  CF(:JF(LLEN))
      CALL SCAN(J,1,'I'); IF(J==0) GOTO 30
      READ(2,*) LLEN; LLEN = MAX(20,MIN(240,LLEN))
      GOTO 20

30    WRITE(6,'(4X,"The number of leading correlation decimals to ",
     +  "record is now ",A,"."/4X,"Hit RETURN if OK, or enter anot",
     +  "her choice of ND."/)') CF(:JF(ND))
      CALL SCAN(J,1,'I'); IF(J==0) GOTO 40
      READ(2,*) ND; ND = MAX(2,MIN(5,ND))
      GOTO 30

40    WRITE(6,'(4X,"If correlations are to be recorded as ",A,", hit",
     +  " RETURN."/4X,"Otherwise, enter anything to choose ",A,".")')
     +  TX(LT)(:LAST(TX(LT))), TY(LT)(:LAST(TY(LT)))
      CALL SCAN(J,1,'B'); IF(J==0) GOTO 50
      LT = 1-LT; GOTO 40

50    IF(LWRP==1) WRITE(6,'(4X,"If line wrap is needed only where len",
     +  "gth limit requires, hit RETURN."/4X,"Otherwise, enter any",
     +  "thing to break also at end of each array row."/)')
      IF(LWRP==0) WRITE(6,'(4X,"If line wrap is needed only where len",
     +  "gth limit requires, enter something."/4X,"Otherwise, hit RET",
     +  "URN to break also at end of each array row."/)')
      CALL SCAN(J,1,'B'); IF(J==0) GOTO 60
      LWRP = 1-LWRP; GOTO 50
60    OPEN(7,F1)
      WRITE(7,'(I4,"  Maximum line length")') LLEN
      WRITE(7,'(I4,"  Number of decimals to record")') ND
      WRITE(7,'(I4,"  Lower triangle? (1=yes, 0=no)")') LT
      WRITE(7,'(I4,"  Line break ending each matrix row? (1=no, ",
     +  "0=yes)")') LWRP
      CLOSE(7)

      WRITE(6,'(3X,"These format parameters are now saved in ASCII f",
     +  "ile KOVFMT.  You can"/3X,"copy this to other subdirectorie",
     +  "s if wanted there for Gendata work,"/3X,"and can change its",
     +  " entries by direct ASCII editing.  So you may never"/3X,"ne",
     +  "ed to run COVFORM again."/)')
      STOP
      END

      FUNCTION JF(N)
C Return character expression of integer N left-justified in field CF; then
C CF(:JF(N)) writes N with exactly the right length in format specifier A.
C *** Haven't found any way to avoid requiring N to be INTEGER(4).
      CHARACTER(12) CF
      INTEGER(4) K
      COMMON /CF/ CF
      K = ABS(N)
      CF = '            '
      J = 13
10    J = J-1
      CF(J:J) = CHAR(48+MOD(K,10))
      K = K/10
      IF(K>0) GOTO 10
      IF(N<0) CF(J-1:J-1) = '-'
      CF = ADJUSTL(CF)
      JF = LEN_TRIM(CF)
      END FUNCTION

      FUNCTION LAST(WORD)
C This left-justifies leading substring WORD(:M) of WORD, and returns its
C length as L. If the string is empty, LAST is returned as 0.
      CHARACTER WORD*(*)
      WORD = ADJUSTL(WORD)
      LAST = LEN_TRIM(WORD)
      END
C
      SUBROUTINE SCAN(NL,NS,SEQ)
C This reads the keyboard string, cleans it for list-directed reading of
C the numbers therein, and checks whether it contains NS integers/reals in
C the sequence of Is and Rs received in SEQ if NS>0, or, if NS<1, whether
C all its numbers are of the first I/R kind listed in SEQ. (Integers are
C accepted also as reals.  Termination of an input line by "*" allows up to
C two continuation lines.) NL returns 0 if the input string is blank, -1 if
C this contains only non-numeric characters, -2 if the cleaned number
C string returned in File 2 is non-null but does not match SEQ, and
C gives the total count of numbers in the returned string otherwise.
C *** If SEQ is "B", NL returns 0 if the input line is blank, and
C     returns -1 otherwise.
C
      CHARACTER  AA, SEQ*(*), WA*240, WB*240
      NL = 0
5     NLL = NL + 80
      READ(5,'(A80)') WA(NL+1:NLL)
      IP = NL
      NL = NLL+1
10    NL = NL-1
      IF(NL==0) RETURN
      IF(WA(NL:NL)==' ') GOTO 10
      IF(WA(NL:NL)=='*' .AND. NL>IP) GOTO 5
      IF(SEQ(1:1)=='B') NL = -1
      IF(SEQ(1:1)=='B') RETURN
      IP = 0
      WB(NL+1:NL+1) = ' '
      DO 20 I = 1,NL
       WB(I:I) = ' '
       IF(WA(I:I)<CHAR(48) .OR. WA(I:I)>CHAR(57)) GOTO 20
       WB(I:I) = WA(I:I)
       WA(I:I) = '0'
20     CONTINUE
      IP = 0
      IF(WA(:3)=='-.0') WB(:1) = '-'
      IF(WA(:2)=='-0') WB(:1) = '-'
      IF(WA(:3)=='-.0') WB(:1) = '-'
      IF(WA(:2)=='.0') WB(:1) = '.'
      IF(WA(:2)=='.0') IP = 1
      DO I = 2,NL
        IF(WA(I:I)=='-') THEN
          IF(WB(I-1:I-1)==' ' .AND. (WA(I+1:I+1)=='.'.OR.WA(I+1:I+1)
     +      =='0')) WB(I:I) = '-'
          IP = 0
        ELSE IF (WA(I:I)=='.') THEN
          IF((WA(I-1:I-1)=='0'.OR.WA(I+1:I+1)=='0') .AND. IP==0)
     +      WB(I:I) = '.'
          IF(WB(I:I) == '.') IP = 1
        ELSE IF (WA(I:I) /= '0') THEN
          IP = 0
        END IF
      END DO
C Identify Integer/Real sequence in WB and put in start of WA
      AA = 'I'
      IF(WB(1:1)=='.') AA = 'R'
      NN = 0
      DO I = 2,NL+1
        IF(WB(I:I)==' ' .AND. WB(I-1:I-1)/=' ') THEN
          NN = NN + 1
          WA(NN:NN) = AA
          AA = 'I'
        ELSE IF (WB(I:I)=='.') THEN
          AA = 'R'
        END IF
      END DO
      IF(NN==0) NL = -1
      IF(NN==0) RETURN
      AA = '+'
      IF(NS<=0 .AND. SEQ(1:1)=='R') GOTO 60
      IF(NS<=0) GOTO 50
      IF(NN<NS) GOTO 57
      DO I = 1,NS
        IF(SEQ(I:I)=='I' .AND. WA(I:I)/='I') AA = '0'
      END DO
      GOTO 55
50    DO I = 1,NN
        IF(WA(I:I)/=SEQ(1:1)) AA = '0'
      END DO
55    IF(AA=='+') GOTO 60
57    NL = -2
      IF(NL<=-2) WRITE(6,'(/" Your input does not contain the ",
     +  "number sequence requested. Try again.")')
      RETURN
60    REWIND 2
      WRITE(2,'(A240)') WB(1:NL)
      NL = NN
      REWIND 2
      RETURN
      END

      SUBROUTINE WAIT(N)
C  N > 0 calls for space before screen display
      DO I = 1,N; WRITE(6,'()'); END DO
      WRITE(6,'(" Hit RETURN to continue")')
      READ(5,'()')
      RETURN
      END

