C             Program MORSCOR   (Source code, Fortran-90.)

C                    Last revised:  10 September 2003

C This routine inputs a rawdata population created by GENSCOR and processes
C this further in various available ways.  The input file is presumed to be
C a binary output from GENSCOR whose name's extension is POP.

      LOGICAL QD, QE, QF, QG, QR, QY   ! Create groups?
      CHARACTER*12 CF, F1, F2, F3, FA, FB, FT, WORD*130, CLN*8
      CHARACTER FMT*40, FMA*40, CH1, CH2*2, CH3*3, CH4*4  ! , CG, PL*2
      REAL TP(2,4)
      CHARACTER,ALLOCATABLE:: NAME(:)*12,IDENT(:)*8,CWRD(:),WRD(:)*170
      INTEGER,ALLOCATABLE :: LST(:), MX(:)
      REAL,ALLOCATABLE :: CFF(:), CM(:), CV(:), GE(:,:), GF(:,:),
     +         GY(:,:), Q(:,:), SS(:,:,:), TWIST(:,:), W(:,:), X(:)
C       TP(<f,u>, ) contains TWIST parameters RAi,RBi,Pi,Qsmooth for skewing score dists
C       TWIST(j, ) contains the generated individual-factor twist parameters
C         in cols 1-3, and their skew/kurtosis in cols 4/5
      COMMON /CF/ CF
      LO(I,J) = J*(J-1)/2 + I
      LOC(I,J) = LO(MIN(I,J),MAX(I,J))
      DATA QD,QE,QF,QR,QY/5*.FALSE./  ! , DEV/99./
      OPEN(2,STATUS='SCRATCH')
      CALL SYSTEM('cls')

CC TEST LINES
C      OPEN(21,FILE='JUNK')

CC  MORSCOR uploads a standardized simulation scorefile written by GENSCOR and
CC  utilizes this in your pick from a list of alternative operations that is
CC  sporadically updated in accord with user desires.  The current options:

CC  1. Write retrieved information about the production structure of these
CC       scores to an ASCII SEE-file, followed at your option by transcription
CC       of the scores themselves into Hydata-standard ASCII format.
CC  2. Write the input data to an ASCII file in Hydata-standard format while
CC       partitioning these records among NG groups by giving them ID numbers
CC       whose leading digits create group assignments.  Specifically, each
CC       record's ID will equal g10^r + k, where g ranges over the integers
cc       1 to NG (or is zero if NG = 1), r is the smallest integer exponent
cc       such that the rth power of 10 exceeds NS (number of subjects), and
cc       k ranges over original list positions 1 to NS.
CC  3. Same as Option 2 except that each group's data are written to a
CC       different ASCII datafile. [formerly continued as below]

CC  4. Expansion of Option 2 or 3 to multiple-group simulation by decentering
CC       E (the data residuals) and/or F (the common factors) according to your
CC       free choice of means on these variables separately for each group.
CC       A schema for these means, ready to upload under a basename of form
CC       AV<nn> (whose digits <nn> identify the schema's dimensions) must
CC       already have been created by a run of SCHEMAS.

ccCC     different ASCII datafile.  IDs assigned in these are the same as
ccCC     under Option 2, so subsequent differential transformation of these
ccCC     group files can later be merged without loss of records.

      WRITE(6,'(/"  MORSCOR uploads a standardized simulation datafil",
     +  "e written by GENSCOR and"/"  utilizes this in your pick from",
     +  " a list of alternative operations that is"/"  sporadically u",
     +  "pdated in accord with user desires.  The current options:"/)')
      WRITE(6,'("  1. Write retrieved information about the productio",
     +  "n structure of these"/7X,"scores to an ASCII SEE-file, follo",
     +  "wed at your option by transcription"/7X,"of the scores thems",
     +  "elves into Hydata-standard ASCII format."/)')
      WRITE(6,'("  2. Write the input data to an ASCII file in Hydata",
     +  "-standard format while"/7X,"partitioning these records among",
     +  " NG groups by giving them ID numbers"/7X,"whose leading digi",
     +  "ts create group assignments.  Specifically, each"/7X,"recor",
     +  "d''s ID will equal g10^r + k, where g ranges over the inte",
     +  "gers"/7X,"1 to NG (or is zero if NG = 1), r is the smallest",
     +  " integer exponent"/7X,"such that the rth power of 10 exceed",
     +  "s NS (number of subjects), and"/7X,"k ranges over original ",
     +  "list positions 1 to NS.")')
      WRITE(6,'("  3. Same as Option 2 except that each group''s data",
     +  " are written to a"/7X,"different ASCII datafile."/)')

cc     +  IDs assign","ed in these are the same as"/5X,"under Option 1, so subseq",
cc     +  "uent differential transformation of these"/5X,"group files ",
cc     +  "can later be merged without loss of records.")')
cc      CALL WAIT(1)

      WRITE(6,'("  4. Expansion of Option 2 or 3 to multiple-group si",
     +  "mulation by decentering"/7X,"E (the data residuals) and/or F",
     +  " (the common factors) according to your"/7X,"free choice of ",
     +  "means on these variables separately for each group."/7X,"A s",
     +  "chema for these means, ready to upload under a basename of ",
     +  "form"/7X,"AV<nn> (whose digits <nn>) identify the schema''s ",
     +  "dimensions) must"/7X,"already have been created by a run of",
     +  " SCHEMAS.")')
      CALL WAIT(0)
      ALLOCATE( NAME(40) )
      WRITE(6,'("  The GENSCOR-created databases available here are")')
      CALL LOOK(1,'*.POP',NAME,40,NN); LL = NN
      IF(NN==0) WRITE(6,'(/ " No identifiable GENSCOR-produced data",
     +  "files here. Go generate one.")'); IF(NN==0) STOP
12    F3 = NAME(LL); CALL CAP(F3,12); LF3 = LAST(F3)  !  QD = .FALSE. set in DATA

C   Write-code in GENSCOR:
C      WRITE(7) NV, NF, NC, MTW, NS, ORT, KOP, LB
C      WRITE(7) (CM(I),I=1,NV), (CWRD(I),I=1,NC)
C      IF(MTW>0) WRITE(7) ((TP(I,J),I=1,2),J=1,4),
C     +           ((TWIST(I,J),I=1,NVF),J=1,7)
C      WRITE(7) ((P(I,J),I=1,NV),J=1,NF)  ! W is the refined simple-structure pattern
C      WRITE(7) (CV(I),I=1,NVV), (CFF(I),I=1,NFF)
CC       CV holds data covars; CFF, SS-factor covars.
C      IF(KOP==3) THEN
C        READ(9) ((P(I,J),I=1,NF),J=1,NF)  ! Retrieve refined path matrix
C        WRITE(7) ((P(I,J),I=1,NF),J=1,NF)
C        WRITE(7) LA, (WRD(K)(:LA),K=1,LB)
C      END IF

      OPEN(7,FILE=F3,FORM='UNFORMATTED')   ! TWISTed iff MTW=1; ORTHed iff KORT=1
      READ(7) NV, NF, NC, MTW, NS, KORT, KOP, LB
      NVV = LO(NV,NV); NFF = LO(NF,NF); NVF = NV+NF
      WORD(:13) = 'Normaltwisted' !  1:6, 7:13 => 1+6*MTW: 6+7*MTW
15    WRITE(6,'(/" The dataset now chosen is No. ",A," (",A,"), which",
     +  " holds ",A," records"/" with ",A," data variables, ",A," fac",
     +  "tors, and ",A," distribution shapes.")') CF(:JF(LL)),F3(:LF3),
     +  CF(:JF(NS)),CF(:JF(NV)),CF(:JF(NF)), WORD(1+6*MTW:6+7*MTW)
      IF(NN>1) WRITE(6,'(" Hit RETURN if OK, or enter the index of ",
     +  "another selection from this list."/)')
      IF(NN==1) WRITE(6,'(" Hit RETURN if OK, or enter anything to ",
     +  "quit."/)')
      CALL SCANR(J,1,'I',NUL); IF(J/=0.AND.NN==1) STOP; IF(J<0) GOTO 15
      IF(J>0) THEN; IF(NN==1) STOP
        READ(2,*) LL; LL = MAX(1,MIN(LL,NN)); GOTO 12
      END IF
      ALLOCATE( CM(NV), CV(NVV), CFF(NFF), CWRD(NC), IDENT(NVF), X(NVF),
     +           W(NV,NF) )
      READ(7) (CM(I),I=1,NV), (CWRD(I),I=1,NC)  ! CWRD is names in single string
      IF(MTW>0) THEN; ALLOCATE( TWIST(MTW*NVF,7) )
        READ(7) ((TP(I,J),I=1,2),J=1,4), ((TWIST(I,J),I=1,NVF),J=1,7)
      END IF
      DO I = 1,NVF ! Default item/factor names.  Should usually be overwritten
        IF(I<=NV) IDENT(I) = 'y'//CF(:JF(I))  !  by namelist in CWRD
        IF(I>NV.AND.I<NV+27) IDENT(I) = CHAR(64+I-NV) !
        IF(I>NV+26) IDENT(I) = 'f'//CF(:JF(I-NV-26))  ! This needs update????
      END DO
      F1 = F3(:LF3-4)          ! F1,F3 both hold input basename
      WRITE(6,'(4X,"Pick a basename for this transcription of ",A,
     +  " that you expect"/4X,"to recur as stem in the names of othe",
     +  "r files derived from this base."/4X,"To leave branch room, ",
     +  "it should be no longer than six characters.")') F3(:LF3)
20    LF = MIN(6,LAST(F1))
      WRITE(6,'(/" If you want this stem datafile to have basename ",
     +  A,", hit RETURN."/" Otherwise, enter another choice starting",
     +  " with a letter."/)') F1(:LF)
      READ(5,'(A)') WORD(:12)
      IF(WORD(:1)/=' ') THEN
        N = LAST(WORD); CALL CAP(WORD,N); L=ICHAR(WORD(:1))
        IF(L>64 .AND. L<91) F1 = WORD(:N)
        GOTO 20
      END IF
      LDOT = LF+1; F1(LDOT:LDOT) = '.'
      CALL NAME1(F1,F2,6,LF2,KST) ! KST is the integer just preceding start of
      LF1 = LAST(F1)              ! the present D-series (needed only if QG=t)
      IF(F1(LF1-2:LF1)/='.D1') THEN  ! LF2 is length of <base>.LOG
        WRITE(6,'(5X,"Other Hydata-standard datafiles with this base",
     +    "name already exist in this"/5X,"subdirectory, which may w",
     +    "ell prove confusing.  To choose another basename,"/5X,"hi",
     +    "t RETURN. Otherwise, enter anything to continue with ",A)')
     +    F2(:LDOT)
        READ(5,'(A)') CH1; IF(CH1==' ') GOTO 20
      END IF

C First, transcription of structure info       !  F1 is <baseout.Di>
      INQUIRE(FILE=F3(:LF3-3)//'LOG',EXIST=QG) !  F2 is <baseout.LOG>
      DO I = 1,NV+NF; J=0
23      J=J+1; K=K+1; CH1 = CWRD(K); IF(CH1=='.') CYCLE
        IDENT(I)(J:J) = CH1; GOTO 23
      END DO
      READ(7) ((W(I,J),I=1,NV),J=1,NF)
C       W gets the refined simple-structure pattern; CM the communalities.
      READ(7) (CV(I),I=1,NVV), (CFF(I),I=1,NFF)
      IF(KOP==3) THEN    ! Get path matrix GE substituted for P, but not used??
        ALLOCATE( WRD(LB) )
        READ(7) LA, (WRD(K)(:LA),K=1,LB)
      END IF
      READ(7,END=25) X(1); BACKSPACE 7; QD = .TRUE.; GOTO 27
C                ^ Test if next line exists
25    WORD = 'quit.'; IF(NN>1) WORD = 'check out another POP-file.'
      WRITE(6,'(" This is a pseudo-datafile, containing production in",
     +  "formation on a score"/" population that was generated but no",
     +  "t archived.  Hit RETURN to retrieve"/" this information, or ",
     +  "enter anything to ",A)') WORD(:LAST(WORD))
      CALL SCN(J); IF(J==0) GOTO 30
      IF(NN>1) GOTO 15; IF(NN==1) STOP
27    WORD = F3(:LF3-3)//'LOG'; QG = .NOT.QG ! Last tmp use of QG
      IF(QG) WRITE(6,'(" To reproduce details of these scores'' orig",
     +  "in, hit RETURN. (This information"/" is largely redundant ",
     +  "with file ",A," which, however, seems to have"/" vanished.)",
     +  "  Otherwise, enter anything to proceed with score transcrip",
     +  "tion.")') WORD(:LF3)
      IF(.NOT.QG) WRITE(6,'(" To reproduce details of these scores''",
     +  " original production, enter anything."/" (These will be lar",
     +  "gely redundant with file ",A," still available here)."/" Ot",
     +  "herwise, hit RETURN to get on with score transcription.")')
     +  WORD(:LF3)
      CALL SCN(J); IF(QG.AND.J/=0. .OR. .NOT.QG.AND.J==0) GOTO 33

C>>> Write to SEE-file
C Binary file xxxxxxxxx contains simulated scores for xxxx subjects on xx data
C variables Y having xx common factors F in accord with SE model Y = WF + E with
C Cfe = 0 and Cee diagonal.  (Because exact orthogonalization of the unique factors
C was waived, Cov(F,E) and Cov(E,E) in this finite sample differ from the model
C ideal Cfe and Cee, respectively, by sampling error.)
C was enforced, Cov(F,E) and Cov(E,E) in this finite sample exactly realize
C the model's ideal Cfe and Cee, respectively.)

30    OPEN(8,FILE=F2(:LF2-3)//'SEE'); QR = .TRUE. ! Retain extention LOG?? NO.
      WRITE(8,'(" Binary file ",A," contains simulated scores for ",A,
     +  " subjects on ",A," data"/" variables Y having ",A," common ",
     +  "factors F in accord with SE model Y = WF + E with"/" Cfe =",
     +  " 0 and Cee diagonal.  (Because exact orthogonalization of t",
     +  "he unique factors")') F3(:LF3), CF(:JF(NS)), CF(:JF(NV)),
     +  CF(:JF(NF))             ! QR=t flags writing a SEE-file
      IF(KORT>0) WRITE(8,'(" was enforced, Cov(F,E) and Cov(E,E) in t",
     +  "his finite sample exactly realize the"/" model''s ideal Cfe ",
     +  "and Cee, respectively.)  Neither Cov(F,E) or Cov(E,E) is sho",
     +  "wn")')
      IF(KORT<1) WRITE(8,'(" was waived, Cov(F,E) and Cov(E,E) in thi",
     +  "s finite sample differ from the model''s"/" ideal Cfe and Ce",
     +  "e, respectively, by sampling error.)  Neither Cov(F,E) or Co",
     +  "v(E,E) is shown")')
      WRITE(8,'(" below, nor are the E-scores explicit in ",A," or ",
     +  "its ASCII transcription."/" Should you want these they can",
     +  " be computed from the information given, starting"/" with ",
     +  "E = Y - WF.")') F3(:LF3)
      WRITE(8,'(/" The data covariances Cov(Y,Y) produced by this ",
     +  "simulation:")')
      DO J = 1,NV
        WORD(:5) = '  y'//CF(:JF(J))
        IF(J<101) WORD(:5) = '   y'//CF(:JF(J))
        IF(J>99) WORD(:5) = ' y'//CF(:JF(J))
        WRITE(8,'(A5,":",4(5A6,2X),20(:/14X,4(5A6,2X)))') WORD(:5),
     +    (CLN(CV(LO(I,J)),6,3),I=1,J)
        IF(J<NV.AND.MOD(J,5)==0) WRITE(8,'()')
      END DO
      WRITE(8,'(//" The common-factor pattern W in these simulated ",
     +  "data (communalities in parentheses):"/)')

C         A     B     C     D     E       F     G     H     I     J       K     L     M     N     O
C      Ŀ Ŀ Ŀ
C        PQRSTĿ UVWXYĿ uĿ

      WRITE(8,'(13X,3(2X,5(A,5X)))') (CHAR(64+I),I=1,MIN(15,NF))
      WRITE(8,'(11X,3( (" ",A,4(:"",A),"Ŀ") ))')
     +  ('',J=1,MIN(15,NF))
      IF(NF>15) WRITE(8,'(6(13X,3((" ",A,4(:"",A),"Ŀ"))))')
     +  (CHAR( 64+I+38*MIN(1,I/27) ),I=16,NF)
      DO I = 1,NV
        WRITE(8,'(I3,". (",A4,") ",3(5A6,2X), 90(:/14X,3(5A6,2X)) )')
     +    I, CLN(CM(I),4,3), (CLN(W(I,J),6,3),J=1,NF)       !  64-26 = 38
        IF(MOD(I,10)<1.AND.I<NV) WRITE(8,'()')
      END DO
      MAXN = 0; DO I = 1,NV; MAXN = MAX(MAXN,LAST(IDENT(I))); END DO
      WRITE(8,'(/" Names assigned to the data variables, profiling wh",
     +  "ich factors are most salient for them:")')
      WRITE(8,'(20(2(2X,5(I4,":",A)),:/))') (I,IDENT(I)(:MAXN),I=1,NV)
CC      WRITE(8,'(20(2(2X,5(I4,":",A)),:/))') (I,IDENT(I)(:1+LAST(IDENT(
CC     +  I))),I=1,NV)
      WRITE(8,'(/" Correlations Cff imposed on the common factors in",
     +  " this simulation:")')
      DO J = 1,NF
        WORD(:5) = '  f'//CF(:JF(J))
        IF(J<101) WORD(:5) = '   f'//CF(:JF(J))
        IF(J>99) WORD(:5) = ' f'//CF(:JF(J))
        WRITE(8,'(A5,":",4(5A6,2X),20(:/14X,4(5A6,2X)))') WORD(:5),
     +    (CLN(CFF(LO(I,J)),6,3),I=1,J)
        IF(J<NV.AND.MOD(J,5)==0) WRITE(8,'()')
      END DO
      IF(KOP==3) THEN
        WRITE(8,'(/" The causal-path structure (A-matrix) in this ",
     +    "Cff''s production is:")')
        DO K = 1,LB; WRITE(8,'(A)') WRD(K)(:LA); END DO
CC        DEALLOCATE( WRD )   ! No real point
      END IF
      WRITE(8,'(//" DISTRIBUTION SHAPES:")')
      IF(MTW/=1) WRITE(8,'(4X,"All raw factor scores were produced ",
     +  "by a Normal random generator whose"/4X,"linear combinations",
     +  " to achieve stipulated correlations and marginal norms"/4X,
     +  "preserve Normality of distribution apart from size-",A,
     +  " sampling noise.)")') CF(:JF(NS))
      IF(MTW/=1) GOTO 33
      WRITE(8,'(4X,"The raw factor scores, emitted by a Normal rand",
     +  "om generator, were distorted"/4X,"from Normality by the ",
     +  "TWIST parameters recorded here.")')
      WRITE(8,'(6X,"Twisting by parameters",4X,"RA",5X,"RB",4X,
     +  "P  smooth"/13X,"Common factors:",2A7,A5,3X,L1/13X,"Unique f",
     +  "actors:",2A7,A5,3X,L1)') ( CLN(TP(J,1),7,2), CLN(TP(J,2),7,2),
     +  CLN(TP(J,3),5,2), (TP(J,4)>.5), J=1,2)
      M1 = NINT(100*TP(1,1)); M2 = NINT(100*TP(1,2))
      N1 = NINT(100*TP(2,1)); N2 = NINT(100*TP(2,2))
      JL = MIN(M1,M2); JH = MAX(M1,M2); KL = MIN(N1,N2); KH = MAX(N1,N2)
      WRITE(8,'(" gave the score population the following higher",
     +    " factor moments (Normal: Skew = 0, Kurtosis = 3.0)")')
      WRITE(8,'(/" Common-factor skew: "/20(5(2X,5(1X,A4)):/))')
     +    (CLN(TWIST(I,4),4,2),I=1,NF)
      WRITE(8,'(" Common-factor kurtosis:"/20(5(2X,5(1X,A4)):/))')
     +    (CLN(TWIST(I,5),4,2),I=1,NF)
      WRITE(8,'(/" Unique-factor skew:"/20(5(2X,5(1X,A4)):/))')
     +    (CLN(TWIST(I,4),4,2),I=NF+1,NVF)
      WRITE(8,'(" Unique-factor kurtosis:"/20(5(2X,5(1X,A4)):/))')
     +    (CLN(TWIST(I,5),4,2),I=NF+1,NVF)
      WORD = ' after'; IF(KORT<1) WORD(:6) = '.     '
      WRITE(8,'(//" These higher moments derive from those of the in",
     +  "itial random-score axes that are"/" variously composited (m",
     +  "odestly if at all for the unique factors; rather more"/" so",
     +  " for the common ones) to satisfy the model''s imposed covar",
     +  "iances.  Here are")')
      WRITE(8,'(" each raw axis''s Leftside^Rightside powering expon",
     + "ents, derived from the Twist"/" parameters reported above, ",
     + "that shaped their departures from Normality.  The")')
      WRITE(8,'(" finished common factors are rotations of the leadi",
     +  "ng ",A," raw axes; each finished"/" unique factor U<i> (i =",
     +  " 1,..,",A,") is just the ",A,"+i''th raw axis rescaled",A)')
     +  CF(:JF(NF)), CF(:JF(NV)), CF(:JF(NF)), WORD(:6)
      IF(KORT==1) WRITE(8,'(" partialling out the ",A,"+i preced",
     +  "ing ones.")') CF(:JF(NF-1))
      WRITE(8,'(/" L^R exponents that twisted these Common-factor ",
     +  "precursor moments:")')
      IF(JL==JH) THEN
        WORD = ' (Normal, no twist)'
        IF(JL/=100) WORD = ' (twisted symmetric)'
        WRITE(8,'(3X,"All are ",A3,"^",A3,A,)') (CLN(.01*JL,3,2),
     +    I=1,2),WORD(:20)
      ELSE IF(JL>0) THEN
        WRITE(8,'(3X,"All are ",A3,"^",A3," or ",A3,"^",A3)') CLN(.01
     +    *JL,3,2), CLN(.01*JH,3,2), CLN(.01*JH,3,2), CLN(.01*JL,3,2)
      ELSE
        WRITE(8,'(12(:/3(2X,5(1X,A3,"^",A3))) )') (CLN(TWIST(I,1),3,2),
     +   CLN(TWIST(I,2),3,2),I=1,NF)
      END IF
      WRITE(8,'(/" L^R exponents that twisted these Unique-factor ",
     +  "precursor moments:")')
      IF(KL==KH) THEN
        WORD = ' (Normal, no twist)'
        IF(KL/=100) WORD = ' (twisted symmetric)'
        WRITE(8,'(3X,"All are ",A3,"^",A3,A,)') (CLN(.01*KL,3,2),
     +    I=1,2),WORD(:20)
      ELSE IF(KL>0) THEN
        WRITE(8,'(3X,"All are ",A3,"^",A3," or ",A3,"^",A3)') CLN(.01
     +    *KL,3,2), CLN(.01*KH,3,2), CLN(.01*KH,3,2), CLN(.01*KL,3,2)
      ELSE
        WRITE(8,'(12(:/3(2X,5(1X,A3,"^",A3))) )') (CLN(TWIST(I,1),3,2),
     +   CLN(TWIST(I,2),3,2),I=NF+1,NVF)
      END IF
      WRITE(8,'(/" Skew of the common-factor precursors:"/20(5(2X,
     +  5(1X,A4)):/))')  (CLN(TWIST(I,6),4,2),I=1,NF)
      WRITE(8,'(" Kurtosis of the common-factor precursors:"/
     +  20(5(2X,5(1X,A4)):/))') (CLN(TWIST(I,7),4,2),I=1,NF)
      WRITE(8,'(/"  Skew of the unique-factor precursors:"/
     +  20(5(2X,5(1X,A4)):/))') (CLN(TWIST(I,6),4,2),I=NF+1,NVF)
      WRITE(8,'(" Kurtosis of the unique-factor precursors:"/
     +  20(5(2X,5(1X,A4)):/))') (CLN(TWIST(I,7),4,2),I=NF+1,NVF)
      CLOSE(8)

CC      WRITE(8,'(" HYDATA-standard datafile ",A,": ",A," variables, ",
CC     +  A," records; largest ID, ",A,"; transcribed under DEV =",F5.1/
CC     +  8X,"from rawdata source ",A,"; datafix ",A,"; ",A," missing ",
CC     +  "scores; ",A," complete records.")') WORD(:12), CF(:JF(NY)),
CC     +  CF(:JF(NS)), CF(:JF(NS)), 10., F3(:(13:24), CF(:JF(NFIX)),
CC     +  CF(:JF(MIS)), CF(:JF(KMPR))
CC
CCC HYDATA-standard datafile xxxxxxxxxxxx: xxx variables, xxxx records; largest ID No.xxxxxxxxxx; transcribed under DEV = xxxx
CCC        from rawdata source xxxxxxxxxxxx; datafix xx; xxxxxxx missing scores.
CCC *** Any change in this WRITE Line 1 must be mirrored by HYDATA READ formats.
CCC *** 1st name, F2, must receive a 12-space field. 2nd name is F1
CC
CC      N = 150/(LM+1)
CC      FM1 = '(90('//CF(:JF(N))//'(1X,A),:/))'//CLEAR
CC      WRITE(8,FM1) (IDENT(ORD(I))(:LM),I=1,NY)
CC      IF(NSX>0) WRITE(8,'("Rescale",8(2X,5I3),20(/8X,8(2X,5I3)))')
CC     +   (KX(I),I=1,NY)

33    IF(.NOT.QD.AND.QR) THEN ! QD=f flags pseudo-datafile.  QD is now free for other uses
        WRITE(6,'(" Done. The production report is in ",A,".")')
     +    F2(:LF2-3)//'SEE'; STOP
      END IF

      QG = .FALSE.; NG = 1  ! Number of score groups
35    IF(.NOT.QG) WRITE(6,'(//3X,"Major Options:  If you want these",
     +  " records to be partitioned (equally)"/3X,"among NG > 1 gro",
     +  "ups, enter your choice of NG.  Otherwise, hit RETURN to"/3X,
     +  "transcribe this datafile into ASCII, or waive that by ent",
     +  "ering a letter."/)')
      IF(QG.AND.NG>1) WRITE(6,'(3X,"Hit RETURN to partition among ",A,
     +  " groups, or enter another choice of NG."/)') CF(:JF(NG))
      IF(QG.AND.NG==1) THEN; WRITE(6,'(3X,"Hit RETURN to waive partit",
     +  "ioning, or enter a choice of NG > 1."/)'); QG = .FALSE.; END IF
      CALL SCANR(J,1,'I',NUL); IF(NG>1.AND.J==0) GOTO 37
      IF(.NOT.QG.AND.J<0) THEN ! Exit without data transcription; no 2nd chance
        IF(QR) WRITE(6,'(" Details on this simulation''s production a",
     +    "re reported in textfile ",A,".")') F2(:LF2-3)//'SEE'
        IF(.NOT.QR) WRITE(6,'(" No product this time, but come again",
     +    " when you''re ready.")'); STOP
      END IF
      IF(J>0) THEN
        READ(2,*) NG; NG=MAX(1,MIN(99,NG)); QG = .TRUE.; GOTO 35
      END IF
C Hitting RETURN when QG=F or NG=1 comes immediately down to here
      WRITE(6,'(4X,"Enter anything to confirm that you want just the",
     +  " ASCII transcription"/4X,"of this datafile.  Otherwise, hit",
     +  " RETURN to reconsider your options.")')
      CALL SCN(J); IF(J==0) GOTO 35; GOTO 60

C ##### After Label 99 (next use of QG), QG=T flags multiple files
C Need to distinguish:
C  (a) 1 file, no groups;              QG=F, NG=1, QY=F; QR=F
C  (b) 1 file, NG groups, no means;    QG=F, NG>1, QY=F; QR either way
C  (c) 1 file, NC groups with means;   QG=F, NG>1, QY=T; QR either way
C  (d) NC files, no means              QG=T, NG>1, QY=F; QR either way
C  (e) NC files with group means       QG=T, NG>1, QY=T; QR either way


C You can select xx equal groups from this received population of xxxx score
C records in either of two ways:
C 1) Let each group comprise xxxx consecutive records from xxxxxxxxxx.
C      Choose this if you want to retain the same record groups over
C      altered settings of the within-group means.
C 2) Let the groups be size-xxxx disjoint random selections from this
C      population.  Choose this for studying how results under a fixed
C      setting of group effects are disturbed by sampling noise.

37    KG = NS/NG; KK = KG; NG1 = NG+1  ! KK will be buffer for revised KG
38    QR = .FALSE.  ! QR=T flags randomization
      CALL SYSTEM('CLS'); WRITE(6,'(//25X,"GROUPS SELECTION")')
      WRITE(6,'(/" You can select ",A," equal groups of stipulated si",
     +  "ze GS  ",A," from this received"/" population of ",A," scor",
     +  "e records in either of two ways:"//" 1) Let each group comp",
     +  "rise GS consecutive records from ",A,"."/6X,"Choose this if",
     +  " you want to retain the same record groups over altered"/6X,
     +  "settings of the within-group means."//" 2) Let the groups be",
     +  " size-GS disjoint random selections from this"/6X,"populati",
     +  "on.  Choose this for studying how results under a fixed"/6X,
     +  "setting of group effects are disturbed by sampling noise."/)')
     +  CF(:JF(NG)), CF(:JF(KG)), CF(:JF(NS)), F3(:LF3)

c You can select xx equal groups of stipulated size GS  xxx from this received
c population of xxxx score records in either of two ways:
c 1) Let each group comprise GX consecutive records from AAAAAA.  Choose
c      this if you want to retain the same record groups over altered
c      settings of the withihn-group means.
c 2) Let the groups be size-GX disjoint random selections from this
c      population.  Choose this for studying how results under a fixed
c      setting of group effects are disturbed by sampling noise.

39    WORD = 'smaller than'; IF(KK<KG) WORD = 'different from'
      WRITE(6,'(3X,"To partition this datafile into ",A," groups of ",
     +  "GS = ",A," consecutive"/3X,"records (Option 1), hit RETURN.",
     +  "  Otherwise, randomly assign ",A," records"/3X,"to each of ",
     +  A," disjoint groups (Option 2) by entering a letter.  If you"/
     +  3X,"prefer groups of size ",A,1X,A,", enter the numeric GS ",
     +  "wanted."/)') CF(:JF(NG)), CF(:JF(KK)), CF(:JF(KK)),
     +  CF(:JF(NG)), WORD(:LAST(WORD)), CF(:JF(KK))
      CALL SCANR(JJ,1,'I',NUL)  ! QR=T says to randomize
cc         If JJ=0: leave QR=F and current KK, goto confirm
cc         If JJ<0: set QR=T, leave current KK, goto confirm
cc         If JJ>0: set QR=T, read KK from input, goto confirm
      IF(JJ/=0) QR = .TRUE.
      IF(JJ>0) THEN
        READ(2,*) KK; KK = MAX(2,MIN(KK,KG)); GOTO 39
      END IF
      WORD = ' sub'; L = 1; IF(KK<KG) L = 4
      IF(JJ==0) WRITE(6,'("  To confirm wanting sequentially selecte",
     +  "d groups of maximal size ",A,",")') CF(:JF(KG))
      IF(JJ/=0) WRITE(6,'("  To confirm wanting randomly selected gr",
     +  "oups of",A,"maximal size ",A,",")') WORD(:L), CF(:JF(KK))
      WRITE(6,'("  enter anything.  Otherwise, hit RETURN to modify",
     +  " this choice.")')
      CALL SCN(J); IF(J==0) GOTO 38; KG = KK
40    WRITE(6,'(" To consider imposing mean differences among these ",
     +  A," groups, hit RETURN."/" Otherwise, enter anything to waiv",
     +  "e this option.")') CF(:JF(NG)); QD = .TRUE.; CALL SCN(J)
      IF(J/=0) THEN                    !  ^ No longer needed ??
        WRITE(6,'(4X,"Enter anything to confirm that you want means",
     +    " in these groups to differ"/4X,"only by sampling error. ",
     +    " Otherwise, hit RETURN to choose again.")')
        CALL SCN(J); IF(J==0) GOTO 40
        QD = .FALSE.; GOTO 60
      END IF    ! QD=F waives creating Y-mean diffs -- no longer needed ??

C Start of group-means assignments
      FA = 'AV'//CF(:JF(NV))//CF(:JF(NG))//'.*'; KA = -1   ! Suppress LOOK
      FB = 'AV'//CF(:JF(NF))//CF(:JF(NG))//'.*'; KB = -1   !    display
      IF(NG>NF) FB(3:) = '0'//FB(3:)
      CALL LOOK(1,FA,NAME,20,KA); CALL LOOK(1,FB,NAME,20,KB)

c   To differentiate these groups by stipulating means therein, you must
c   have previously used SCHEMAS to prepare at least one xx-by-xx matrix
c   of F-means or xx-by-xx matrix of E-means (AV-schemata).

c     Reminder: Under model Y = WF + E, with residual E conceived as   
c     measurement noise, the data means have composition My = WMf + Me 
c     in all subsets of the posited population.  So model-sanctioned    
c     group differences on Y can arise either through group differences 
c     on Y's common factors F in accord with F's W-patterned wont, or   
c     from noise disturbances  think of them as detection "biases"  
c     that are constant within but not between groups.                  


c   No AV-schemata are currently at hand; so hit RETURN to finish without
c   exercising the group-means option, or abort this run (entering any
c   character will do) to prepare the group-means schemata you need.

c   The AV-schemata at hand provide only group-specific E [F] means.
c   If you don't want to differentiate your groups on E-means as well,
c   hit RETURN to continue.  Otherwise, abort this run (entering any
c   character will do) to finish your group-means preparations.

      CALL SYSTEM('cls'); JA = MIN(1,KA); JB = MIN(1,KB);
      WRITE(6,'(/20X,"CREATING GROUP DIFFERENCES"/)')
      WRITE(6,'(3X,"To differentiate these groups by stipulating mea",
     +  "ns therein, you must"/3X,"have previously used SCHEMAS to ",
     +  "prepare at least one ",A,"-by-",A," matrix"/3X,"of F-means ",
     +  "or ",A,"-by-",A," matrix of E-means (AV-schemata).")')
     +  CF(:JF(NF)), CF(:JF(NG)), CF(:JF(NV)), CF(:JF(NG))
      WRITE(6,'(/3X," Reminder: Under model Y = WF + E, with resid",
     +  "ual E conceived as   "/3X," measurement noise, the data ",
     +  "means have composition My = WMf + Me "/3X," in all subse",
     +  "ts of the posited population.  So model-sanctioned    "/3X,
     +  " group differences on Y can arise either through group dif",
     +  "ferences "/3X," on Y''s common factors F in accord with F",
     +  "''s W-patterned wont, or",3X,""/3X," from noise disturban",
     +  "ces  think of them as detection ""biases""  "/3X," th",
     +  "at are constant within but not between groups.",18X,""/)')
      IF(JA+JB==0) WRITE(6,'(3X,"No AV-schemata are currently at hand",
     +  "; so hit RETURN to finish without"/3X,"exercising the group-",
     +  "means option, or abort this run (entering any"/3X,"character",
     +  " will do) to prepare the group-means schemata you need."/)')
      CH2 = 'EF'; IF(KA==0) CH2 = 'FE'
      IF(JA+JB==1) THEN
        WRITE(6,'(6X,"The AV-schemata at hand provide only group spe",
     +    "cific ",A,"-means."/6X,"If you don''t want to differentia",
     +    "te your groups on ",A,"-means as well,"/6X,"hit RETURN to",
     +    " continue.  Otherwise, abort this run (entering any"/6X,
     +    "character will do) to finish your group-means preparation",
     +    "s.")') CH2(:1), CH2(2:)
        CALL SCN(J); IF(JA+JB==1.AND.J<0) STOP; IF(JA+JB==0) GOTO 60
      END IF
      ALLOCATE( GE(NV,NG+1), GF(NF,NG+1) ); GE = 0.; GF = 0. ! +1 for means over groups
      IF(KB==0) GOTO 50; IF(KA>0) CALL WAIT(0)

C          ͻ
C                ??? Group differences in factor means ???      
C          ͼ

      WRITE(6,'(/10X,"",53(""),"")')
      WRITE(6,'(10X,"",6X,"??? Group differences in factor means ",
     +  "???",6X,""/10X,"",53(""),""/)')
      WRITE(6,'(" The ",A,"-by-",A," AV-schemata here available are")')
     +  CF(:JF(NF)), CF(:JF(NG)); KB = 1
42    CALL LOOK(1,FB,NAME,20,KB) ! FB still has extension dummy here
46    WRITE(6,'(/4X,"Hit RETURN to consider schema ",A," for your gr",
     +  "oups'' factor means."/4X,"Otherwise, enter the index of an ",
     +  "alternative choice from this list"/4X,"or any letter to lea",
     +  "ve the F-means unchanged."/)') CF(:JF(KB))
      CALL SCANR(J,1,'I',NUL); IF(KB==1.AND.J/=0) GOTO 50
      IF(KB>1.AND.J/=0) THEN
        READ(2,*) NN; NN = MIN(NN,KB); GOTO 48
      END IF
      FT = NAME(NN)   ! Put FB = FT after F-means are fixed
      CALL SKEME(NF,NG,FT,KB,GF,MSG)   ! SKEME starts by uploading FT
      IF(KB==1) THEN
        QF = .TRUE.; IF(MSG==0) THEN; FB = FT; GOTO 48; END IF
        WRITE(6,'(" More regrets: No other suitable F-mean schema",
     +    " is currently in store."/" Come again after calling ",
     +    "SCHEMAS to remedy this deficiency.")'); STOP
      ELSE ! If more available
        WRITE(6,'(/" If the ",A," listing contained another F-mean",
     +    "s schema you think you might"/" prefer to the one just ",
     +    "examined, enter anything.  Otherwise, hit RETURN to")')
     +    FB(:LAST(FB))
        IF(MSG>0) WRITE(6,'(" move on without differential F-mean",
     +    "s.")'); QF = .FALSE.
        IF(MSG==0) WRITE(6,'("move on with the F-means now select",
     +    "ed.")'); QF = .TRUE.
        CALL SCN(J); IF(J/=0) GOTO 42; FB = FT
      END IF
48    DO I = 1,NF; GF(I,NG1) = 0    ! Center group F-means
        DO J = 1,NG; GF(I,NG1) = GF(I,NG1) + GF(I,J); END DO
        GF(I,NG1) = GF(I,NG1)/NG
        DO J = 1,NG; GF(I,J) = GF(I,J) - GF(I,NG1); END DO
      END DO
      IF(KOP/=3) GOTO 50
C   Adjust F-means for A-paths: GF <= QGF = (I-AP)GF
      Q = 0.; DO I = 1,NF; Q(I,I) = 1; END DO; Q = Q-AP
      CALL MINV(NF,Q,NF,IER)   ! Q is now (I-AP) !! Check: Recreation of GF
      AP = 0. ! Use AP as workspace for QAF      !!   here indeed agrees with
      DO I = 1,NF                                 !!   GF computed in GENSCOR !!
        DO J = 1,NG; DO K = 1,NF; X(I) = Q(I,K)*GF(K,J); END DO; END DO
        DO J = 1,NG; GF(I,J) = X(I); END DO  ! ^Adjustment for Q
      END DO  ! GF now replaced by QGF
50    IF(KA==0) GOTO 60   ! Rem: KA is count of E-means schemata

C      ͻ
C           ??? Group differences in detection biases (E-means) ???     
C      ͼ

52    WRITE(6,'(/6X,"",65(""),"")')
      WRITE(6,'(6X,"",5X,"??? Group differences in detection biases ",
     +  "(E-means) ???",5X,""/6X,"",65(""),""/)')
      WRITE(6,'(" The ",A,"-by-",A," AV-schemata here available are")')
     +  CF(:JF(NV)), CF(:JF(NG)); KA = 1
54    CALL LOOK(1,FA,NAME,20,KA)  ! FA still has extension dummy here
56    WRITE(6,'(/4X,"Hit RETURN to consider schema ",A," for your gro",
     +  "ups'' E-mean detection"/4X,"biases.  Otherwise, enter the in",
     +  "dex of a different schema on this list"/4X,"or any letter to",
     +  " waive assignment of detection biases."/)') CF(:JF(KA))
      CALL SCANR(J,1,'I',NUL); IF(J<0) GOTO 58
      IF(J/=0) THEN
        READ(2,*) NN; NN = MIN(NN,KA); GOTO 56
      END IF
      FT = NAME(NN)   ! Put FA = FT after E-means are fixed
      CALL SKEME(NV,NG,FT,KA,GE,MSG)   ! SKEME starts by uploading FT and
      IF(KA==1) THEN
        QE = .TRUE.; IF(MSG==0) THEN; FA = FT; GOTO 58; END IF
        WRITE(6,'(" More regrets: No other suitable E-mean schema",
     +    " is currently in store."/" Come again after calling ",
     +    "SCHEMAS to remedy this deficiency.")'); STOP
      ELSE ! If more available
        WRITE(6,'(/" If the ",A," listing contained another E-mean",
     +    "s schema you think you might"/" prefer to the one just ",
     +    "examined, enter anything.  Otherwise, hit RETURN to")')
     +    FA(:LAST(FA))
        IF(MSG>0) WRITE(6,'(" move on without differential E-mean",
     +    "s.")'); QE = .FALSE.
        IF(MSG==0) WRITE(6,'("move on with the E-means now select",
     +    "ed.")'); QE = .TRUE.
        CALL SCN(J); IF(J/=0) GOTO 54
      END IF

58    QY = QE.OR.QF; IF(.NOT.QY) GOTO 60
      IF(QE) THEN
        DO I = 1,NV    ! Center group E-biases; GE,GY already zeroed
          DO J = 1,NG; GE(I,NG1) = GE(I,NG1) + GE(I,J); END DO
          GE(I,NG1) = GE(I,NG1)/NG
          DO J = 1,NG; GE(I,J) = GE(I,J) - GE(I,NG1); END DO
        END DO
      END IF  ! ######## Scores modified here
      ALLOCATE( GY(NV,NG) ); GY = 0.; IF(QE) GY = GE
      IF(QF) THEN         ! Pattern is W; E-means ^^ already put into GY
        DO I = 1,NV; DO J = 1,NG
          DO K = 1,NF; GY(I,J) = GY(I,J) + W(I,K)*GF(K,J); END DO
        END DO; END DO                 !  GF here ^^includes premult by Q
      END IF  ! GY now holds combined Y-effects of F-diffs and E-diffs
C
60    OPEN(15,STATUS='SCRATCH',FORM='UNFORMATTED',ACCESS='DIRECT',
     +  RECL=8+4*NVF); NR = 0
      WRITE(6,'(/" ..... Uploading score records. ....."/)')
61    READ(7,END=64) (X(I),I=1,NVF); NR = NR+1
      WRITE(15,REC=NR) 1, NR, (X(I),I=1,NVF); GOTO 61
64    IF(NR/=NS) THEN ! All cases load all records into direct-access file 15
        WRITE(6,'(" WARNING: The number ",A," of records retrieved her",
     +   "e from datafile ",A/11X,"differs from the number ",A," claim",
     +   "ed in its documentation.")') CF(:JF(NR)),F3(:LF3),CF(:JF(NS))
        NS = NR; CALL WAIT(0) ! ^^^ Should never happen
      END IF
      ALLOCATE( LST(NS) ); DO I=1,NS; LST(I)=I; END DO
      IF(NG<2) THEN; IDM = 0; MXID = NS; GOTO 107; END IF
      ALLOCATE( SS(4,NVF,NG), MX(NG) ); SS = 0.
      IF(QR) THEN
        CALL RANSEL(NS,NS,LST)
        DO L = 1,NG; CALL ISORT(KG,LST(1+(L-1)*KG)); END DO
      END IF           ! ^ Increasing order within each group
C   Get list MX of max ID in each group; needed for all QG=T versions
      DO L = 1,NG; MW = 0  ! MW gets max output-ID fieldwidth over all groups;
        MX(L) = LST(L*KG); MW = MAX(MW,JF(L)+JF(MX(L))) ! MW needed just to get IDM
      END DO ! IDN is prepend-group multiplier; -1 therein because MW already
      IDM = 10**(MW-1) !; MXID = MX(NG) + NG*IDM ! ^ includes width of group index
      KY=0.; KF=0; BIG=0.; MAXG=0  ! KY/KF counts out-of-bounds Y-scores/F-scores
      NSS = NS; NS = KG*NG   ! KG is group size, NS becomes total over NG groups
C   Rec in list-position LST(NN) is in group JG = 1+(NN-1)/KG
      NN = 0   ! Read/Write on File 15 henceforth done in LST order
75    NN = NN+1; READ(15,REC=LST(NN)) L, ID, (X(I),I=1,NVF)   ! L is a dummy
        JG = 1+(NN-1)/KG
CC        IF(.NOT.QY) GOTO 82
        DO I = 1,NVF ! Put received group stats in SS(1,..) and SS(2,..)
          SS(1,I,JG) = SS(1,I,JG) + X(I)
          SS(2,I,JG) = SS(2,I,JG) + X(I)*X(I)
        END DO    ! ^^^ Don't need SS if NG = 1
        DO I = 1,NV
          X(I) = X(I) + GY(I,JG); Z=ABS(X(I))    ! ######## Rescoring here
          IF(Z>=9.949) THEN; IF(Z>=9.949) KY=KY+1
            IF(Z>BIG) THEN; BIG = Z; MAXG = JG; END IF
            X(I) = SIGN(MIN(Z,9.949),X(I))
          END IF
        END DO
        IF(QF) THEN
          DO K = 1,NF; I = NV+K
            X(I) = X(I) + GF(K,JG); Z=ABS(X(I))
            IF(Z>=9.949) THEN; KF=KF+1
              IF(Z>BIG) THEN; BIG = Z; MAXG = JG; END IF
              X(I) = SIGN(MIN(Z,9.949),X(I))
            END IF
          END DO
        END IF
        DO I = 1,NVF  ! Don't need if NG = 1
          SS(3,I,JG) = SS(3,I,JG) + X(I)
          SS(4,I,JG) = SS(4,I,JG) + X(I)*X(I)
        END DO       !  ^^^ SDs not used at present
82      IF(MOD(NN,1000)==0) WRITE(6,'(I9," records uploaded; ",A,
     +    " to go.")') NN, CF(:JF(NS-NN))
        WRITE(15,REC=LST(NN)) JG, ID, (X(I),I=1,NVF); IF(NN<NS) GOTO 75
        REWIND 15

C     End of loop over records in F15
92    IF(KY+KF>0) THEN
        WRITE(6,'(/" WARNING: Under the centered group means now ass",
     +    "igned, ",A," scores (",A," on"/10X,"factors, largest in ",
     +    "group ",A,") will be trimmed to stay within"/10X,"the 9.5",
     +    " size limit on scores stored by MORSCOR.  If that is OK,"/
     +    10X,"hit RETURN to continue.  Otherwise enter anything to ",
     +    "exit and"/10X,"consider reducing the extremity of your mo",
     +    "st deviant group means.")') CF(:JF(KY+KF)), CF(:JF(KF)),
     +    CF(:JF(MAXG))
        CALL SCN(J); IF(J==0) GOTO 95
        WRITE(6,'(/10X,"Enter anything to confirm your decision to abo",
     +    "rt"/10X,"this run.  Otherwise, hit RETURN to reconsider.")')
        CALL SCN(J); IF(J==0) GOTO 92
      END IF

95    IF(NN<NS) THEN  ! Should never happen
        WRITE(6,'(" ***** File error: Datafile ",A," claims to con",
     +    "tain ",A," records,"/8X," but only ",A," are found.")')
     +    F3(:LAST(F3)), CF(:JF(NS)), CF(:JF(NN)); STOP
      END IF
      KG = NN/NG; SS = SS/KG
      IF(QY) THEN
        DO I = 1,NVF; DO J = 1,NG
          SS(4,I,J) = SQRT(SS(4,I,J) - SS(3,I,J)**2)   ! After group-means shifting
          SS(2,I,J) = SQRT(SS(2,I,J) - SS(1,I,J)**2)   ! Before  "     "      "
        END DO; END DO !  ^^^ Within-group variances not used at present
      END IF
99    IF(NG>1) THEN  ! **** Rem: QG=t now means separate group files
        WRITE(6,'(/4X,"To keep the group-flagged records in a single",
     +    " datafile, hit RETURN."/4X,"Otherwise, enter anything to ",
     +    "write ",A," groups to separate datafiles.")') CF(:JF(NG))
        QG = .FALSE.; READ(5,'(A)') CH1; IF(CH1/=' ') QG = .TRUE.
      END IF
      IF(NG<2) WRITE(6,'(/4X,"CONFIRM: To leave the records ungrouped",
     +  ", enter anything.")')
      IF(.NOT.QG .AND. NG>1) WRITE(6,'(/4X,"CONFIRM: To write ",A,
     +  " ID-flagged groups to a single datafile, enter anything.")')
     +  CF(:JF(NG))
      IF(QG) WRITE(6,'(/4X,"CONFIRM: To write ",A," groups to separ",
     +  "ate datafiles, enter anything.")') CF(:JF(NG))
      WRITE(6,'(13X,"Otherwise, hit RETURN to reconsider.")')
      READ(5,'(A)') CH1; IF(CH1==' ') GOTO 99
107   KX = 2
      WRITE(6,'(" Finally, choose whether you want these Z-scores to",
     +  " be transcribed with"/" two-decimal or three-decimal accura",
     +  "cy.  (Scores are filed with point omitted"/" after decimal ",
     +  "truncation.  Two should be enough, but it''s your call.)")')
109   WRITE(6,'(/13X,"To round scores to",I2," decimals, hit RETURN."/
     +  13X,"Otherwise, enter anything to opt for",I2," decimals.")')
     +  KX, 5-KX
      CALL SCN(J)
      IF(J/=0) THEN; KX = 5-KX; GOTO 109; END IF
      WRITE(6,'(12X,"",48(""),""/12X,"",8X,"Data transcription ",
     +  "is underway",10X,""/12X,"",48(""),"")')
C Start data transcription
      MXX = 999; IF(KX==3) MXX = 9999   ! NSS saves original record total
      KDV = MXX  !; NFIX = 0; MMIS = 0  ! HYDATA-standard read uploads these, but here entered as text
      KS = NS/NG; NS = KS*NG ! KS is no. in group; NS is now group-equalizing total
      CH4 = '45I4'; IF(KX==3) CH4 = '40I5'
C        !  Score field = KX+1; max line = min(lim, NV*(KX+1)
C        !  If KX = 2, mxl = min(180,NV*4); else = min(200,NV*5)
      MXL = MIN(180,NV*4); IF(KX>2) MXL = MIN(200,NV*5)
      FMA = '(10('//CF(:JF(MXL/(1+MAXN)))//'(1X,A):/))'  ! Namelist format; all cases
      LM = 3+JF(NV); N = 150/(LM+1)

ccc If NG=1:  MXID=NS=KS  Rem: NS is sum over groups; less than NSS if leftover records
ccc If QG=f,NG>1: MXID = ID in REC=NS + group leadr
ccc If QG=t: MXID = MX(JG) + group leader
ccc
C      IDM = 0; IF(NG>1) IDM = 10**JF(NS) ! If NG>1, ID-add for grp IG is IDM*IG
C      MXID = IDM*NG + NS ! =NS if NG=1  ! REM: D-file FMT needs correct MXID
c      CH2 = CF(:JF(JF(MXID)))  ! ; CH4 = '45I4'; IF(KX==3) CH4 = '40I5'
CC      FMT = '(I'//CH2//',":",45I4,20(:/'//CH2//'X,1X,45I4))'
c      FMT='(I'//CH2//',":",'//CH4//',50(:/'//CH2//'X,1X,'//CH4//'))'

cc HYDATA-standard score format
cc      WORD(:4) = '50I3'; IF(KFLD==4) WORD(:4) = '45I4'
cc      IF(KFLD==5) WORD(:4) = '40I5'
cc      FMT = '(I'//CH2//',":",'//WORD(:4)//',20(:/'//CH2//'X,1X,'//
cc     +  WORD(:4)//'))     '
C>>> Code from HYDATA
C>>      WORD = ' '
C>>      WORD((13-LF2)/2:12) = F2; WORD(12+(13-LF1)/2:24) = F1
C>>      WRITE(7,'(" HYDATA-standard datafile ",A,": ",A," variables, ",
C>>     +  A," records; largest ID, ",A,"; transcribed under DEV = ",A/
C>>     +  8X,"from rawdata source ",A,"; datafix ",A,"; ",A," missing ",
C>>     +  "scores; ",A," complete records.")') WORD(:12), CF(:JF(NY)),
C>>     +  CF(:JF(NRR)), CF(:JF(MXID)), CF(:JF(KDV)), WORD(13:24),
C>>     +  CF(:JF(NFIX)), CF(:JF(MIS)), CF(:JF(KMPR))
C>>C HYDATA-standard datafile xxxxxxxxxxxx: xxx variables, xxxx records; maximum ID No.xxxxxxxxxx; transcribed under DEV = xxxx
C>>C        from rawdata source xxxxxxxxxxxx; datafix xx; xxxxxxx missing scores.
C>>C *** 1st name, F2, must receive a 12-space field. 2nd name is F1

      OPEN(23,FILE=F2) ! Append to logfile
      CALL FNDEND(23)
      WRITE(23,'("%%"/40("* ")/" HYDATA-standard transcription from s",
     +  "imulation datafile ",A," containing ",A/" unformatted score ",
     +  "records for ",A," data variables followed by ",A," common fa",
     +  "ctors.")') F3(:LAST(F3)),CF(:JF(NSS)),CF(:JF(NV)),CF(:JF(NF))
      CALL DAY(23); IF(NG>1) NSS=NR  ! Ready to read input line 4, start of data ;
      IF(QG) GOTO 127
C
C  Just one output file (either NG=1, or NG>1 with QG=F). IDM already set
CC      IDM = 0; MXID = NS          !! Case QG=F set above
      IF(NG>1) MXID = MX(NG) + NG*IDM  !! IDM set above good for all NG>1 cases
      CH2 = CF(:JF(JF(MXID)))   !; CH4 = '45I4'; IF(KX==3) CH4 = '40I5'  done above
CC      FMT = '(I'//CH2//',":",45I4,20(:/'//CH2//'X,1X,45I4))'
      FMT='(I'//CH2//',":",'//CH4//',50(:/'//CH2//'X,1X,'//CH4//'))'
      OPEN(9,FILE=F1,FORM='FORMATTED'); WORD = ' ' ! Data-transcription if QG=F
      WORD(:12) = ' '; WORD((13-LF1)/2:12) = F1
      WRITE(9,'(" HYDATA-standard datafile ",A,": ",A," variables, ",
     +  A," records; largest ID, ",A,"; transcribed under DEV = ",A/
     +    6X,"as part of simulation ",A,"; 0 datafixes, 0 missing sco",
     +    "res.")') WORD(:12), CF(:JF(NVF)),CF(:JF(NS)), CF(:JF(MXID)),
     +    CF(:JF(KDV)), F3
      IF(NG<2) WRITE(23,'(/" All records have been transcribed to AS",
     +  "CII datafile ",A," as a single group (no rescaling except"/
     +  " omission of decimal point after rounding to",I2," decimals",
     +  "). Its header identification begins:"//" HYDATA-standard da",
     +  "tafile ",A,": ",A," variables ",A," records; largest ID, ",A,
     +  "; transcribed under DEV = ",A/8X,"from Gendata output ",A)')
     +  F1(:LF1), KX, F1(:LF1), CF(:JF(NVF)), CF(:JF(NS)),
     +  CF(:JF(MXID)), CF(:JF(KDV)), F3(:LF3)
      IF(NG>1.AND..NOT.QY) WRITE(23,'(/1X,A," of these records have ",
     +  "been transcribed to ASCII datafile ",A," with IDs that"/
     +  " distinguish ",A," groups, each containing ",A," records.",
     +  "  However, no group differences"/" have been imposed.")')
     +  CF(:JF(NG*KG)), F1(:LF1), CF(:JF(NG)), CF(:JF(KG))
      IF(NG>1.AND.QY) WRITE(23,'(/1X,A," of these records have been ",
     +  "transcribed to ASCII datafile ",A," with IDs that"/" distin",
     +  "guish ",A," groups, each containing ",A," records and diff",
     +  "ering in group means as reported below.")') CF(:JF(NG*KG)),
     +  F1(:LF1), CF(:JF(NG)), CF(:JF(KG))
        WRITE(9,FMA) (IDENT(I)(:1+LAST(IDENT(I))),I=1,NVF)
      WRITE(9,'("Rescale:",8(2X,5I3),20(/8X,8(2X,5I3)))') (KX,I=1,NVF)
      DO NN = 1,NS !  Group is 1+(NN-1)*KG  !! ^"Rescale" must be left-flush
        READ(15,REC=LST(NN)) JG, ID, (X(I),I=1,NVF)
        IF(NG==1) THEN  ! $$$$$$$$ Need bounds on scores here ???
          WRITE(9,FMT) ID, (NINT(X(I)*10**KX),I=1,NVF); CYCLE
        END IF  ! Goto next record
        ID = ID + JG*IDM  ! Record with grouped IDs
        WRITE(9,FMT) ID, (MAX(-MXX,MIN(MXX,NINT(X(I)*10**KX))),I=1,NVF)
      END DO
      CLOSE(9); GOTO 130
127   DEALLOCATE( NAME ); ALLOCATE( NAME(NG) )
C  More than one output file.
      IF(QY) WRITE(23,'(/1X,A," of these records have been partition",
     +  "ed among ",A," size-",A," groups written to separate"/" ASC",
     +  "II datafiles differing both in IDs and group means as repor",
     +  "ted below.")') CF(:JF(NG*KG)), CF(:JF(NG)), CF(:JF(KG))
      IF(.NOT.QY) WRITE(23,'(/1X,A," of these records have been partit",
     +  "ioned among ",A," size-",A," groups written to separate"/" AS",
     +  "CII datafiles with grouped IDs but NO mean differences assign",
     +  "ed between groups.")') CF(:JF(NG*KG)), CF(:JF(NG)),CF(:JF(KG))
      DO IG = 1,NG           ! Write groups successively
        F1(LF2-1:) = CF(:JF(KST+IG))  ! KST is correct here - see above
        M = MX(IG); MXID = M + IG*IDM
        CH2 = CF(:JF(JF(MXID)))    !; CH4 = '45I4'; IF(KX==3) CH4 = '40I5'  done abve
        FMT='(I'//CH2//',":",'//CH4//',50(:/'//CH2//'X,1X,'//CH4//'))'
        LF1 = LAST(F1); NAME(IG) = F1
        KF = 30+IG; WORD = ' '
        OPEN(KF,FILE=F1,FORM='FORMATTED')
        WORD(:12) = ' '; WORD((13-LF1)/2:12) = F1
        WRITE(KF,'(" HYDATA-standard datafile ",A,": ",A," variables, ",
     +    A," records; largest ID, ",A,"; transcribed under DEV = ",A/
     +    6X,"as part of simulation ",A,"; 0 datafixes, 0 missing sco",
     +    "res.")') WORD(:12), CF(:JF(NVF)),CF(:JF(KS)), CF(:JF(MXID)),
     +    CF(:JF(KDV)), F3(:LF3)
cc        WRITE(KF,FMA) (IDENT(I)(:LM),I=1,NVF)
        WRITE(KF,FMA) (IDENT(I)(:1+LAST(IDENT(I))),I=1,NVF)
        WRITE(KF,'("Rescale:",8(2X,5I3),20(/8X,8(2X,5I3)))')
     +    (KX,I=1,NVF) !! ^"Rescale" must be left-flush
        DO J = (IG-1)*KS+1, IG*KS
          READ(15,REC=LST(J)) L, ID, (X(I),I=1,NVF)
          ID = ID + IG*IDM
          WRITE(KF,FMT) ID, (MAX(-MXX,MIN(MXX,NINT(X(I)*10**KX))),
     +      I=1,NVF) ! $$$$$$$$$    ^ Bounds needed??? If so, then elsewhere also
        END DO
        CLOSE(KF)
      END DO
C Finish with centered means assigned
130   IF(NG==1) GOTO 150
      DO IG = 1,NG
        F1(LF2-1:) = CF(:JF(KST+IG))
        LF1 = LAST(F1); NAME(IG) = F1
        M = MX(IG); MH = 10**JF(M); MXID = M + MH   ! MH is group head to prepend
        IF(.NOT.QG) GOTO 135
        WRITE(23,'(/" The Group-",A," records are in datafile ",A,
     +    ", whose header lines are:")') CF(:JF(IG)), F1(:LF1)
        WRITE(23,'(" HYDATA-standard datafile ",A,": ",A," variables ",
     +    A," records; largest ID, ",A,"; transcribed as a subset of"/
     +    8X,"Gendata output ",A,";")') F1(:LF1), CF(:JF(NVF)),
     +    CF(:JF(NS/NG)), CF(:JF(MX(IG)+IG*IDM)), F3(:LF3)
      END DO
135   WRITE(23,'(/" Here are the received group means, nonzero only",
     +  " by sampling chance:")')
      CH3 = ' '
      WRITE(23,'(" Outset group means on F (the dataset''s common fa",
     +  "ctors):")')
      WRITE(23,'(" Group:    1",98(A8))') (CLN(J*1.,8,10),J=2,NG),
     +  '       '
      WRITE(23,'(" ",98A)') ('',I=2,NG),''
      DO I = 1,NF
        J = JF(I); CH3(4-J:) = CF(:J); CH3(3-J:3-J) = 'f'
        WRITE(23,'(2X,A," ",99(A6," "))') CH3, (CLN(SS(1,NV+I,K),
     +    6,-3),K=1,NG)
      END DO
      WRITE(23,'(" ",98A)') ('',I=2,NG),''
      CH3 = ' '
      WRITE(23,'(" Outset group means on Y (the indicator variables)")')
      WRITE(23,'(" Group:    1",98(A8))') (CLN(J*1.,8,10),J=2,NG),
     +  '       '
      WRITE(23,'(" ",98A)') ('',I=2,NG),''
      DO I = 1,NV
        J = JF(I); CH3(4-J:) = CF(:J); CH3(3-J:3-J) = 'y'
        WRITE(23,'(2X,A," ",99(A6," "))') CH3, (CLN(SS(1,I,K),
     +    6,-3),K=1,NG)
      END DO
      WRITE(23,'(" ",98A)') ('',I=2,NG),''
      WRITE(23,'(/26("")," GROUP EFFECTS ASSIGNED ",32(""))')

c Group means have been shifted from their Genscor-created values by adding to each
c record's score on each F-source and/or Y-indicator an assigned group effect which
c is the same for each record within its group but generally varies over groups and
c variables.  Each variable's assigned constants are centered over groups.  Note
c that group effects imposed on F also produce F-mediated differences in the groups'
c Y-means added to whatever detection biases may have been assigned directly to Y.
      IF(QF.OR.QE) WRITE(23,'(" Group means have been shifted from th",
     +  "eir Genscor-created values by adding to each"/" record''s sc",
     +  "ore on each F-source and/or Y-indicator an assigned group ef",
     +  "fect which "/" is the same for each record within its group ",
     +  "but generally varies over groups and"/" variables.  Each var",
     +  "iable''s assigned constants are centered over groups.  Note"/
     +  " that group effects imposed on F also produce F-mediated dif",
     +  "ferences in the groups''"/" Y-means added to whatever detect",
     +  "ion biases may have been assigned directly to Y.")')
      IF(.NOT.QF) THEN
        WRITE(23,'(/" Group effects imposed on the factors: NONE")')
        GOTO 143
      END IF

C Group:    1       2       3       4       5  
C Ĵ
C   f1   x.xx -x.xxx -xx.xx   x.xx  -x.xx 
C   f2                                    
C 

      CH3 = ' '
      WRITE(23,'(//" Group effects imposed on the factors by center",
     +  "ing an instantiation of schema ",A,":")') FB(:LAST(FB))
      WRITE(23,'(" Group:    1",98(A8))') (CLN(J*1.,8,10),J=2,NG),
     +  '       '
      WRITE(23,'(" ",98A)') ('',I=2,NG),''
      DO I = 1,NF;
        J = JF(I); CH3(4-J:) = CF(:J); CH3(3-J:3-J) = 'f'
        WRITE(23,'(2X,A," ",99(A6," "))') CH3, (CLN(GF(I,K),6,-3),
     +    K=1,NG)
      END DO
      WRITE(23,'(" ",98A)') ('',I=2,NG),''

143   IF(.NOT.QE) THEN
        WRITE(23,'(/" Detection biases imposed on the indicators: ",
     +    "NONE")')
        GOTO 145
      END IF
      CH3 = ' '
      WRITE(23,'(//" Detection biases imposed on the indicators by ce",
     +  "ntering an instantiation of schema ",A,":"/)') FA(:LAST(FA))
      WRITE(23,'(" Group:    1",98(A8))') (CLN(J*1.,8,10),J=2,NG),
     +  '       '
      WRITE(23,'(" ",98A)') ('',I=2,NG),''
      DO I = 1,NV;
        J = JF(I); CH3(4-J:) = CF(:J); CH3(3-J:3-J) = 'y'
        WRITE(23,'(2X,A," ",99(A6," "))') CH3, (CLN(GE(I,K),6,-3),
     +    K=1,NG)
      END DO
      WRITE(23,'(" ",98A)') ('',I=2,NG),''

c These assignments entail that these indicators' population means in these groups are
145   WRITE(23,'(/" The groups'' population means on these indicator",
     +  "s entailed by these assignments are")'); CH3 = ' '
      IF(.NOT.QY) THEN; WRITE(23,'(" all zero.")'); GOTO 147; END IF
      WRITE(23,'(" Group:    1",98(A8))') (CLN(J*1.,8,10),J=2,NG),
     +  '       '
      WRITE(23,'(" ",98A)') ('',I=2,NG),''
      DO I = 1,NV;
        J = JF(I); CH3(4-J:) = CF(:J); CH3(3-J:3-J) = 'y'
        WRITE(23,'(2X,A," ",99(A6," "))') CH3, (CLN(GY(I,K),6,-3),
     +    K=1,NG)
      END DO
      WRITE(23,'(" ",98A)') ('',I=2,NG),''

147   WRITE(23,'(/" The actual indicator means in these groups, diff",
     +  "ering"/5X,"from their population values by sampling error, ",
     +  "are")')
      WRITE(23,'(" Group:    1",98(A8))') (CLN(J*1.,8,10),J=2,NG),
     +  '       '
      WRITE(23,'(" ",98A)') ('',I=2,NG),''
      CH3 = ' '
      DO I = 1,NV;
        J = JF(I); CH3(4-J:) = CF(:J); CH3(3-J:3-J) = 'y'
        WRITE(23,'(2X,A," ",99(A6," "))') CH3, (CLN(SS(3,I,K),6,-3),
     +    K=1,NG)
      END DO
      WRITE(23,'(" ",98A)') ('',I=2,NG),''

150   IF(.NOT.QG) WRITE(6,'(/" Done:  The transcribed data are in AS",
     +  "CII file ",A,".")') F1(:LF1)
      IF(.NOT.QG) STOP
      WRITE(6,'(/" Done:  The transcribed data are in ASCII files")')
      WRITE(6,'(8X,5A12)') (NAME(I),I=1,NG)
      STOP
      END
C
      SUBROUTINE CAP(WORD,L)
C This makes the first L letters in WORD all upper-case.
      CHARACTER WORD*(*)
      DO I = 1,L
        N = ICHAR(WORD(I:I))
        IF(N>=97 .AND. N<=122) WORD(I:I) = CHAR(N-32)
      END DO
      END SUBROUTINE
C
      FUNCTION JF(N)
C Return character expression of integer N left-justified in field CF; then
C CF(:JF(N)) writes N with exactly the right length in format specifier A.
C *** Haven't found any way to avoid requiring N to be INTEGER(4).
      CHARACTER(12) CF
      INTEGER(4) K
      COMMON /CF/ CF
      K = ABS(N)
      CF = '            '
      J = 13
10    J = J-1
      CF(J:J) = CHAR(48+MOD(K,10))
      K = K/10
      IF(K>0) GOTO 10
      IF(N<0) CF(J-1:J-1) = '-'
      CF = ADJUSTL(CF)
      JF = LEN_TRIM(CF)
      END FUNCTION
C
      FUNCTION CLN(X,NFF,ND)
C Express real number X as a character string in fieldwidth NF with LD decimals
C when room, where LD = ABS(ND).  ND<0 tries to precede all positive numbers
C with a blank. LD > 9 displays zero decimals and no decimal point while
C returning X = 0 as ND-10 zeros right-justified in selected field.
C ***** WARNING: If a call of CLN prints garbage, you have forgotten to
C       declare CLN as CHARACTER*8 in the calling routine.
      PARAMETER (KW=16)
      CHARACTER CLN*8, WK(KW)
      CLN = '        '
      NF = MIN(8,NFF)  ! Limit fieldwidth to 8 chars
      LD = ABS(ND)
      IF(ABS(X)<1.0E-12) THEN !  Special for vanishingly small X
        N = MIN(NF-1,MOD(LD,10))
        IF(LD<10) CLN(NF-N:NF+1-N) = '.0'
        IF(LD<10) RETURN
        DO I = 1,N
          CLN(NF+1-I:NF+1-I) = '0'
        END DO
        RETURN
      END IF
      M = NF; IF(ABS(X)>1.) M = NF-1-INT(LOG10(ABS(X))) !  M is space free for decimal (or M-1 if X<0) )
      IF(M<0 .OR. M<1.AND.X<0.) GOTO 55
      IF(ND>=10) LD = 0; LD = MIN(LD,M)
      DO I = 1,KW
        WK(I) = ' '
      END DO
      IF(LD==0) N = NINT(ABS(X))         ! Shouldn't be needed, but is
      IF(LD/=0) N = NINT(ABS(X)*10**LD)  ! This can overflow if LD is large
      DO I = KW,KW-LD+1,-1
        WK(I) = CHAR(48+MOD(N,10))
        N = N/10
      END DO
      WK(KW-LD) = '.'
      IF(N==0 .AND. LD==0) WK(KW-LD-1) = '0'
      IF(N==0 .AND. X<0. .AND. LD>0) WK(KW-LD-1) = '-'
      DO I = KW-LD-1,2,-1
        IF(N>0) WK(I) = CHAR(48+MOD(N,10))
        IF(N>0 .AND. X<0.) WK(I-1) = '-'
        N = N/10
      END DO
      KS = KW-NF+1
25    KS = KS-1
C       Field returned will start at WK(KS+1) for initial KS
      IF(KS<=0) GOTO 50
      IF(ND>=0) THEN
        IF(WK(KS)/=' ' .AND. WK(KS+NF)/='.') GOTO 25
      ELSE
        IF(WK(KS+1)/=' '. AND. WK(KS+1)/='-' .AND. WK(KS+NF)/='.')
     +    GOTO 25
      END IF
      IF(ND>=10) KS = MAX(1,KS-1)
      DO I = 1,NF
        CLN(I:I) = WK(KS+I)
      END DO
50    IF(WK(KS)==' ') RETURN
55    CLN = ' *******'
      END FUNCTION
C
      SUBROUTINE FNDEND(K)
C Finds end of file K for appending; Lahey and Microsoft compilers requires
C backspace. Also UNIX compiler
      BACKSPACE K
10    READ(K,'()',END=20); GOTO 10
20    BACKSPACE K
      END SUBROUTINE
C
      FUNCTION LAST(WORD)
C This left-justifies leading substring WORD(:M) of WORD, and returns its
C length as L. If the string is empty, LAST is returned as 0.
      CHARACTER WORD*(*)
      WORD = ADJUSTL(WORD)
      LAST = LEN_TRIM(WORD)
      END

      SUBROUTINE LOOK(K,GET,NAME,ML,KNT)
C LOOK calls DOS to delete or report files named in GET, with action set by K.
C K/2 = 0,1 initial-lists/append-lists GET in buffer file ZZZ. MOD(K,2) = 0,1
C stores/shows-to-screen the GET list. So K=0 initial-stores; K=1 initial-
C shows; K=2 append-stores; and K=3 append-shows. The last filename matching
C the GET template is returned in WORD with its length M.  NAME returns the
C list of template matches, the number of which is NL, and prints the numbered
C list to screen.  ML is max NL allowed by array allocation.
C ***** This variant uses negative input on KNT to suppress screen write
      LOGICAL QY
      CHARACTER*12 GET*(*), NAME(*), WORD*40, WD*40
      CHARACTER E   ! <<<  Special characters as needed
      SAVE NL  ! NL must NOT be disturbed by KNT if K > 1
      NOSHO = KNT; IF(K<2) NL = 0  ! Shd always have K  1 on 1st call
      WD = GET; M = LAST(WD); LL = M
CC      LL = 1    ! Why set LL this old way, or distinguish it from M ???
CC5     LL = LL+1; IF(LL<M) GOTO 5   ! Some old code glitch ??
      WD(M+2:M+LL+1) = WD(:LL); WD(40:40) = ' '  ! Shd now always have LL = M
      DO I = M+2,M+LL+1
        IF(WD(I:I)=='*' .OR. WD(I:I)=='?' ) THEN
          WD(40:40) = '!'; WD(I:I) = '!'
        END IF
      END DO
      INQUIRE(FILE=WD(M+2:M+LL+1),EXIST=QY)
      IF(.NOT.QY) OPEN(19,FILE=WD(M+2:M+LL+1)) ! Precludes no-match error message
      IF(K/2==0) CALL SYSTEM('dir '//WD(:M)//' >ZZZ')
      IF(K/2>0) CALL SYSTEM('dir '//WD(:M)//'>>ZZZ')
      IF(.NOT.QY) CLOSE(19,STATUS='DELETE')
      IF(MOD(K,2)==0) RETURN
      OPEN(4,FILE='ZZZ')
10    READ(4,'(A)',END=50) WORD
      IF(WORD(25:26)==' 0' .OR. WORD(16:16)=='<') GOTO 10  ! No directory names
C Special filter for AV*-or-.POP
      IF(WORD(:2)/='AV' .AND. WORD(10:12)/='POP') GOTO 10
cc      E = WORD(:1); IF(E==' ' .OR. E=='.') GOTO 10
      IF(WORD(:2)=='AV' .AND. LGT(WORD(3:3),'9')) GOTO 10
      L = LAST(WORD(:14))      ! ^ Lexically Greater Than
      DO I = 1,L; IF(WORD(I:I)=='!') GOTO 10; END DO
      L = LAST(WORD(:8))
      IF(WORD(10:10)/=' ') WORD(L+1:L+4) = '.'//WORD(10:12)  ! <<<<< base.ext assembled here
      LF = LAST(WORD(:L+4))
      IF(WORD(LF-2:LF)=='POP') THEN
        INQUIRE(FILE=WORD(:LF),UNFORMATTED=E)  ! ; IF(E/='Y') GOTO 10
      IF(E/='Y') GOTO 10
      END IF  ! Not datafile from GENSCOR if formatted ^
      DO I = 1,NL  !  Eliminate possible duplications|  ^Not from GENSCOR unless unformatted
        IF(NAME(I)(:L+4)==WORD(:L+4).AND.NAME(I)(L+5:L+5)==' ') GOTO 10
      END DO
      NL = NL+1
      NAME(NL) = WORD(:L+4)//'     '
      M = L+4
      IF(NL<ML) GOTO 10
50    IF(NL==0) M = 0
      CLOSE(4,STATUS='DELETE')
      KNT = NL
      IF(NOSHO.LT.0) RETURN
      IF(NL>0) WRITE(6,'(20(:/4(I5,". ",A,:)))') (I,NAME(I),I=1,NL)
      IF(NL>0) WORD(:12) = NAME(NL)
      RETURN
      END

      SUBROUTINE MINV(N,A,LDA,IER)
C This returns in A the inverse of N-by-N matrix A, with determinant if
C wanted. LDA is the leading dimension of A declared in the calling program.
      INTEGER R(N), C(N)
      REAL A(LDA,*)
      IF(N>LDA) WRITE(6,'(/" Parameter MV in subroutine MINV ",
     +  "must be increased to ",I3)') N
      IF(N>LDA) STOP
      D = 1.; IER = 0
      BBIG: DO K=1,N
C Search for largest element
        R(K) = K; C(K) = K; BIG = A(K,K)
        DO J=K,N; DO I=K,N
            IF(ABS(BIG)>=ABS(A(I,J))) CYCLE
            BIG = A(I,J); R(K) = I; C(K) = J
        END DO; END DO
C Interchange rows
        I = R(K)
        IF(I<=K) GOTO 60
        DO J=1,N
          TMP = A(K,J); A(K,J) = A(I,J); A(I,J) = TMP
        END DO
C Interchange columns
60      J = C(K)
        IF(J<=K) GOTO 90
        DO I=1,N
          TMP = A(I,K); A(I,K) = A(I,J); A(I,J) = TMP
        END DO
C Divide column by minus pivot (saved in BIG)
90      IF(ABS(BIG)<1.0E-30) IER = 1
        IF(IER==1) RETURN
        DO I=1,N
          IF(I/=K) A(I,K) = -A(I,K)/BIG
        END DO
C Reduce matrix
        DO I=1,N
          TMP = A(I,K)
          DO J=1,N
            IF(I==K .OR. J==K) CYCLE
            A(I,J) = A(I,J) + TMP*A(K,J)
          END DO
        END DO
C Divide row by pivot
        DO J=1,N
          IF(J/=K) A(K,J) = A(K,J)/BIG
        END DO
C Accumulate product of pivots.  At output, D is the matrix's determinant.
        D = D*BIG
C Replace pivot by its reciprocal
        A(K,K) = 1./BIG
      END DO BBIG
C Final row/column interchange to undo permutations
      K = N
200   K = K-1
      IF(K==0) RETURN
      J = R(K)
      IF(J<=K) GOTO 240
      DO I=1,N
        TMP = A(I,K); A(I,K) = A(I,J); A(I,J) = TMP
      END DO
240   I = C(K)
      IF(I<=K) GOTO 200
      DO J=1,N
        TMP = A(K,J); A(K,J) = A(I,J); A(I,J) = TMP
      END DO
      GOTO 200
      END SUBROUTINE

      SUBROUTINE NAME1(F1,F2,M,L,KST)
C This receives a filename in F1 (presumed to start in position 1), solves
C for <base> to be the part of F1 prior to '.' up to M characters, scans the
C subdirectory for the lowest i=1,2,...,99 such that file <base>.Di does not
C already exist, returns <base>.Di in F1(:12), <base>.LOG in F2, and the end
C position of the latter in L. KST is 1 less than the i returned in Di
      LOGICAL QY
      CHARACTER F1*(*), F2*(*), CF*12
      COMMON /CF/ CF
      L = 0
10    L = L+1; IF(L<=M.AND.F1(L:L)/=' '.AND.F1(L:L)/='.') GOTO 10
      F1(L+2:) = ' '
      F2 = F1; F1(L:L+1) = '.D'; F2(L:L+3) = '.LOG'
      L = L+2; I = 0
20    I = I+1; KST = I-1
      F1(L:) = CF(:JF(I))
      INQUIRE(FILE=F1,EXIST=QY)
      IF(QY .AND. I<99) GOTO 20
      IF(QY .AND. I==99) F1(L:L+1) = '0 '
      L = L+1
      END SUBROUTINE
C
      FUNCTION RANDY()
C Use the compiler's random generator for a random number in the unit interval
      DATA NEW/1/
      IF(NEW>0) THEN; NEW = 0; CALL RANDOM_SEED(); END IF
      CALL RANDOM_NUMBER(RANDY)
      END FUNCTION

      SUBROUTINE SCN(NL)
C This is a baby SCAN that responds to keyboard entry KB by returning NL = 0
C if KB is RETURN, NL = 1 if KB is a number, and NL = -1 KB is a letter.
      CHARACTER CH
      READ(6,'(A)') CH; N = ICHAR(CH)
      NL = 0; IF(N<=32) RETURN
      IF(N<58) NL = 1; IF(N>64) NL = -1
      END SUBROUTINE
C
      SUBROUTINE SCANR(NL,NS,SEQ,KND)
C This reads the keyboard string, cleans it for list-directed reading of
C the numbers therein, and checks whether it contains NS integers/reals in
C the sequence of Is and Rs received in SEQ if NS>0, or, if NS<1, whether
C all its numbers are of the first I/R kind listed in SEQ. (Integers are
C accepted also as reals.  Termination of an input line by "*" allows up to
C two continuation lines.)  NL returns 0 if the input string is blank, -1 if
C this contains only non-numeric characters, -2 if the cleaned number string
C returned in File 2 is non-null but does not match SEQ, and gives the total
C count of numbers in the returned string otherwise.
C *** If SEQ is "B", NL returns 0 if the input line is blank or -1 otherwise.
C *** Version R: KND(I) returns 1 if Ith entry has a decimal, else 0
      CHARACTER  AA, SEQ*(*), WA*240, WB*240
      INTEGER KND(*)
      NL = 0
5     NLL = NL + 80
      READ(5,'(A80)') WA(NL+1:NLL)
      IP = NL
      NL = NLL+1
10    NL = NL-1
      IF(NL==0) RETURN
      IF(WA(NL:NL)==' ') GOTO 10
      IF(WA(NL:NL)=='*' .AND. NL>IP) GOTO 5
      IF(SEQ(1:1)=='B') NL = -1
      IF(SEQ(1:1)=='B') RETURN
      IP = 0; WB = ' '
      DO I = 1,NL
        IF(WA(I:I)<CHAR(48) .OR. WA(I:I)>CHAR(57)) CYCLE
        WB(I:I) = WA(I:I); WA(I:I) = '0' ! All digits transferred to WB
      END DO
CC      IP = 0  ! Already initialized ?? (Flags whether transfer of . is ok)
      IF(WA(:3)=='-.0'.OR.WA(:2)=='-0') WB(:1) = '-'       ! WA starts with - ?
      IF(WA(:2)=='.0') THEN; WB(:1) = '.'; IP = 1; END IF  ! WA starts with . ?
      DO I = 2,NL    ! REM: '0' in WA now flags integers transferred to WB
        IF(WA(I:I)=='-') THEN
          IF(WB(I-1:I-1)==' ' .AND. (WA(I+1:I+1)=='.'.OR.WA(I+1:I+1)
     +      =='0')) WB(I:I) = '-'; IP = 0
        ELSE IF (WA(I:I)=='.') THEN
          IF( (WA(I-1:I-1)=='0'.OR.WA(I+1:I+1)=='0') .AND. IP==0) THEN
            WB(I:I) = '.'; IP = 1
          END IF
        ELSE IF(WA(I:I) /= '0') THEN
          IP = 0
        END IF
      END DO
C Identify Integer/Real sequence in WB and put I/R string in start of WA
      NN = 0  ! Count numbers in the input sequence
      AA = 'I'; IF(WB(1:1)=='.') AA = 'R'
      DO I = 2,NL+1
        IF(WB(I:I)==' ' .AND. WB(I-1:I-1)/=' ') THEN
          NN = NN + 1; WA(NN:NN) = AA; AA = 'I'
        ELSE IF(WB(I:I)=='.') THEN    !   ^  Default for next entry
          AA = 'R'
        END IF
      END DO
      IF(NN==0) THEN; NL = -1; RETURN; END IF
      IF(KND(1)/=0) THEN
        DO J = 1,NN; KND(J) = 1; IF(WA(J:J)=='I') KND(J) = 0; END DO
      END IF                   ! ^ Return 0,1 coding of I,R kinds
      AA = '+'
      IF(NS<=0 .AND. SEQ(1:1)=='R') GOTO 60
      IF(NS<=0) GOTO 50
      IF(NN<NS) GOTO 57
      DO I = 1,NS
        IF(SEQ(I:I)=='I' .AND. WA(I:I)/='I') AA = '0'
      END DO
      GOTO 55
50    DO I = 1,NN
        IF(WA(I:I)/=SEQ(1:1)) AA = '0'
      END DO
55    IF(AA=='+') GOTO 60
57    NL = -2
      IF(NL<=-2) WRITE(6,'(/" Your input does not contain the ",
     +  "number sequence requested. Try again.")')
      RETURN
60    REWIND 2
      WRITE(2,'(A)') WB(1:NL)
      NL = NN
      REWIND 2
      RETURN
      END

      SUBROUTINE SKEME(NY,NF,F1,MM,B,MSG) ! From SEMCOV
C F1 names the uploaded schema, MM the max index of stored files of F1's kind.
C B returns a full instantiation of schema F1. MSG/=0 flags no schema return
      CHARACTER*12  CF, F1, CLN*8, PL*2    ! , CK*1
      INTEGER  LKOD(0:3,26), LKBK(0:3,26), LST(0:NY*NF), LTRS(0:NY*NF)
      REAL  X(20), B(NY,NF+1)
      NDIG(N) = (MAX(1,N)/48)*(57/MAX(1,N))  ! 1 if N is ICHAR for digit; otherwise, 0
      NLET(N) = (MAX(1,N)/64)*(90/MAX(1,N))  ! 1 if N is ICHAR for cap letter or @; otherwise, 0
      COMMON /CF/ CF
      SAVE LSHO  ! Flag for info display
      KIND = 5   ! Only AV-schemata called in MORSCOR
      LF1 = LAST(F1); MSG = 0; LSHO = 1; FUZ = .0
CC      KIND = 3; IF(F1(5:5)=='H') KIND = 2; IF(F1(5:5)=='R') KIND = 4
CC      CK = 'A'; IF(KIND==3) CK = 'C'
      GOTO 30
23    WRITE(6,'(" Apologies: File ",A," is corrupt.  Try another.")')
     +  F1(:LF1); CLOSE(7); MSG = -1; RETURN
30    OPEN(19,FILE=F1,FORM='UNFORMATTED')
      READ(19,ERR=23) NL, (LST(I),I=1,NL); LST(0) = NL
      READ(19,ERR=23) LLET, ((LKOD(I,J),I=0,3),J=1,LLET)
      CLOSE(19)

C ========= Start of schema display ==========
32    CALL SHO(NY,NF,KIND,F1,LKOD,LST,LLET,FUZ,1,6)
      IF(LSHO>0.OR.NF>5) CALL WAIT(0)
C =============== Start of letter specifications ==================
      DO I = 1,NL
        LTRS(I) = MOD(LST(I),100)     ! LTRS collects letter entries with repetitions
      END DO
      LLET = 0
      OUTER: DO L = 65,90    ! Alphabetize LTRS without repetitions
        DO N = LLET+1,NL
          IF(LTRS(N)==L) THEN
            LLET = LLET+1; LTRS(N) = LTRS(LLET); LTRS(LLET) = L
            CYCLE OUTER
          END IF
        END DO; IF(LLET==NL) EXIT
      END DO OUTER
      DO I = 1,LLET           ! Count occurrences of each letter (needed?)
        M = LTRS(I); KL = 0   ! and store with letter in LKOD(0,-)
        DO J = 1,NL
          IF(LTRS(J)==M) KL = KL + 1
        END DO
        LKOD(0,I) = M + KL*100
      END DO

C  As you presumably know, each letter in this schema goes proxy for a triple
C  of adjustable parameters: Hi,Lo,Pr. [Lo,Hi] is the size range within which
C  matrix elements coded L will be randomized (or fixed if Lo = Hi), while
C  this term is made negative with probability Pr.  If you elect to revise
C  the present settings, recall that entering less than three numbers when
C  editing the settings for proxy L will set Pr = 0 and default Lo to Hi
C  if you enter just one.

C  Reminder: Each letter in this schema goes proxy for a triple of adjustable
C  parameters; Hi,Lo,Pr. [Lo,Hi] is the size range within which matrix elements
C  coded L will be randomized (or fixed if Lo = Hi), while this term is made
C  negative with probability Pr.  If you elect to revise the present settings,
C  recall that entering less than three numbers when editing the settings for
C  proxy L will set Pr = 0 and default Lo to Hi if you enter just one.

      IF(LSHO==0) GOTO 43
      WRITE(6,'("  Reminder: Each letter in this schema goes proxy f",
     +  "or a triple of adjustable"/"  parameters: Hi,Lo,Pr. [Lo,Hi]",
     +  " is the size range within which matrix elements"/"  coded L",
     +  " will be randomized (or fixed if Lo = Hi), while this value",
     +  " is made"/"  negative with probability Pr.  If you elect to",
     +  " revise the present settings,"/"  recall that entering less",
     +  " than three numbers when editing the settings for"/"  proxy",
     +  " L will set Pr = 0 and default Lo to Hi if you enter just ",
     +  "one.")'); LSHO = 0
      WRITE(6,'("  >> Note 1:  Numeric entries here cannot exceed thr",
     +  "ee digits and, if entered"/7X,"without a decimal point, are ",
     +  "presumed to start with one.  So make the"/7X," decimal expli",
     +  "cit in entries exceeding .999 or less than .010."/)')
      WRITE(6,'("  >> Note 2: Entry of a letter at any point will ju",
     +  "mp to display of what"/7X,"has been entered so far, followed",
     +  " by option to resume/revise these"/13X,"specifications or qu",
     +  "it with provision for finishing later.")')
      PL = 's '  ! PL(K:); want K=2 if LK = 1, otherwise K=1
C
43    KIK = -1; LKBK = LKOD ! Count changes (none/some would suffice)
45    CALL SHO(NY,NF,KIND,F1,LKOD,LST,LLET,FUZ,2,6)
      IF(KIK<0) THEN ! ******* No need to show pat again if NY<10
        WRITE(6,'(3X,"To accept these parameter specifications, hit ",
     +    "RETURN.  Otherwise, enter")')
        WRITE(6,'(3X,"any letter to revise them, or any numeral to ",
     +    "see the pattern schema again.")')
        CALL SCN(J); IF(J==0) GOTO 99; IF(J>0) GOTO 32; GOTO 51
CC        IF(J>0.AND.NY>9) GOTO 32; GOTO 51
      END IF
      DO I = 1,3; DO J = 1,LLET
          IF(LKOD(I,J)/=LKBK(I,J)) KIK = KIK+1
      END DO; END DO
      IF(KIK>=0) THEN
        IF(KIK==0) WRITE(6,'(/"  You have left these settings unchang",
     +    "ed.  Enter something if you want to"/"  make another edit p",
     +    "ass at them.  Otherwise, hit RETURN to accept them.")')
        IF(KIK>0) WRITE(6,'(/7X,"To accept these revised parameter se",
     +    "ttings, hit RETURN.  Otherwise,"/7X,"enter anything to cor",
     +    "rect them.")')
        CALL SCN(J); IF(J/=0) GOTO 51
      END IF
47    LDT=7; IF(KIND==3) LDT=5; IF(F1(LDT+1:LDT+1)=='.') LDT=LDT+1
      WRITE(6,'("  If you want this schema stored with these altered",
     +  " parameter settings"/"  enter any letter to create a new ",
     +  A," file, or any integer to overwrite"/2X,A,". Otherwise, ",
     +  "hit RETURN to waive archiving these changes.")')
     +  F1(:LDT-1), F1(:LAST(F1))
      CALL SCN(J); IF(J==0) GOTO 99
      IF(J>0) THEN ! Integer calls rewrite
        WRITE(6,'("  Hit RETURN to confirm replacing the parameters ",
     +    "now saved in ",A," with"/"  their present values.  Otherw",
     +    "ise, enter anything to reconsider.")')
        CALL SCN(J); IF(J==0) GOTO 49; GOTO 47
      END IF
      F1 = F1(:LDT)//CF(:JF(MM+1))
49    OPEN(7,FILE=F1,FORM='UNFORMATTED')
      WRITE(7) LST(0),  (LST(I),I=1,LST(0))
      WRITE(7) LLET, ((LKOD(I,J),I=0,3),J=1,LLET)
      CLOSE(7)
      WRITE(6,'("  Changes saved as instructed.")')
      GOTO 99
51    DO L = 1,LLET  ! Start editing
        K = 1; IF(LKOD(0,L)/100==1) K = 2; LTRS(1) = 1  ! KORD must be flagged
54      WRITE(6,'(4X,"Your parameter settings for generating ",A,1X,
     +    "element",A,"coded  ",A,"  are now"/16X,"<Hi,Lo,Pr> = <",
     +    A4,2(1X,A4),">"/4X,"Hit RETURN if OK, or enter preferred ",
     +    "triple with Pr last."/)')  CF(:JF(LKOD(0,L)/100)), PL(K:),
     +    CHAR(MOD(LKOD(0,L),100)), (CLN(.001*LKOD(J,L),4,3),J=1,3)
        CALL SCANR(J,0,'R',LTRS(1))   ! ***** Special return in LTRS
        IF(J==0) CYCLE; IF(J<0) GOTO 32
        JJ = MIN(3,J)
        READ(2,*) (X(I),I=1,JJ)
        DO I = 1,JJ
          IF(X(I)/=NINT(X(I)) .OR. LTRS(I)>0)  CYCLE
57        IF(ABS(X(I))>=1.) THEN; X(I) = .100*X(I)
          GOTO 57; END IF
        END DO
        IF(JJ==1) THEN
          LKOD(1,L) = NINT(1000*X(1)); LKOD(2,L) = LKOD(1,L)
        ELSE IF(JJ>1) THEN
          K = 1; IF(ABS(X(2))>ABS(X(1))) K = 2; M = NINT(SIGN(1.,X(K)))
          LKOD(1,L) = NINT(M*1000*MAX(ABS(X(1)),ABS(X(2))))
          LKOD(2,L) = NINT(M*1000*MIN(ABS(X(1)),ABS(X(2))))
        END IF
        IF(JJ==3) LKOD(3,L) = 1000*ABS(X(3)); IF(JJ<3) LKOD(3,L) = 0
        GOTO 54
      END DO
      GOTO 45
C =============== End of letter specifications ==================
99    WRITE(6,'(" Hit RETURN to instantiate this schema in the group ",
     +  "differences you are"/" creating.  Otherwise, enter anyth",
     +  "ing for return to available alternatives.")')
      CALL SCN(J); Z = 1.
      IF(J/=0) THEN
        WRITE(6,'(" >>> Hit RETURN to confirm that you don''t want to",
     +    " use this schema at present,"/5X,"or enter anything to cor",
     +    "rect what may have been an entry error.")')
        CALL SCN(J); IF(J/=0) GOTO 99
        MSG = 1; RETURN
      END IF
      DO L = 1,LLET; Z = MIN(Z,ABS(.001*LKOD(2,L))); END DO  ! Z is smallest Lo
      WRITE(6,'(" This schema''s ""background"" consists of its nonsal",
     +  "ient (dot-marked) elements."/" If you want those to remain st",
     +  "rictly zero in this instantiation, hit RETURN."/" Otherwise, ",
     +  " enter a letter to fuzz your schema with background noise.")')
      CALL SCN(J); IF(J==0) GOTO 120
130   WRITE(6,'(" This schema''s FUZZ parameter, which will randomize",
     +  " its background elements"/" within FUZZ of zero, is now ",A4,
     +  ".  Hit RETURN if OK; otherwise, enter your"/" preferred FUZZ",
     +  ". (Usually this should be considerably less than your lowest"/
     +  " salience bound, which at present is ",A4," here.)"/)')
     +  CLN(FUZ,4,3), CLN(Z,4,3)
      CALL SCANR(J,1,'R',NUL); IF(J==0) GOTO 114; IF(J<0) GOTO 130
      READ(2,*) FUZ; FUZ = ABS(FUZ)
112   IF(FUZ>=1.) THEN; FUZ = FUZ/10; GOTO 112; END IF
      GOTO 130
114   IF(FUZ>.8*Z .AND. KIND/=3) THEN
        WRITE(6,'(" Do you really want to blur the contrast between ",
     +    "salient and nonsalient"/" loadings here with FUZZ this la",
     +    "rge (",A5,")?  If so, enter anything to"/" confirm.  Othe",
     +    "rwise, hit RETURN to reconsider.")') CLN(FUZ,5,3)
        CALL SCN(J); IF(J==0) GOTO 130
      END IF
120   B=0.  ! ; IF(KIND==3) THEN; DO I=1,NF; B(I,I)=1.; END DO; END IF  ! Unities on COV diagonal
      IF(FUZ>=.005) THEN; S = FUZ/.5
        DO I = 1,NY; L = NF ! ; IF(KIND>2) L = I-1  ! KINDs 3,4 are COV,APATR
          DO J = 1,L; B(I,J) = S*(RANDY()-.5); END DO
        END DO ! Easiest to fuzz all, then overwrite the cells declared salient
      END IF
      DO K = 1,LST(0)
        I = LST(K)/10000; J = MOD(LST(K)/100,100); L = 0
125     L = L+1
        IF(MOD(LKOD(0,L),100)/=MOD(LST(K),100).AND. L<LLET) GOTO 125
        HO = .001*LKOD(2,L); HI = .001*LKOD(1,L); KP = LKOD(3,L)
        Z = ABS(HO) + ABS(HI-HO)*RANDY(); IF(KP==0) Z = SIGN(Z,HI)
        IF( KP>0 .AND. RANDY()<.001*KP ) Z = -Z
        B(I,J) = Z
      END DO  ! MSG = 0  ! Signals return of instantiated schema
      END SUBROUTINE
C
      SUBROUTINE SHO(NY,NF,KIND,F1,LKOD,LST,LLET,FUZ,JOB,KF)
C JOB<=1 shows matrix schema; JOB=2 shows its letter specs; JOB > 2 shows both
C Only negative SHO job in Gendata package so far is -3.
      CHARACTER*4  C0,C1,C2,C3,C4, CH3*3, CLN*8  ! , CK*1
      CHARACTER*12  CF, F1, WRD(25)*3, CC*2   ! , WORD*80
      INTEGER GRID(NY,NF), LKOD(0:3,*), LST(0:*)
      COMMON /CF/ CF
C ========= Start of schema display ==========
      MM = 24; IF(KF/=6) MM = 50
      LF1 = LAST(F1)
      IF(ABS(JOB)==2) GOTO 11
      GRID = 249    ! Show grid zeros by 
cc      CK = 'A'; IF(KIND==3) CK = 'C'; IF(KIND==5) CK = 'M'
      CC = '24'; IF(KF/=6) CC = '50'
      NL = LST(0); IE = 0             ! "//CC//"
      DO K = 1,NL  ! Unpack grid saved in LST
        I = LST(K)/10000; J = MOD(LST(K)/100,100)
        GRID(I,J) = MOD(LST(K),100); IF(KIND/=2) CYCLE
        IF(I<=J) IE = IE+1  ! IE>0 flags not subdiagonal
      END DO
CC      WORD(:11) = ' recursive '; J = 1; IF(KIND==4) J=11
      IF(KF==6) WRITE(KF,'(5X,A," by ",A," schema ",A," is")')
     +  CF(:JF(NY)), CF(:JF(NF)), F1(:LF1)
      IF(KF/=6) WRITE(KF,'(4X,"Schema ",A," is")') F1(:LF1)
      WRITE(KF,'(4X,'//CC//'I3,3(:/6X,'//CC//'I3))') (I,I=1,NF)  ! Indices on top line
      CH3 = 'Ŀ '; IF(NF>MM) CH3 = '   '  ! IF(NF>MM.OR.KIND==3) CH3 = '   '
      WRD=' '; N1 = NF+1 ! ^ MM is number of 3-fields in show line
CC      IF(KIND==3 .AND. NF<=24) THEN
CC        WRD = ' '; N1 = NF+1; WRD(NF:NF) = 'sym'; WRD(N1:N1) = '  '
CC      END IF
      WRITE(KF,'(3X,"",'//CC//'A3,2A3)') ('',I=1,MIN(NF,24)), CH3
      CH3 = '  '; IF(KIND==3) CH3 = '  1'; LSHN = 0; LSHB = 0
      DO K = 1,NY; JJ = NF; L = 1+JJ/MM; IF(KIND==3) JJ = K-1     ! L is lines
        IF(NF<=MM) WRITE(KF,'(I3,"",'//CC//'A3,2A3)') K, ('  '// ! needed to
     +    CHAR(GRID(K,I)),I=1,JJ), CH3, WRD(K+1:N1)               ! show row
        IF(NF>MM) WRITE(KF,'(I3,"",'//CC//'A3/3(:3X,"  ",'//C3//
     +    '(2X,A1)))') K, ('  '//CHAR(GRID(K,I)),I=1,JJ), CH3
        IF(K==1 .AND. KIND==3) WRD(:NF) = '   '
        IF(KF/=6) CYCLE; LSHN = LSHN+L
        IF(LSHN-LSHB>=18.AND.K*L<NY-2) THEN
          CALL WAIT(0); LSHB = LSHN
        END IF
      END DO
      WRITE(KF,'(3X,"",'//CC//'A3,A3)') ('',I=1,MIN(NF,MM))," "
      IF(ABS(JOB)<2) RETURN
C ==================== End of schema display ======================
11    IF(JOB>1) WRITE(KF,'(3X,A,"''s current parameter assignments ",
     +  "are")') F1(:LF1)
      IF(JOB<0) WRITE(KF,'(4X,"under specification parameters")')
      MM = 17; IF(KF/=6) MM = LLET
      C1 = 'Ŀ  '; C2 = '   '; C3 = 'Ĵ  '; C4 = '  '; C0 = '   '
      IF(LLET>MM) THEN; C1 = ' '; C2 = ' '; C3 = ' '; C4 = ' '; END IF
      WRITE(KF,'(6X,"",20A)') ((""),I=1,MIN(LLET,MM)), C1
      WRITE(KF,'(6X,"",40A)') ('   ',CHAR(MOD(LKOD(0,I),100)),I=1,
     +  MIN(LLET,MM)), C2
      WRITE(KF,'(" ",60A)') ((""),I=1,MIN(LLET,MM)), C3
      WRITE(KF,'("  Hi ",60(1X,A3))') (CLN(.001*LKOD(1,I),3,2),I=1,
     +  MIN(LLET,MM)), C0
      WRITE(KF,'("  Lo ",60(1X,A3))') (CLN(.001*LKOD(2,I),3,2),I=1,
     +  MIN(LLET,MM)), C0
      WRITE(KF,'("  Pr ",60(1X,A3))') (CLN(.001*LKOD(3,I),3,2),I=1,
     +  MIN(LLET,MM)), C0
      WRITE(KF,'(" ",60A)') ((""),I=1,MIN(LLET,MM)), C4
      IF(LLET>MM) THEN; K = 34-LLET    ! K + LLET-17 = 17
        C1 = ''; C2 = ''; C3 = ''; C4 = ''
        WRITE(KF,'(7X,20A)') ('    ',I=1,34-LLET), ('',I=18,LLET),C1
        WRITE(KF,'(7X,20A4)') ('    ',I=1,34-LLET),  ('   ',CHAR(MOD(
     +    LKOD(0,I),100)),I=18,LLET), C2
        WRITE(KF,'(7X,20A)') ('    ',I=1,34-LLET), ('',I=18,LLET),C3
        WRITE(KF,'(7X,20(1X,A3))') ('    ',I=1,34-LLET),(CLN(.001*LKOD(
     +    1,I),3,2),I=18,LLET), C0
        WRITE(KF,'(7X,20(1X,A3))') ('    ',I=1,34-LLET),(CLN(.001*LKOD(
     +    2,I),3,2),I=18,LLET), C0
        WRITE(KF,'(7X,20(1X,A3))') ('    ',I=1,34-LLET),(CLN(.001*LKOD(
     +    3,I),3,2),I=18,LLET), C0
        WRITE(KF,'(7X,20A)') ('    ',I=1,34-LLET), ('',I=18,LLET),C4
      END IF
      IF(KF/=6 .AND. FUZ>.005) WRITE(KF,'(3X,"and level ",A3," ba",
     +  "ckground fuzz.")') CLN(FUZ,3,2)
      END SUBROUTINE

      SUBROUTINE DAY(N)
C This date-stamps output file N
      CHARACTER ZZZ*8, WORD*18, CF*12, LST(12)*10
      COMMON /CF/ CF
      DATA LST/'January  7','February 8','March    5','April    5',
     +         'May      3','June     4','July     4','August   6',
     +         'September9','October  7','November 8','December 8'/
      CALL DATE_AND_TIME(ZZZ)  ! Last three outputs not used here
      M = 10*(ICHAR(ZZZ(7:7))-48) + ICHAR(ZZZ(8:8))-48  ! M gets day of month
      READ(ZZZ(5:6),*) L; K = ICHAR(LST(L)(10:10))-48
      WORD = CF(:JF(M))//' '//LST(L)(:K)//' '//ZZZ(:4)
      WRITE(N,'(/15X,"Date of this transcription:  ",A)') WORD
      END SUBROUTINE
C
      SUBROUTINE WAIT(N)
C  N > 0 calls for N spaces before screen display
      DO I = 1,N; WRITE(6,'()'); END DO
      WRITE(6,'(" Hit RETURN to continue")')
      READ(5,'(A1)')
      RETURN
      END
C=================================================================
      SUBROUTINE ISORT(N,LST)
C Sort LST integers into ascending (or descending) order
      INTEGER LST(*)
      DO J = 2,N; L = LST(J)
        DO I = J-1,1,-1
          IF(LST(I)<=L) GOTO 12    ! Increasing order
C          IF(LST(I)>=L) GOTO 12    ! Decreasing order
          LST(I+1) = LST(I)
        END DO
        I = 0
12      LST(I+1) = L
      END DO
      END SUBROUTINE
C
      SUBROUTINE RANSEL(NS,NT,LSET) !,LTAG,METH)
C This randomly selects NS of integers 1 to NT, and returns the selected
C sequence in array LSET. Selection is WITHOUT replacement if METH = 0; other-
C wise, WITH replacement.  Under METH = 0, LTAG(i) = J (otherwise 0) if item i
C has been selected and has index position J when the selected items are put
C into ascending order.  Under METH > 0, LTAG(i) is the number of times item i
C has been selected while METH returns the max number of times any one number
C has been selected.  The random generator must have been seeded previously.
CC *** MORSCOR initializes LSET prior to call
      INTEGER LSET(*) ! , LTAG(*)
cc >>> In this application, LSET is received with integers 1,2,...,NT
CC      DO I = 1,NT; LSET(I) = I; END DO  ! LTAG(I) = 0;
C       Note: Can make initial I-sequence in LSET any numeric input list
cc      IF(METH>0) GOTO 50
C Make selection WITHOUT replacement
      IF(NT<NS) THEN
        WRITE(6,'(/" *** ERROR: The range of integers sent to RAN",
     +   "SEL is smaller than the selection count.")'); STOP
      END IF
      DO I = 0,NS-1; I1 = I+1
        K = MIN(NT,I1+INT((NT-I)*RANDY())) ! Ran-select K between I+1 and NT
        L = LSET(K); LSET(K) = LSET(I1); LSET(I1) = L  ! ; LTAG(L) = K
      END DO ! ^Exchange LSET terms in positions I+1 and K
cc      K = 0  ! ^Nonzero LTAG(I) flags that I was selected
cc      DO I = 1,NT; IF(LTAG(I)==0) CYCLE
cc        K = K+1; LTAG(I) = K
cc      END DO
      RETURN
CCC Make selection WITH replacement
CC50    DO I = 1,NS
CC        K = MIN(NT,1+INT(NT*RANDY()))
CC        LSET(I) = K; LTAG(K) = LTAG(K)+1
CC      END DO
CC      METH = 0
CC      DO I = 1,NT; METH = MAX(METH,LTAG(I)); END DO
CC      END SUBROUTINE
      END SUBROUTINE

