
C Program SAMPLCOVS.  (Source code, FORTRAN-90.  EIGLIB must also be loaded.)
C
C                    Last revised:  8 February 2003
C
C Simulate covariances within a random sample of NS subjects from a covariance
C matrix in file KOV<nf><end>.<ext> treated as a population correlation matrix.
C Each sample cov produced on the run has name <km>KOV<nf><en>.<*><i> where km
C is the 1st digit of NS followed by the number of digits in NS, <en> is as
C much of <end> as room allows, <i> is a serial index, and <*> is as much of
C <ext> as has room.

      LOGICAL QT
      CHARACTER*12 F1, F2, CF, NAME(40), WORD*100, FMT*20, EXT*3   ! CLN*8,
      INTEGER LIST(2,20)
      REAL,ALLOCATABLE :: CV(:), CS(:,:), CZ(:), R(:), T(:,:)
      COMMON /CF/ CF
      LO(I,J) = J*(J-1)/2 + I
      LOC(I,J) = LO(MIN(I,J),MAX(I,J))
      DATA LLEN,NND,KLT,LWRP/150,3,1,1/ ! Cov-formatting defaults
      OPEN(2,STATUS='SCRATCH')
      INQUIRE(FILE='KOVFRM',EXIST=QT)
      IF(QT) THEN ! >>> Blank entry is read as 0 before branching to ERR
        OPEN(7,FILE='KOVFRM')
        READ(7,*,ERR=5) M; LLEN = MAX(10,MIN(240,M))
        READ(7,*,ERR=5) M; NND = MAX(3,MIN(5,M))
        READ(7,*,ERR=5) M; KLT = MAX(0,MIN(1,M))
        READ(7,*,ERR=5) M; LWRP = MAX(0,MIN(1,M))
        GOTO 7
      END IF
5     QT = .FALSE.
7     CLOSE(7)
      MXL = LLEN/(NND+2)  !  Code for reading/writing COV-files
      FMT = '('//CF(:JF(MXL))//'I'//CF(:JF(NND+2))//')'

CC test lines
C      OPEN(21,FILE='JUNK')

      CALL SYSTEM('cls')
c    Ŀ
c      Given the covariances among NV variables in a real or pretend     4
c      population of subjects, this program derives the simulated        7
c      standardized covariances among these variables in one or more     4
c      random samples of stipulated sizes NS from this population under  1
c      presumption that the sampled distribution is multi-Normal.        7
c    
      WRITE(6,'(//4X,"",67(""),"")')
      WRITE(6,'(4X,"  Given the covariances among NV variables in ",
     +  "a real or pretend",4X,""/4X,"  population of subjects, thi",
     +  "s program derives the simulated",7X,""/4X,"  standardized ",
     +  "covariances among these variables in one or more",4X,""/4X,
     +  "  random samples of stipulated sizes NS from this populatio",
     +  "n under "/4X,"  presumption that the sampled distribution ",
     +  "is multi-Normal.",7X,"")')
      WRITE(6,'(4X,"",67(""),""/)'); KK = 1
      WRITE(6,'("  The input filename must have form KOVi*.*, where ",
     +  "i is an integer that by"/"  rights is the 1st digit of NV t",
     +  "hough SAMPLCOV will let you fake that."/"  The so-named fil",
     +  "es currently available here are")')
9     CALL LOOK(1,'KOV*.*',NAME,40,N)
      IF(N==0) WRITE(6,'(/ " No identifiable KOV-files here. Go ",
     +  "get one.")'); IF(N==0) STOP
      NN = 1
10    F1 = NAME(NN); LF1 = LAST(F1); LD = LF1-3;
12    IF(F1(LD:LD)/='.') THEN; LD=LD+1; GOTO 12; END IF  ! LD is dot position
20    IF(N>1) WRITE(6,'(/" The KOV-file now chosen is ",A,".  Hit RET",
     +  "URN if OK,"/" or enter the index of another selection ",
     +  "from this list."/)') F1(:LF1)
      IF(N==1) WRITE(6,'(/" Only one KOV-file, ",A,", is now availab",
     +  "le.  Hit RETURN if OK,"/" or enter anything to quit. ")')
     +  F1(:LF1)
      CALL SSCN(J); IF(N==1 .AND. J/=0) STOP
      IF(J<0) GOTO 20
      IF(J>0) THEN
        READ(2,*) NN
        NN = MAX(1,MIN(NN,N))
        GOTO 10
      END IF
cc      WRITE(6,'(" Loading file ",A," . . . .")') F1(:LF1)
      CALL START(4,F1,KK)  ! K is the number of header lines
      READ(4,*) NV, NVV
      IF(NVV/=LO(NV,NV)) THEN
        WRITE(6,'(/" *** ERROR: File ",A," fails on line ",A," to ",
     +    "declare sym-storage.")') F1(:LF1), CF(:JF(KK+1)); STOP
      END IF
      IF(KK==0) THEN
        WRITE(6,'(" File ",A," contains covariances for ",A," variab",
     +    "les, but no header"/" information.  Hit RETURN to contin",
     +    "ue, or any letter to abort.")') F1(:LF1), CF(:JF(NV))
      ELSE
        REWIND 4
        WRITE(6,'(" Header information in file ",A," of covariances",
     +    " for ",A," variables is")') F1(:LF1), CF(:JF(NV))
        DO I = 1,KK
          READ(4,'(A)') WORD; LL = MIN(78,LAST(WORD))
          IF(LL>77) THEN; LL = 77; WORD(76:78) = '...'; END IF
          IF(LL>0) WRITE(6,'(" [ ",A)') WORD(:LL)
        END DO
        WORD = ' choose again.'; IF(N<2) WORD = ' stop.         '
        WRITE(6,'(/" Hit RETURN to continue, or any letter to",A)')
     +    WORD(:14)
      END IF
      CALL SSCN(J); IF(J/=0 .AND. N<2) STOP; IF(J/=0) GOTO 9
      CLOSE(4); CALL START(4,F1,KK)
      READ(4,*) NV, NVV
      ALLOCATE ( CV(NVV), CS(NV,NV), T(NV,NV), CZ(NVV), R(NV) )
      READ(4,*) (CV(I),I=1,NVV)
      DO I = NVV,1,-1
        CV(I) = CV(I)/CV(1)
      END DO       ! CV uploads the input covariances
      CLOSE(4)
      F2 = 'xx'//F1(:LD); LD2 = MIN(9,LD+2)   ! Dot position in output filename F2
      F2 = F2(:LD2-1)//'.*'; EXT = F1(LD+1:); NLL = 0 ! Count leading letters in ext
      DO I = 1,2; IF(ICHAR(EXT(I:I))<65) EXIT; NLL = NLL+1; END DO
      WRITE(6,'(/" Computing this KOV''s principal components ",
     +  ". . . . ."/)')
      CALL EIGS(NV,NV,CV,NVV,R,T,NV,1,IER,2)
      DO J = 1,NV
        S = SQRT(MAX(0.,R(J)))
        DO I = 1,NV
          T(I,J) = T(I,J)*S
        END DO
      END DO
C
C   Assuming that xxxxxxxxxx holds population covariances for xxxx variables
C   whose joint distribution is multi-Normal, the correlations among these
C   in one or more size-NS random samples from this population will now be
C   Odell/Feiveson simulated for your listing of one or more choices of NS.
C   Each sampling result will be recorded in a separate ASCII file named
C   <km>",A,"<ext>, wherein <km> is the 1st digit of NS followed by the
C   number of digits in NS, and <ext> is a sequential index preceded by as
C   much of the input KOV-name's letter extension as space allows.
C   NOTE: The algorighm requires NS to exceed the number of variables.

      WRITE(6,'(3X,"Assuming that ",A," holds population covariances ",
     +  "for ",A," variables"/3X,"whose joint distribution is multi-N",
     +  "ormal, the correlations among these"/3X,"in one or more size",
     +  "-NS random samples from this population will now be"/3X,"Ode",
     +  "ll/Feiveson simulated for your listing of one or more choice",
     +  "s of NS."/3X,"Each sampling result will be recorded in a sep",
     +  "arate ASCII file named"/3X,"<km>",A,"<ext>, wherein <km> is ",
     +  "the 1st digit of NS followed by the"/3X,"number of digits in ",
     +  "NS, and <ext> is a sequential index preceded by as"/3X,"much ",
     +  "of the input KOV-name''s letter extension as space allows.")')
     +  F1(:LF1), CF(:JF(NV)), F2(3:LD2)
      WRITE(6,'(3X,"(NOTE: The algorithm requires NS to exceed the ",
     +  "number of variables.)")')
      NL = 0
30    WRITE(6,'(//"  Enter on one line the different sample sizes NS ",
     +  "> ",A," you want to simulate,"/"  each followed after a spac",
     +  "e by the number NR of samples you want of that"/"  size.  Pu",
     +  "nctuation isn''t needed; but if you list several <NS,NR> pai",
     +  "rs,"/"  a mark after each NR may decrease your risk of an ",
     +  "entry omission."/)') CF(:JF(NV))

32    IF(NL>0.) THEN; IER = 0
        DO I = 1,NL
          LIST(2,I) = MIN(LIST(2,I),999) ! Surely never except by accident
          IF(LIST(1,I)<LIST(2,I)) IER = IER+1
        END DO
        IF(IER>0) WRITE(6,'(" ??? Are you sure you want repetition co",
     +    "unts (",A,") larger than sample size ???")') CF(:JF(IER))
        WRITE(6,'(/" Your list of <NS,NR> pairs is now")')
        WRITE(6,'(1X,20(1X,A,"(",A,")"))') ((CF(:JF(LIST(J,I))),
     +    J=1,2),I=1,NL)
        WRITE(6,'(" Hit RETURN if OK; otherwise enter new list."/)')
      END IF
      CALL SSCN(J)
      IF(J<0 .OR. J==0.AND.NL==0) GOTO 30; IF(J==0) GOTO 40
      NL = J/2
      READ(2,*) ((LIST(K,I),K=1,2),I=1,NL)
ccc      DO I = 1,NL  ! Round entries to nearest multiple of 10  !! No point??
ccc        LIST(1,I) = MAX(10,10*NINT(.1*LIST(1,I)))
ccc      END DO
      CALL JSORT(NL,LIST,1); NO = 0   ! Sort into ascending NS order
      DO I=1,NL; IF(LIST(1,I)>NV) EXIT; NO=NO+1; END DO
      IF(NO>0) THEN; NL = NL-NO;
        DO I = 1,NL
          LIST(1,I) = LIST(1,I+NO); LIST(2,I) = LIST(2,I+NO)
        END DO
      END IF
      IF(NL<1) THEN
        WRITE(6,'(4X,"You haven''t entered any acceptable <NS,NR> pa",
     +    "irs.  Hit RETURN"/4X,"to try again, or enter anything to ",
     +    "abort.")')
        CALL SSCN(J); IF(J==0) GOTO 30
      END IF
      GOTO 32
C
40    DO KK = 1,NL  ! End of this DO terminates the run
        NS = LIST(1,KK)
        J = JF(NS); F2(:2) = CF(:1)//CHAR(J+48)
        WRITE(6,'(/" Computing sample covariances for NS = ",A)')
     +    CF(:JF(NS))
        DO KKK = 1,LIST(2,KK)
          CALL JITCOV(NV,NS,CZ,CS)

C Efficient style of getting matrix products Q = A*B*C and R = B*C:
C Q(i,j) = kl A(i,k)*B(k,l)*C(l,j) = k A(i,k)*(l B(k,l)*C(l,j) ); so
C     Initialize Q = 0
C     DO J = 1,MaxJ   !   A => T, B => CZ, C => T'
C       DO K = 1,MaxK; R(K,J) = 0
C         DO N = 1,MaxN; R(K,J) = R(K,J) + B(K,N)*C(N,J); END DO
C         DO I = 1,MaxI; Q(I,J) = Q(I,J) + A(I,K)*R(K,J); END DO
C     END DO; END DO

C  Compute T*CZ*T'
          CV = 0.
          DO J = 1,NV; DO K = 1,NV
              CS(K,J) = 0.
              DO N = 1,NV
                CS(K,J) = CS(K,J) + CZ(LOC(K,N))*T(J,N)
              END DO
              DO I = 1,J; IJ = LO(I,J)
                CV(IJ) = CV(IJ) + T(I,K)*CS(K,J)
              END DO
          END DO; END DO
          DO J = 1,NV   ! Save SDs before normalization; then normalize
            R(J) = SQRT(CV(LO(J,J)))
            CV(LO(J,J)) = 1.
            DO I = 1,J-1
               S = R(I)*R(J)
               CV(LO(I,J)) = CV(LO(I,J))/S
            END DO
          END DO   ! Rem: NLL is no. leading chars in input EXT
CC          J = JF(NS); WORD = CF(:J); WORD(2:2) = CHAR(J+48)
          J = JF(KKK)  ! rem: KKK is index of repetition within NS set
          IF(NLL<=1) EXT(NLL+1:) = CF(:J)
          IF(NLL>=2) EXT(4-J:) = CF(:J)
          F2 = F2(:LD2)//EXT
          OPEN(7,FILE=F2)
          WRITE(7,'(" Simulated sample correlations (NS = ",A,") from",
     +      " population covariances ",A)') CF(:JF(NS)), F1(:LF1)
          KP = 10**NND; M = NVV; IF(KLT==0) M = NV*NV
          WRITE(7,'(2(1X,A))') CF(:JF(NV)), CF(:JF(M))
          IF(LWRP==1) THEN    ! Rem: KLT=1 is LowerTriangle
            IF(KLT==1) WRITE(13,FMT) (NINT(KP*CV(J)),J=1,NVV)
            IF(KLT==0) THEN
              DO I = 1,NV
                WRITE(7,FMT) (NINT(KP*CV(LOC(I,J))),J=1,NV)
              END DO
            END IF
          END IF
          IF(LWRP==0) THEN ! Line breaks at end of array rows
            DO J = 1,NV
              JJ = J; IF(KLT==0) JJ = NV
              WRITE(7,FMT) (NINT(KP*CV(LOC(I,J))),I=1,JJ)
            END DO
          END IF
          WRITE(7,'(/" SDs in sample before variance normalization:")')
          WRITE(7,FMT) (NINT(KP*R(I)),I=1,NV)
ccc          WRITE(7,'(25(1X,A5))') (CLN(R(I),5,3),I=1,NV)
        END DO   ! End repetition within NS-set
        WRITE(6,'(" Sample correlations for NS = ",A," are now fil",
     +    "ed under basename ",A)') CF(:JF(NS)), F2(:LD2-1)
      END DO
      WRITE(6,'(/" *** Simulated sample covariances are done ***")')
      STOP
      END
C
      FUNCTION JF(N)
C Return character expression of integer N left-justified in field CF; then
C CF(:JF(N)) writes N with exactly the right length in format specifier A.
      CHARACTER*12 CF
      INTEGER(4) K
      COMMON /CF/ CF
      K = ABS(N)
      CF = '            '
      J = 13
10    J = J-1
      CF(J:J) = CHAR(48+MOD(K,10))
      K = K/10
      IF(K>0) GOTO 10
      IF(N<0) CF(J-1:J-1) = '-'
      CF = ADJUSTL(CF)
      JF = LEN_TRIM(CF)
      END FUNCTION
C
      FUNCTION CLN(X,NFF,ND)
C Express real number X as a character string in fieldwidth NF with LD decimals
C when room, where LD = ABS(ND).  ND<0 tries to precede all positive numbers
C with a blank. LD > 9 displays zero decimals and no decimal point while
C returning X = 0 as ND-10 zeros right-justified in selected field.
C ***** WARNING: If a call of CLN prints garbage, you have forgotten to
C       declare CLN as CHARACTER*8 in the calling routine.
      PARAMETER (KW=16)
      CHARACTER CLN*8, WK(KW)
      CLN = '        '
      NF = MIN(8,NFF)  ! Limit fieldwidth to 8 chars
      LD = ABS(ND)
      IF(ABS(X)<1.0E-12) THEN !  Special for vanishingly small X
        N = MIN(NF-1,MOD(LD,10))
        IF(LD<10) CLN(NF-N:NF+1-N) = '.0'
        IF(LD<10) RETURN
        DO I = 1,N
          CLN(NF+1-I:NF+1-I) = '0'
        END DO
        RETURN
      END IF
      M = NF; IF(ABS(X)>1.) M = NF-1-INT(LOG10(ABS(X))) !  M is space free for decimal (or M-1 if X<0) )
      IF(M<0 .OR.  M<1.AND.X<0.) GOTO 55
      IF(ND>=10) LD = 0; LD = MIN(LD,M)
      DO I = 1,KW
        WK(I) = ' '
      END DO
      IF(LD==0) N = NINT(ABS(X))         ! Shouldn't be needed, but is
      IF(LD/=0) N = NINT(ABS(X)*10**LD)  ! This can overflow if LD is large
      DO I = KW,KW-LD+1,-1
        WK(I) = CHAR(48+MOD(N,10))
        N = N/10
      END DO
      WK(KW-LD) = '.'
      IF(N==0 .AND. LD==0) WK(KW-LD-1) = '0'
      IF(N==0 .AND. X<0. .AND. LD>0) WK(KW-LD-1) = '-'
      DO I = KW-LD-1,2,-1
        IF(N>0) WK(I) = CHAR(48+MOD(N,10))
        IF(N>0 .AND. X<0.) WK(I-1) = '-'
        N = N/10
      END DO
      KS = KW-NF+1
25    KS = KS-1
C       Field returned will start at WK(KS+1) for initial KS
      IF(KS<=0) GOTO 50
      IF(ND>=0) THEN
        IF(WK(KS)/=' ' .AND. WK(KS+NF)/='.') GOTO 25
      ELSE
        IF(WK(KS+1)/=' '. AND. WK(KS+1)/='-' .AND. WK(KS+NF)/='.')
     +    GOTO 25
      END IF
      IF(ND>=10) KS = MAX(1,KS-1)
      DO I = 1,NF
        CLN(I:I) = WK(KS+I)
      END DO
50    IF(WK(KS)==' ') RETURN
55    CLN = ' *******'
      END FUNCTION
C
      SUBROUTINE JITCOV(NV,NS,CJIT,WK)
C Return in CJIT a simulated sample covariance matrix for NV variables when
C sample size is NS and the population covariances are orthonormal.  The
C algorithm is by Odell & Feiveson (J. Amer. Stat. Assn., l966) with their
C ChiSq-distributed terms on the diagonal of workspace WK approximated by
C the Wilson/Hifferty formula they recommend for this.  To simulate sampling
C from a population covariance matrix CV, first generate CJIT and then
C compute A*CJIT*A' where A is a Gram-factor of CV.
C ***** WARNING: Make sure that the program initializes ISEED.
C ***** WARNING: JITCOV output sometimes has negative eigenvalues.
      CHARACTER CF*12
      REAL CJIT(*), WK(*)  ! CJIT and WK must be at least length LO(NV,NV)
      COMMON/CF/ CF
      LO(I,J) = J*(J-1)/2 + I
      IF(NS<=NV) THEN
        WRITE(6,'(" *** Error: JITCOM requires NS (now ",A,") to be ",
     +    "greater than NV (now ",A,")")') CF(:JF(NS)), CF(:JF(NV))
        STOP
      END IF
      DO J = 1,LO(NV,NV)
        WK(J) = ZRAND()
      END DO
      DO J = 1,NV
        DF = FLOAT(NS-J)
        R = 2./(9.*DF)   ! For Wilson-Hifferty approximation
11      ZZZ = DF*(1 - R + ZRAND()*SQRT(R))**3  ! Wilson-Hifferty approx.
        IF(ZZZ<=0.) GOTO 11
        WK(LO(J,J)) = ZZZ
      END DO
      DO J = 1,NV
        DO I = 1,J
          IF(I==J) CJIT(LO(J,J)) = WK(LO(J,J))
          IF(I<J) CJIT(LO(I,J)) = WK(LO(I,J))*SQRT(WK(LO(I,I)))
          DO K = 1,I-1
            CJIT(LO(I,J)) = CJIT(LO(I,J)) + WK(LO(K,I))*WK(LO(K,J))
          END DO
        END DO
      END DO
      DO J = 1,LO(NV,NV)
        CJIT(J) = CJIT(J)/NS
      END DO
      END SUBROUTINE

      FUNCTION LAST(WORD)
C This left-justifies leading substring WORD(:M) of WORD, and returns its
C length as LAST. If the string is empty, LAST is returned as 0.
      CHARACTER WORD*(*)
      M = LEN(WORD)
      WORD(:M) = ADJUSTL(WORD(:M))
      LAST = LEN_TRIM(WORD(:ABS(M)))
      END FUNCTION
C
      SUBROUTINE LOOK(K,GET,NAME,ML,NL)
C LOOK calls DOS to delete or report files named in GET, with action set by K.
C K/2 = 0,1 initial-lists/append-lists GET in buffer file ZZZ. MOD(K,2) = 0,1
C stores/shows-to-screen the GET list. So K=0 initial-stores; K=1 initial-
C shows; K=2 append-stores; and K=3 append-shows. The last filename matching
C the GET template is returned in WORD with its length M.  NAME returns the
C list of template matches, the number of which is NL, and prints the numbered
C list to screen.  ML is max NL allowed by array allocation.
      LOGICAL PRM, QY
      CHARACTER*12 GET*(*), NAME(*), WORD*40, WD*40, TMP
      WD = GET; M = LAST(WD)
      LL = 1
5     LL = LL+1; IF(LL<M) GOTO 5
      WD(M+2:M+LL+1) = WD(:LL); WD(40:40) = ' '  ! Shd now always have LL = M
      DO I = M+2,M+LL+1
        IF(WD(I:I)=='*' .OR. WD(I:I)=='?' ) THEN
          WD(40:40) = '!'; WD(I:I) = '!'
        END IF
      END DO
      INQUIRE(FILE=WD(M+2:M+LL+1),EXIST=QY)
      IF(.NOT.QY) OPEN(19,FILE=WD(M+2:M+LL+1)) ! Precludes no-match error message
      IF(K/2==0) CALL SYSTEM('dir '//WD(:M)//' >ZZZ')
      IF(K/2>0) CALL SYSTEM('dir '//WD(:M)//'>>ZZZ')
      IF(.NOT.QY) CLOSE(19,STATUS='DELETE')
      IF(MOD(K,2)==0) RETURN
      OPEN(4,FILE='ZZZ')
      NL = 0
10    READ(4,'(A)',END=50) WORD
      IF(WORD(:1)==' ' .OR. WORD(:1)=='.') GOTO 10
      IF(WORD(25:26)==' 0' .OR. WORD(16:16)=='<') GOTO 10  ! No directory names
C       Filter out lines other than filenames
      J = ICHAR(WORD(4:4)); IF(J<49 .OR. J>57) GOTO 10
      DO I = 1,LAST(WORD(:14)) !    ^ Must have digit following "KOV" start
        IF(WORD(I:I)=='!') GOTO 10
      END DO
19    L = 0
20    L = L+1
      IF(WORD(L+1:L+1)/=' ' .AND. L<8) GOTO 20
      IF(WORD(10:10)/=' ') WORD(L+1:L+4) = '.'//WORD(10:12)
      DO I = 1,NL  !  Eliminate possible duplications
        IF(NAME(I)(:L+4)==WORD(:L+4) .AND. NAME(I)(L+5:L+5)==' ')
     +    GOTO 10
      END DO
      NL = NL+1
      NAME(NL) = WORD(:L+4)//'     '
      M = L+4
      IF(NL<ML) GOTO 10
50    IF(NL==0) M = 0
      CLOSE(4,STATUS='DELETE')
      DO J = 2,NL
        TMP = NAME(J)
        DO I = J-1,1,-1
          IF(.NOT.PRM(NAME(I),TMP)) GOTO 55    ! Increasing order
          NAME(I+1) = NAME(I)
        END DO
        I = 0
55      NAME(I+1) = TMP
      END DO
      IF(NL>0) WRITE(6,'(20(:/4(I5,". ",A,:)))') (I,NAME(I),I=1,NL)
      IF(NL>0) WORD(:12) = NAME(NL)
      RETURN
      END

      FUNCTION PRM(NAM1,NAM2)
C Consider both base and extension when flagging which filename comes first
C in alphanumeric listing.  PRM=t says that NAM2 comes before NAM1.
      LOGICAL PRM
      CHARACTER NAM1*(*), NAM2*(*)
      PRM = .FALSE.
      L1 = LAST(NAM1); L2 = LAST(NAM2)
      N1 = L1+1; N2 = L2+1  ! Find dot positions, if any
10    N1 = N1-1; IF(NAM1(N1:N1)/='.' .AND. N1>1) GOTO 10
20    N2 = N2-1; IF(NAM2(N2:N2)/='.' .AND. N2>1) GOTO 20
      IF(N1==1) N1=L1+1; IF(N2==1) N2=L2+1  ! Where dot would be were there one
      JJ = KPRM(NAM1(:N1-1),NAM2(:N2-1))
      IF(JJ==-1) PRM = .TRUE.; IF(JJ/=0) RETURN  ! JJ=0 if basenames are same
      IF(JJ==0 .AND. (N1>L1 .OR. N2>L2)) THEN  ! An extension is blank
        IF(N2>L2) PRM = .TRUE.; RETURN
      END IF
      JJ = KPRM(NAM1(N1:L1),NAM2(N2:L2))  ! Include extension dot
      PRM = .FALSE.; IF(JJ==-1) PRM = .TRUE.
      END FUNCTION

      FUNCTION KPRM(WRD1,WRD2)
C Return value 0 if WRD1=WRD2; otherwise  -1 or +1 according to whether WRD2
C comes before or after WRD1 in alphanumeric sequence.
      INTEGER KPRM
      CHARACTER WRD1*(*), WRD2*(*)
      L1 = LAST(WRD1); L2 = LAST(WRD2)
      KPRM = 0; IF(WRD1(:L1)==WRD2(:L2)) RETURN
      N1 = L1+1; N2 = L2+1    ! Find position preceding terminal number string
10    N1 = N1-1; N = ICHAR(WRD1(N1:N1))
         IF(N>47.AND.N<58 .AND. N1>1) GOTO 10
20    N2 = N2-1; N = ICHAR(WRD2(N2:N2))
         IF(N>47.AND.N<58 .AND. N2>1) GOTO 20
      IF(LLT(WRD1(:N1),WRD2(:N2))) KPRM = 1
      IF(LLT(WRD2(:N2),WRD1(:N1))) KPRM = -1
      IF(WRD1(:N1)/=WRD2(:N2)) RETURN
      IF(N1==L1 .OR. N2==L2) THEN  ! A number terminus is blank
        KPRM = 1; IF(N2==L2) KPRM = -1; RETURN
      END IF
      READ(WRD1(N1+1:L1),*) K1; READ(WRD2(N2+1:L2),*) K2
      KPRM = 1; IF(K2<K1) KPRM = -1
      END FUNCTION
C
      FUNCTION RAN2()
C This is a reduction of RANGEN to its variant KTYP=6 (formerly KTYP=2),
C producing a random number from the current generator state. ISEED must
C first be generated in MAIN. KTYPs 2 and 4 can also be instated below.
      REAL WK(128)
      DOUBLE PRECISION DSEED, DSEED1, DSEED2, D2A, D2M
      COMMON /RND/ ISEED
      SAVE D2A, D2M, INIT, DSEED, WK
      DATA  D2M/2147483647.0D0/, INIT/1/
C On first call, initialize generator state DSEED and shuffle-register WK
      IF(INIT/=1) GOTO 50
      INIT = 0
      CALL TMSEED(ISEED)
      DSEED = DBLE(MAX(1,MIN(2147483646,ISEED)))
C           Determine scaling factor for unit interval U(0,1)
      D2A = 2147483647.0D0
      TEMP = 2147483646.0D0/D2A
      IF (TEMP<1.0) GOTO 15
      D2A = 2147483655.0D0
      TEMP = 2147483646.0D0/D2A
      IF (TEMP<1.0) GOTO 15
      D2A = 2147483711.0D0
10    CONTINUE
      TEMP = 2147483646.0D0/D2A
      IF(TEMP>=1.0) THEN
         D2A = D2A + 8.0D0
         GO TO 10
      END IF
15    CONTINUE

C            Use KTYP=2 multiplier 16807
C      DO I = 1,128  !
C         DSEED = DMOD(16807.0D0*DSEED,D2M)
C         WK(I) = DSEED/D2A
C      END DO
C            Use KTYP=4 multiplier 397304094
C      DO I = 1,128
C         DSEED1 = DMOD(32768.0D0*DSEED,D2M)
C         DSEED2 = DMOD(23166.0D0*DSEED,D2M)
C         DSEED = DMOD(12121.0D0*DSEED1+DSEED2,D2M)
C         WK(I) = DSEED/D2A
C      END DO

C            Use KTYP=6 multiplier 950706376
       DO I = 1,128
          DSEED1 = DMOD(32768.0D0*DSEED,D2M)
          DSEED2 = DMOD(8392.0D0*DSEED,D2M)
          DSEED = DMOD(29013.0D0*DSEED1+DSEED2,D2M)
          WK(I) = DSEED/D2A
       END DO
C The above is done only on the initial call
C
50    CONTINUE

C Generate random number RAN2 and update DSEED

C          Use the multiplier 16807 with shuffling (KTYP=2)
C      DSEED = DMOD(16807.0D0*DSEED,D2M)
C          Use the multiplier 397204094 with shuffling (KTYP=4)
C      DSEED1 = DMOD(32768.0D0*DSEED,D2M)
C      DSEED2 = DMOD(23166.0D0*DSEED,D2M)
C      DSEED = DMOD(12121.0D0*DSEED1+DSEED2,D2M)

C          Use the multiplier 950706376 with shuffling (KTYP=6)
      DSEED1 = DMOD(32768.0D0*DSEED,D2M)
      DSEED2 = DMOD(8392.0D0*DSEED,D2M)
      DSEED = DMOD(29013.0D0*DSEED1+DSEED2,D2M)
      J = DMOD(DSEED,128.0D0) + 1.0D0
      X = DSEED/D2A
      RAN2 = WK(J)
      WK(J) = X
      RETURN
      END
C
      SUBROUTINE JSORT(N,LST,KD)
C Sort N pairs received in LST into ascending 1st-place order returned in
C LST with duplications removed if KD>0.  In that case, N returns the number
C of distinct list items. [Sort on LST(1,-)]
      INTEGER LST(2,*)
      IF(N<=1) RETURN
10    DO J = 2,N
        L = LST(1,J); M = LST(2,J)
        DO I = J-1,1,-1
          IF(LST(1,I)<=L) GOTO 12
          LST(1,I+1) = LST(1,I); LST(2,I+1) = LST(2,I)
        END DO
        I = 0
12      LST(1,I+1) = L; LST(2,I+1) = M
      END DO
      IF(KD==0) RETURN
      NN = 1
      DO I = 2,N
        IF(LST(1,I)==LST(1,NN)) CYCLE
        NN = NN+1
        LST(1,NN) = LST(1,I); LST(2,NN) = LST(2,I)
      END DO
      N = NN
      END SUBROUTINE
C
      SUBROUTINE SSCN(NL)
C     Copyright (c) 1991 by W. W. Rozeboom.   All rights reserved.
C This is a stripped version of SCAN that reads the keyboard string and cleans
C it for list-directed readings of the numbers therein returned in scratch
C file 2.  It returns NL = 0 if the input string is empty, and NL = -1 if the
C input string is nonempty but contains no numbers.  Otherwise, NL is the
C count of numbers (real or integer) returned in the cleaned string.
      CHARACTER  WA*80, WB*81
      NL = 80
      READ(5,'(A)') WA(:NL)
10    NL = NL-1
      IF(NL==0) RETURN
      IF(WA(NL:NL)==' ') GOTO 10
      WB(NL+1:NL+1) = ' '
      DO I = 1,NL
        WB(I:I) = ' '
        IF(WA(I:I)<CHAR(48) .OR. WA(I:I)>CHAR(57)) CYCLE
        WB(I:I) = WA(I:I)
        WA(I:I) = '0'
      END DO
      IP = 0
      IF(WA(:3)=='-.0') WB(:1) = '-'
      IF(WA(:2)=='-0') WB(:1) = '-'
      IF(WA(:2)=='.0') WB(:1) = '.'
      IF(WA(:2)=='.0') IP = 1
      DO I = 2,NL
        IF(WA(I:I)=='-') THEN
          IF(WB(I-1:I-1)==' ' .AND. (WA(I+1:I+1)=='.'.OR.WA(I+1:I+1)
     +       =='0')) WB(I:I) = '-'
          IP = 0
        ELSE IF (WA(I:I)=='.') THEN
          IF((WA(I-1:I-1)=='0'.OR.WA(I+1:I+1)=='0') .AND. IP==0)
     +      WB(I:I) = '.'
          IF(WB(I:I) == '.') IP = 1
        ELSE IF (WA(I:I) /= '0') THEN
          IP = 0
        END IF
      END DO
      NN = 0
      DO I = 1,NL+1
        IF(WB(I:I)/=' ' .AND. WB(I+1:I+1)==' ') NN = NN+1
      END DO
      REWIND 2
      WRITE(2,'(A)') WB(:NL)
      REWIND 2
      NL = -1
      IF(NN>0) NL = NN
      END SUBROUTINE

      SUBROUTINE START(J,F1,KK)
C This opens formatted file F1 with unit-number J, and finds its first line
C beginning with a digit. KH returns the number of header lines.
      CHARACTER F1*(*), CH*200
      OPEN(J,FILE=F1); KK = 0
10    READ(J,'(A)',END=50) CH; KK=KK+1; L=LAST(CH); IF(L==0) GOTO 10
      L = ICHAR(CH(1:1))
      IF(L<48 .OR. L>57) GOTO 10
      BACKSPACE J; KK = KK-1
      RETURN
50    WRITE(6,'(/" File ",A12," is defective.")')
      STOP
      END
C
      FUNCTION ZRAND()
C This returns Normally distributed random Z-scores. [From Press et al, p. 203,
C whose theory is obscure at one crucial point.]
      DATA IFLG/0/
      SAVE G
      IF(IFLG==0) THEN  ! No extra deviate is in store
10      V1 = 2.*RAN2() - 1.   ! Put uniform random number in interval [-1,1]
        V2 = 2.*RAN2() - 1.   ! Do the same for V2
        R = V1**2 + V2**2
        IF(R>=1. .OR. R==0.) GOTO 10 ! If <V1,V2> not in unit circle, try again
        F = SQRT(-2.*LOG(R)/R)
        G = V1*F      ! Save extra random deviate for next time
        ZRAND = V2*F
        IFLG = 1
      ELSE
        ZRAND = G
        IFLG = 0
      END IF
      RETURN
      END
C
      FUNCTION QFMT(F1)
C This determines the status of file F1, returning 'Y' if it is Formatted,
C 'N' if it is Not, and 'U' if it is Unknown (does not exist).
      CHARACTER QFMT, F1*(*)
      INQUIRE(FILE=F1,FORMATTED=QFMT)
      RETURN
      END
C
      FUNCTION TM(KSET)
C The value returned by function TM is seconds since last timer reset. After
C this value is determined, the timer is reset if KSET > 0 but continues to
C accumulate if KSET = 0.
      SAVE PREV
      DATA PREV/0/
      CALL TIMER(J)
      X = .01*J
      TM = X - PREV
      IF(TM<=0.) TM = TM + 86400
      IF(KSET==0) RETURN
      PREV = X
      RETURN
      END
C
      SUBROUTINE TMSEED(ISEED)
C Initialize random generator seed by integer from system clock
      CALL TIMER(ISEED)
      ISEED = MOD(ISEED,1000000)
      RETURN
      END
