C            Program SCHEMAS (Source code, Fortran 90)


C              Last revised:  17 September 2003

C Create a letter-flagged schema for one of (a) raw common-factor pattern,
C (b) raw endogenous SEM path matrix, (c) raw common-factor covariance matrix,
C or (d) variables-by-groups matrix of means for MORSCOR.  Also avail creation
C of an assignment of parameter values to the schema's letter dummies either
C when the schema is first defined or when it is read from archive.  Results
C are archived in: PATnnmm.i, APATHnn.i, COVnn.i, APATRnn.i, AVnngg.i.
C ***** A LST-file of all schemas of chosen kind can also be printed
C >>> Present code for reading Grid input allows only NY  99.
C
C NOTE: Docuumentation on the composition and manual creation of backup
C       schemata is given in two text paragraphs at end of this file.

      LOGICAL QY, QZ
      CHARACTER*12  CF, NAME(80), F1,F2, CLN*8, CK*1,PL*2, WORD*139
      INTEGER  KORD(142), LKOD(0:3,26), LBB(0:3,26), NKN(5) ! NKN(i) is count of kind-i backups
      REAL X(20)                     !  BAK(kind,index,list)
      INTEGER,ALLOCATABLE :: GRID(:,:), LST(:), LTRS(:), BAK(:,:,:)
      NDIG(N) = (MAX(1,N)/48)*(57/MAX(1,N))  ! 1 if N is ICHAR for digit; otherwise, 0
      NLET(N) = (MAX(1,N)/64)*(90/MAX(1,N))  ! 1 if N is ICHAR for cap letter or @; otherwise, 0
      COMMON /CF/ CF
      OPEN(2,STATUS='SCRATCH'); NUL = 0
      PL = 's '  ! PL(K:); want K=2 if N=1, else K=1; put K = 3-MAX(1,MIN(2,N))

CC TEST LINES
C      OPEN(21,FILE='JUNK')

C  Ŀ
C                               SCHEMAS                                    
C  

C You are here to create or revise the open schema - nonzero elements flagged
C by letters to be assigned values or randomization ranges later - of a raw
C   a) NY-by-NF SEM measurement model or EFA factor pattern W (NY > NF); or
C   b) NF-by-NF SEM endogenous path structure A (asymmetric square); or
C   c) NF-by-NF common-source correlation matrix C (symmetric square); or
C   d) NV-by-NG matrix AV of NV (NY or NF) means in NG groups.
C Or you can print to textfile the stored schemata of your chosen type.

C To choose (a), enter NY ( 99) and NF.  Otherwise, choose (b) by entering NF
C twice, or (c) by entering NF once, or (d) by entering NV ( 99) followed by
C NG with minus signs (one will suffice).  To see a listing of all schemata of
C all types currently in this directory, enter a letter.  And Ctrl-C aborts.

11    CALL SYSTEM('cls'); NBK = 0
      WRITE(6,'(/" ",72(""),""/" ",30X,"SCHEMAS",35X,""/" ",
     +  72(""),"")')
12    WRITE(6,'(/" You are here to create or revise the open schema -",
     +  " nonzero elements flagged"/" by letters to be assigned value",
     +  "s or randomization ranges later - of a raw"/4X,"a) NY-by-NF",
     +  " SEM measurement model or EFA factor pattern W (NY > NF); or"/
     +  4X,"b) NF-by-NF SEM endogenous path structure A (asymmetric s",
     +  "quare); or"/4X,"c) NF-by-NF common-source correlation matrix",
     +  " C (symmetric square)."/4X,"d) NV-by-NG matrix AV of NV (NY ",
     +  "or NF) means in NG groups.")')
      WRITE(6,'(" Or you can print to textfile the stored schemata of",
     +  " your chosen type."//" To choose (a), enter NY ( 99) and NF",
     +  ".  Otherwise, choose (b) by entering NF"/" twice, or (c) by",
     +  " entering NF once, or (d) by entering NV ( 99) followed by"/
     +  " NG with minus signs (one will suffice).  To see a listing o",
     +  "f all schemata of"/" all types now in this directory, hit RE",
     +  "TURN.  Or enter a letter to abort."/)')
      CALL SCANR(JR,0,'I',NUL); IF(JR<0) STOP; JOB = 4
      IF(JR==0) THEN; CALL SYSTEM('cls'); JOB = 3
        WRITE(6,'(" Schemata already available here:")')
      END IF
      CALL LOOK(0,'PAT*',NAME,80,NLST)   ! Initiate accumulation
      CALL LOOK(2,'APAT*',NAME,80,NLST)  ! Accumulate
      CALL LOOK(2,'COV*',NAME,80,NLST)   ! Accumulate
      CALL LOOK(JOB,'AV*',NAME,80,NLST)  ! NAME(NLST) is last in list
      NBK = MOD(NLST,100); NLST = NLST/100
      IF(NBK>0 .AND. .NOT.ALLOCATED(BAK)) THEN; MX = 0
        DO I=1,NBK; OPEN(8,FILE=NAME(NLST+I))
          READ(8,*) J, N; MX=MAX(MX,N); CLOSE(8) ! MX is max list length
        END DO
        ALLOCATE( BAK(5,NBK,-1:MX) ); NKN=0; KD=0  ! NKN(K) gets count of kind-K baks
        DO I=1,NBK; OPEN(8,FILE=NAME(NLST+I))  ! KND = KIND^NY^NF
          READ(8,*) KND, L0; K = KND/10000; NKN(K) = NKN(K)+1
          BACKSPACE 8; NK = NKN(K)
          READ(8,*) (BAK(K,NK,J),J=-1,L0); CLOSE(8)  ! Load backup register
          DO J = 1,L0; BAK(K,NK,J) = BAK(K,NK,J)+64; END DO  ! Restore CHAR code
          AB:DO L = 1,NK-1  ! Don't add to BAK-register if a duplication
            DO J=0,L0; IF(BAK(K,L,J)/=BAK(K,NK,J)) CYCLE AB; END DO
            CALL SYSTEM('DEL '//NAME(NLST+I))
            NKN(K) = NKN(K)-1; KD = KD+1;
          END DO AB
        END DO; NBK = NBK-KD
      END IF
      IF(JR<0) THEN
        WORD = '..'; IF(NBK==1) WORD = '. except 1 backup.'
        IF(NBK>1) WORD(10:) = CF(:JF(NBK))//' backups.'
        IF(NBK*NLST>0)WRITE(6,'(22X,"(Also ",A,")")')WORD(10:LAST(WORD))
        IF(NLST<1) WRITE(6,'(" No schemata of any type are currently",
     +    " in store here",A)') WORD(2:LAST(WORD))
        IF(NLST>0) WRITE(6,'(9X,"To reload one of these you must fir",
     +    "st specify its"/12X,"type as though it had not yet been ",
     +    "created.")')
        IF(NLST>20) CALL WAIT(1)
      END IF
      IF(JR<1) GOTO 12
      J = MIN(2,JR); KIND = 1; CK = 'W'
      READ(2,*) (KORD(I),I=1,J); K1=KORD(1); K2=KORD(J)  ! temp use of KORD
      NY = MAX(K1,K2); NF = MIN(K1,K2)
      IF(MIN(K1,K2)<0) THEN
        KIND = 5; CK = 'M'; NY = ABS(K1); NF = ABS(K2); GOTO 14
      END IF
      IF(NY==NF) THEN; KIND = 2; CK = 'A'; END IF
      IF(J==1) THEN; KIND = 3; CK = 'C'; END IF  ! Need to set this case last
      LLBK = 0; LBB = 0   ! Kind 4 not yet distinguished from kind 2
C The schema type selected is a pattern W of xx outputs' loadings on xx factors.
C The schema type selected is a xx by xx matrix A of SEM pathweights.
C The schema type selected is a xx by xx correlation matrix C.
C The schema type selected is a xx by xx matrix of means in xx groups.
C >> Note that you have specified more groups (2nd) than variables (1st).
C If this is the frame you intended, hit RETURN.  Otherwise, enter anything
C to choose again.

      IF(KIND==1) WRITE(6,'("  The schema type selected is a pattern ",
     +  "W of ",A," outputs'' loadings on ",A," factors.")')
     +  CF(:JF(NY)), CF(:JF(NF))
      IF(KIND==2) WRITE(6,'("  The schema type selected is a ",A," by ",
     +  A," matrix A of SEM pathweights.")') CF(:JF(NY)), CF(:JF(NF))
      IF(KIND==3) WRITE(6,'("  The schema type selected is a ",A," by ",
     +  A," correlation matrix C.")') CF(:JF(NY)), CF(:JF(NF))
14    IF(KIND==5) WRITE(6,'("  The schema type selected is a ",A," by ",
     +  A," matrix M of means in ",A," groups.")') CF(:JF(NY)),
     +  CF(:JF(NF)), CF(:JF(NF))
      IF(KIND==5.AND.NF>NY) WRITE(6,'("  >> Note that you have spec",
     +  "ified more groups (2nd) than variables (1st).")')
      WRITE(6,'(2X,"If this is the frame you intended, hit RETURN.  ",
     +  "Otherwise, enter anything"/2X,"to choose again.")')
      CALL SCN(J); IF(J/=0) GOTO 11

C   To make path-structure A subdiagonally recursive - that is, for none of
C   your NF endogenous factors to be path-dependent on any indexed after it -
C   hit RETURN.  (Recursive A needn't have subdiagonal path order, but that
C   is most perspicuous.)  Otherwise, enter anything to waive manifest
C   recursiveness.

      IF(KIND==2) THEN
16      WRITE(6,'(3X,"To make path-structure A subdiagonally recursiv",
     +    "e - that is, for none of"/3X,"your NF endogenous factors ",
     +    "to be path-dependent on any indexed after it - "/3X,"hit ",
     +    "RETURN.  (Recursive A needn''t have subdiagonal path order",
     +    ", but that"/3X,"is most perspicuous.)  Otherwise, enter an",
     +    "ything to waive manifest"/3X,"recursiveness.")')
        CALL SCN(J); KIND = 4
        IF(J/=0) THEN
          WRITE(6,'(3X,"Hit RETURN to confirm that A is NOT required ",
     +      "to be subdiagonal."/3X,"Otherwise, enter anything to rec",
     +      "onsider.")')
         CALL SCN(J); IF(J/=0) GOTO 16; KIND = 2
        END IF
      END IF  ! KINDs 2 vs. 4 now distinguished
C
      IF(ALLOCATED(GRID)) DEALLOCATE( GRID, LST, LTRS )    ! LTRS needs room
      ALLOCATE ( GRID(NY,NF), LST(0:NY*NF), LTRS(0:NY*NF) ) !  for repetitions
      LOAD = 0; LTRS(0) = 0; GRID = 249    ! Show grid zeros by 
      IF(KIND==3) THEN
        DO I = 1,NF; GRID(I,I) = 49; END DO  ! Diagonal unities if array is C
      END IF
C List frames with these specs already on file. (LOOK restricted to set dim's)
      If(KIND==1) F1 = 'PAT'//CF(:JF(NY))//CF(:JF(NF))//'.*'
      If(KIND==2) F1 = 'APATH'//CF(:JF(NY))//'.*'
      If(KIND==3) F1 = 'COV'//CF(:JF(NY))//'.*'
      If(KIND==4) F1 = 'APATR'//CF(:JF(NY))//'.*'
      If(KIND==5) F1 = 'AV'//CF(:JF(NY))//CF(:JF(NF))//'.*'
      If(KIND==5.AND.NF>NY) F1(3:) = '0'//F1(3:)
      LDOT = LAST(F1)-1
19    F2 = F1; QY = .FALSE.
      N = -1; CALL LOOK(1,F1,NAME,80,N) ! Neg input N suppresses screen display
      NBK = MOD(N,100); NLST = N/100 ! NBK just for <Kind,NY,NF>
      IF(NLST==0) GOTO 25
      KK = INDX(NAME(NLST),LDOT) ! LDOT gets dot position; INDX is index in extension
      IF(KK>NLST) THEN; QY = .TRUE.
        DO I = 1,N; L = INDX(NAME(I),LD)
          IF(L>I) THEN
            WORD(:45) = 'RENAME '//NAME(I)//F1(:LDOT)//CF(:JF(I))
            K = LAST(WORD(:45)); CALL SYSTEM(WORD(:K))
          END IF
        END DO
        INQUIRE(FILE=F1(:LDOT)//'LST',EXIST=QY)
      END IF
      WRITE(6,'(" Schemata now available with the frame specified",
     +  " are")')
      CALL LOOK(1,F1,NAME,80,N)  ! NAME(NLST) is last in list
      NBK = MOD(N,100); NLST = N/100
C Listing backup count here would require counting right size within KIND
      WORD = '  Note that'; M = 1; IF(QY) M = 11
21    IF(NLST==1) WRITE(6,'(/4X,"To inspect and maybe revise this sch",
     +  "ema, enter any numeral.  Otherwise")')
      IF(NLST>1) WRITE(6,'(/4X,"To inspect/revise one of these schema",
     +  "ta, enter its list index.  Otherwise")')
      WRITE(6,'(4X,"hit RETURN to make a new schema of this type, or",
     +  " enter any letter"/4X,"to choose between printing these and",
     +  " starting again.",A)')  WORD(:M)  ! Rem: WORD may preface add-on line
      IF(QY) WRITE(6,'(4X,"re-indexing here has made your archived ",
     +  A," out of date.")') F1(:LDOT)//'LST'
      CALL SCANR(J,0,'I',NUL); IF(J==0) GOTO 25
      IF(J<0) THEN
        WRITE(6,'(4X,"To display all currently stored ",A,"-schemata",
     +    " in a textfile, hit RETURN."/4X,"Otherwise, enter any let",
     +    "ter to start again, or any numeral to quit.")') F1(:LDOT-1)
        CALL SCN(J); IF(J<0) GOTO 11;IF(J==0) GOTO 888; STOP
      END IF
      IF(NLST==1) THEN
        F2 = NAME(1); LF2 = LAST(F2)
      ELSE IF(J>0) THEN  ! J still set from SCANR call above
        READ(2,*) NN; NN = MAX(1,MIN(NN,NLST))
        F2 = NAME(NN); LF2 = LAST(NAME(NN))
        WRITE(6,'(5X,"Hit RETURN to confirm retrieval of ",A,"-schema ",
     +    A,"."/5X,"Otherwise, enter anything to choose again.")')
     +    CK, F2(:LF2)
        CALL SCN(J); IF(J/=0) GOTO 21
      END IF
      OPEN(7,FILE=F2(:LF2),FORM='UNFORMATTED')
      READ(7,ERR=23) NL, (LST(I),I=1,NL); LST(0) = NL
      READ(7,ERR=23) LLET, ((LKOD(I,J),I=0,3),J=1,LLET)
      LLBK = LLET; LBB = LKOD
      CLOSE(7); LOAD = NN; LLBK = LLET; GOTO 35  ! <= Start of schema entry
23    IF(NLST>1) THEN; WRITE(6,'(" Apologies: File ",A," is corrupt.",
     +  "  Try another.")') F2(:LF2); CLOSE(7); LOAD=0; GOTO 21; END IF
      IF(NLST<2) WRITE(6,'(" File ",A," is corrupt.  But some of it ma",
     +  "y be usable.")') F2(:LF2); CLOSE(7); GOTO 35

c  Your X-schema frame is initially empty.  Enter its elements that you want to
C  be nonzero as a string of 3-tuples <i j L> wherein
C     i is the index (1  i  xx) of an item affected by factor j (1  j  xx),
C     i indexes a factor path-dependent on a factor indexed by j (1  i,j  xx),
C     i and j index factors whose correlation in C is nonzero (1  i,j  xx),
C  and L is your choice of a letter (A through Z) to go proxy for a numerical
C  value to be assigned later.  -elements you want equal or randomized in
C  in the same range should be assigned the same L.  Your triples needn't all
C  be entered on one line; punctuation can be omitted so long as you don't
C  violate the ...-index-index-letter-index-index-letter-... entry pattern;
C  new entries will overwrite any previous ones with the same index pairs; and
C  entry <i j *> ("*" instead of L) wipes any L entered for <i,j> previously.
C    NOTE: Once this -schema is complete, you will assign to each letter
C    in it a triple of parameters for generating raw elements in  so coded.
C    Minimizing the number of different letters you choose also minimizes
C    the number of parameter decisions you have to make.

25    IF(NBK==0) THEN; CALL SYSTEM('cls'); GOTO 30; END IF

C  To inspect and maybe adapt one of the xx **-backup partials in store,
C  To inspect and maybe adapt the one **-backup partial in store,
C  enter anything.  Otherwise, hit RETURN to start from scratch.
      IF(NBK==1) WRITE(6,'(" To inspect and maybe adapt the one ",A,
     +  "-backup partial in store,")') F1(:LDOT-1)
      IF(NBK>1) WRITE(6,'(" To inspect and maybe adapt one of the ",A,
     +  1X,A,"-backup partials in store,")') CF(:JF(NBK)), F1(:LDOT-1)
      WRITE(6,'(" enter anything.  Otherwise, hit RETURN to start fr",
     +  "om scratch.")')
      CALL SCN(J); IF(J==0) GOTO 30
      KK = 1; NK = NKN(KIND)
26    KK = KK+1; K = MOD(KK-1,NK)+1; NL = BAK(KIND,K,0)  ! Can go up to K = NKN(KIND)
      DO J = 0,L0; LST(J) = BAK(KIND,K,J); END DO  ! CHAR code already restored
      F1 = 'backup '//CF(:JF(K)); L = 1
      CALL SHO(NY,NF,KIND,F1,GRID,LST,LKOD,LLET,1,6)
      WORD = ' (you''ve already seen all) '; L=1; IF(KK>NK) L=27
      IF(NK==1) WRITE(6,'(" To build on this, hit RETURN.  Otherwise,",
     +  " enter anything to start afresh.")')
      IF(NK>1) WRITE(6,'(" To build on this, hit RETURN.  Otherwise,",
     +  " enter any number to see another"/" backup",A,"or any lett",
     +  "er to start with a blank frame.")') WORD(:L)
      CALL SCN(J); IF(J==0) GOTO 35; IF(J>0) GOTO 26

CC  Branch: (a) revise/complete this one; (b) look at another; (c) start from scratch
CC  To build on this, hit RETURN.  Otherwise enter any number to see another
CC  backup (you've already seen all) or any letter to start with a blank frame.
CC  To build on this, hit RETURN.  Otherwise, enter anything to start afresh.

30    WRITE(6,'(//"  Your new ",A,"-schema frame is now empty.  Ente",
     +  "r its elements that you want to"/"  be nonzero as a string "
     +  "of 3-tuples <i j L> wherein"/)') CK
31    IF(KIND==1) WRITE(6,'(5X,"i is the index (1  i  ",A,") of an",
     +  " item affected by factor j (1  j  ",A,"),")')  CF(:JF(NY)),
     +  CF(:JF(NF))
      IF(KIND==2) WRITE(6,'(5X,"j indexes a factor path-dependent on",
     +  " one indexed by i (1  i,j  ",A,"),")') CF(:JF(NF))
      IF(KIND==4) WRITE(6,'(5X,"j indexes a factor path-dependent on",
     +  " a prior one i (1  i < j  ",A,"),")') CF(:JF(NF))
      IF(KIND==3) WRITE(6,'(5X,"i and j index factors whose correlati",
     +  "on in C is nonzero (1  i,j  ",A,"),")') CF(:JF(NF))
      IF(KIND==5) WRITE(6,'(5X,"i  ",A," is the index of a Variable ",
     +  "(item or factor) in Group j  ",A,",")') CF(:JF(NY)),
     +  CF(:JF(NF))
      WRITE(6,'(/"  and L is your choice of letter (A through Z) to g",
     +  "o proxy for a numerical "/"  value to be assigned later.  ",A,
     +  "-elements you want equal or randomized in"/"  the same rang",
     +  "e should be assigned the same L.  Your triples needn''t all"/
     +  "  be entered on one line; punctuation can be omitted so lon",
     +  "g as you don''t"/"  violate the ...-index-index-letter-inde",
     +  "x-index-letter-... entry pattern;"/"  new entries will over",
     +  "write any previous ones with the same index pairs; and"/2X,
     +  "entry <i j *> (""*"" instead of L) wipes any L entered for ",
     +  "<i,j> previously.")') CK
      WRITE(6,'(/4X,"NOTE: Once this ",A,"-schema is complete, you wil",
     +  "l assign to each letter"/4X,"in it a triple of parameters fo",
     +  "r generating raw elements in ",A," so coded."/4X,"Minimizing",
     +  " the number of different letters you choose also minimizes"/4X,
     +  "the number of parameter decisions you have to make."/)') CK,CK
      CALL WAIT(0)

c###### 1 Crash here, presumably after entering SHO


35     CALL SHO(NY,NF,KIND,F1,GRID,LST,LKOD,LLET,1,6)
C ========= End of schema display ==========
      IF(LOAD>0) THEN   ! Rem: LOAD is list index of input schema
        WRITE(6,'(/"  This is the ",A,"-schema saved in ",A,".  Hit ",
     +    "RETURN if it is exactly what"/"  you want.  Otherwise ent",
     +    "er 3-tuples <i j L> to revise as appropriate, or"/"  any ",
     +    "letter except Q to revive your options for initializing t",
     +    "his frame."/"  Entry of Q will recall the instructions fo",
     +    "r editing this schema."/)') CK, F2(:LF2); LOAD = -LOAD
      ELSE
        IF(NL==0) WRITE(6,'(/" This is the ",A,"-frame to be specif",
     +    "ied with proxies for nonzero elements."/" Enter 3-tuples",
     +    " <i j L> to put proxy letters L in its row-i/column-j ce",
     +    "lls.")') CK
        IF(NL>0) WRITE(6,'(/" Hit RETURN if this is exactly the sche",
     +    "ma you want.  Otherwise enter more"/" 3-tuples <i j L> to",
     +    " augment/change/*-delete, or any letter to restart.")')
        IF(MOD(KIND,2)==0) WRITE(6,'(" Don''t forget that each <i j ",
     +    "L> entry sets a path TO factor i FROM factor j."/" This r",
     +    "equires i > j in each <i j L> entry if A is to be subdiag",
     +    "onal recursive.")')
        IF(KIND==4) WRITE(6,'(" And since you have so declared, inco",
     +    "rrectly ordered indices will be reversed.")')
      END IF
      WRITE(6,'()')
41    READ(5,'(A)') WORD; LW = LAST(WORD)  ! RETURN key entry yields LW = 0
      K1 = ICHAR(WORD(:1))
      IF(NL==0 .AND. (LW==0.OR.NDIG(K1)/=1)) GOTO 25  ! User is confused
      IF(K1>64) THEN  ! 1st entry is a letter or higher
        IF(K1==81 .OR. K1==113) THEN  ! Review instructions
          CALL SYSTEM('cls')
          WRITE(6,'(//25X,"REVISING ",A,"-SCHEMATA")') CK
          WRITE(6,'("  Enter elements of this that you want to be non",
     +      "zero as a string of 3-tuples"/"  <i j L> wherein"/)')
          GOTO 31
        END IF
        IF(LOAD<0) GOTO 19; GOTO 11
      END IF   ! ^ Neg LOAD flags upload available; otherwise start again
      WORD = '  '//WORD  ! LW+2 is end of displaced string
      IF(LW==0) THEN
        IF(NL==0) GOTO 35; IF(LOAD==0) GOTO 55; GOTO 50
      END IF
      DO I = 3,LW+2; IF(WORD(I:I)=='*') WORD(I:I) = '@'; END DO
      DO I = LW+2,3,-1   ! $$$$$ Reading for triples starts here
        N = ICHAR(WORD(I:I)); N1 = ICHAR(WORD(I-1:I-1))
        N2 = ICHAR(WORD(I-2:I-2))
        IF(N>96) N = N-32; IF(N>34.AND.N<39) N = 64
        IF(N/=64 .AND. NDIG(N)+NLET(N)==0) N = 0
        IF(NLET(N)*NLET(N1) > 0) N = 0  ! Adjacent letters; delete 2nd
        IF(NDIG(N)*NDIG(N1)*NDIG(N2) > 0 ) N = 0  ! 3-digit integer; delete end
        KORD(I-2) = N   ! Same position as in WORD before right shift
      END DO
      DO I = LW,1,-1  ! Convert 1 or 2 field char-digits to 1-field integers
        IF(NDIG(KORD(I))==0) CYCLE   !  1 or 2-digit char-integers are changed
        KORD(I) = 100*(KORD(I)-48)   !  to INT-code times 100 in right field
        IF(I==1 .OR. NDIG(KORD(I-1))==0) CYCLE  ! Single-digit index
        KORD(I) = KORD(I) + 1000*(KORD(I-1)-48); KORD(I-1) = 0
      END DO  ! ^Indices are times 100 to distinguish from char-code letters
      J1 = -1; J2 = -1; J3 = -1; K=0; IX=0; JX=0; MY=NY*100; MF=NF*100
      DO I = 1,LW ! ^Negative flags a component of triple not yet filled
        M = KORD(I); IF(M==0) CYCLE
        IF(J2>0.AND.J3<0) J3=M; IF(J1>0.AND.J2<0) J2=M; IF(J1<0) J1=M
        IF(MIN(J1,J2,J3)<0) CYCLE   ! If J1/2/3 >0, J1/J2 are i/j times 100
        IF(J1<101 .AND. J2<101 .AND. NLET(J3)==0.AND.J3/=46) THEN
          WRITE(6,'(" Your entry string goes bad after ",A," <i j L>",
     +      " triples.  Try again, or"/" enter a letter to abort.")')
     +      CF(:JF(K)); GOTO 41
        END IF
        IF(J1>MY .OR. J2>MF) THEN     ! Index out of range
          IF(J1>MY) IX = IX+1; IF(J2>MF) JX = JX+1; GOTO 44
        END IF
        IF(KIND==3 .OR. KIND==4) THEN         ! Lower-triangle with fixed diagonal
          IF(J1==J2) GOTO 44
          Z = MAX(J1,J2); J2 = MIN(J1,J2); J1 = Z  ! Enforce subdiagonal entry
        END IF
        K = K+1  ! Kth new triple identified
        KORD(K) = 100*J1+J2+J3
44      J1 = -1; J2 = -1; J3 = -1
      END DO
      IF(IX+JX>0) THEN
        WRITE(6,'("  WARNING: <",A,", ",A,"> of these <row, column> ",
     +    "entries are out of range.  The 1st"/10X,"entry in each pa",
     +    "ir must not exeed ",A,", nor the 2nd exceed ",A,".")')
     +    CF(:JF(IX)),CF(:JF(JX)),CF(:JF(NY)),CF(:JF(NF)); CALL WAIT(0)
      END IF
C WARNING: <xx, xx> of these <row, column> entries were out of range.  The 1st
C          entry in each pair must not exeed xx, nor the 2nd exceed xx.
      DO I = 1,K
        M = MOD(KORD(I),100); IF(M==64) M = 249
        GRID(KORD(I)/10000, MOD(KORD(I)/100,100)) = M
      END DO
      NL = 0; LKOD = 0; LTRS = 0
      DO J = 1,NF; DO I = 1,NY   ! Store GRID in LST
         K = GRID(I,J)  !; IF(NLET(K)==0) CYCLE
         IF(NLET(K)==0) CYCLE    ! Rem: NLET( ) is function identifyng letters
         NL = NL+1; LST(NL) = 10000*I + 100*J + K  ! LST holds storage-form GRID
      END DO; END DO; LST(0) = NL
      GOTO 35
50    IF(KIND==2) THEN; LL = LOOP(NF,LST,IE,KORD)
        IF(LL>0) THEN   ! Rem: IE is count of nonzeros in upper triangle
          WRITE(6,'(" >>> WARNING: This pathweight matrix is nonrecu",
     +      "rsive: ",A," of its factors"/14X,"are in loops, namely ",
     +      13(1X,A),5(/13X,20(1X,A)))') CF(:JF(LL)), (CF(:JF(KORD(
     +      I))),I=1,LL)
          WRITE(6,'(14X,"If this is not your intent, you should proba",
     +      "bly enter Ctrl-C"/14X,"to break off.  Otherwise, hit RET",
     +      "URN to continue."/)')
        ELSE IF(IE>0) THEN
          WRITE(6,'(" >>> NOTE: This pathweight matrix is recursive b",
     +      "ut not subdiagonal."/11X,"(",A," nonzero elements are in",
     +      " its upper triangle.)  If you"/11X,"prefer breaking off ",
     +      "to reorder your factor indexing,"/11X,"do Ctrl-C.  Ot",
     +      "herwise, hit RETURN to continue.")') CF(:JF(IE))
        END IF
      END IF

C =============== Start of letter specifications ==============
55    DO I = 1,NL
        LTRS(I) = MOD(LST(I),100)     ! LTRS collects letter entries with repetitions
      END DO
      LLET = 0
      OUTER:DO L = 65,90    ! Alphabetize LTRS without repetitions
        DO N = LLET+1,NL
          IF(LTRS(N)==L) THEN
            LLET = LLET+1; LTRS(N) = LTRS(LLET); LTRS(LLET) = L
            CYCLE OUTER  ! Only one encounter with this letter allowed
          END IF
        END DO; IF(LLET==NL) EXIT
      END DO OUTER
      DO I = 1,LLET             ! Count occurrences of each letter
        M = LTRS(I); KL = 0     ! and store with letter in LKOD(0,-)
        DO J = 1,NL
          IF(LTRS(J)==M) KL = KL + 1
        END DO
        LKOD(0,I) = M + KL*100
      END DO
      A:DO K = 1,LLBK   ! Initiate with previous assignments
        DO I = 1,LLET
          IF(MOD(LBB(0,K),100)==MOD(LKOD(0,I),100)) THEN
            DO J = 1,3; LKOD(J,I) = LBB(J,K); END DO; CYCLE A
          END IF
        END DO
      END DO A

C  For each letter L in this schema, you will now be asked to enter, approve,
C  or revise numeric values for three parameters: Hi,Lo,Pr. [Lo,Hi] is the size
C  range within which matrix elements coded L will be randomized (or fixed if
C  Lo = Hi) while being made negative with probability Pr.  Entering less than
C  three numbers will set Pr = 0 and, if just one entry, default Lo to Hi.
C  >> Note 1:  Numeric entries here cannot exceed three digits and, if entered
C       without a decimal point, are presumed to start with one.  So make the
C       decimal explicit in entries exceeding .999 or less than .100.
c  >> Note 2: Entry of a letter at any point will jump to display of what
c       has been entered so far, followed by option to resume/revise these
c       specifications or quit with provision for finishing later.

      WRITE(6,'("  For each letter L in this schema, you will now be ",
     +  "asked to enter, approve,"/"  or revise numeric values for th",
     +  "ree parameters: Hi,Lo,Pr. [Lo,Hi] is the size"/"  range with",
     +  "in which matrix elements coded L will be randomized (or fixe",
     +  "d if"/2X,"Lo = Hi), while being made negative with probabili",
     +  "ty Pr. Entering less than"/"  three numbers will set Pr = 0 ",
     +  " and, if just one entry, default Lo to Hi."/)')
      WRITE(6,'("  >> Note 1:  Numeric entries here cannot exceed thr",
     +  "ee digits and, if entered"/7X,"without a decimal point, are ",
     +  "presumed to start with one.  So make the"/7X," decimal expli",
     +  "cit in entries exceeding .999 or less than .100."/)')
      WRITE(6,'("  >> Note 2: Entry of a letter at any point will ju",
     +  "mp to display of what"/7X,"has been entered so far, followed",
     +  " by option to resume/revise these"/13X,"specifications or qu",
     +  "it with provision for finishing later."/)')
60    DO L = 1,LLET
        K = 1; IF(LKOD(0,L)/100==1) K = 2; KORD(1) = 1  ! KORD must be flagged
64      WRITE(6,'(4X,"Your parameter settings for generating ",A,1X,
     +    "element",A,"coded  ",A,"  are now"/16X,"<Hi,Lo,Pr> = <",
     +    A4,2(1X,A4),">"/4X,"Hit RETURN if OK, or enter preferred ",
     +    "triple with Pr last."/)')  CF(:JF(LKOD(0,L)/100)), PL(K:),
     +    CHAR(MOD(LKOD(0,L),100)), (CLN(.001*LKOD(J,L),4,3),J=1,3)
        KORD(1)=1; CALL SCANR(J,0,'R',KORD) ! KORD(I)-return 0/1 flags whether Ith entry
        IF(J==0) CYCLE; IF(J<0) GOTO 70                  ! contains a decimal
        JJ = MIN(3,J)
        READ(2,*) (X(I),I=1,JJ)
        DO I = 1,JJ
CC          IF(X(I)/=NINT(X(I)) .OR. KORD(I)>0) CYCLE ! Shdn't need 1st part
          IF(KORD(I)>0) CYCLE
66        IF(ABS(X(I))>=1.) THEN; X(I) = .1*X(I); GOTO 66; END IF
        END DO
        IF(JJ==1) THEN
          LKOD(1,L) = NINT(1000*X(1)); LKOD(2,L) = LKOD(1,L)
        ELSE IF(JJ>1) THEN
          K = 1; IF(ABS(X(2))>ABS(X(1))) K = 2; M = NINT(SIGN(1.,X(K)))
          LKOD(1,L) = NINT(M*1000*MAX(ABS(X(1)),ABS(X(2))))
          LKOD(2,L) = NINT(M*1000*MIN(ABS(X(1)),ABS(X(2))))
        END IF
        IF(JJ==3) LKOD(3,L) = 1000*ABS(X(3)); IF(JJ<3) LKOD(3,L) = 1000
        GOTO 64
      END DO

C         1   2   3   4   5   6   7   8   9  10  11  12  13  14  15  16  17  18  19  20  21  22  23  24
C          25  26  ..  ..  ..  ..  ..  ..  ..  ..  .. .. .. .. .. .. .. .. .. ..
C  Your complete list of pattern-completion parameters is                          wrap continuation
C     Ŀ         Ŀ
C        A   B   C   D   E   F   G   H   I   J   K   L   M   N  15  16  17            W   X   Y   Z 
CĴ         Ĵ
C Hi  .xx .xx .xx .xx .xx .xx .xx .xx .xx .xx .xx .xx .xx .xx .xx .xx .xx          .xx .xx .xx .xx 
C Lo  .xx .xx                                                                                      
C Pr  .xx .                                                                                        
C         
C
70    WRITE(6,'(" Your full list of pattern-completion parameters",
     +  " is")')
      CALL SHO(NY,NF,KIND,F1,GRID,LST,LKOD,LLET,2,6)
      WRITE(6,'(/"  Hit RETURN to save these specifications for use ",
     +  "or modification later."/"  Otherwise enter a letter to edit",
     +  " these parameter assignments, or a numeral to"/"  restart b",
     +  "y uploading another ",A,"-schema while leaving this one un",
     +  "changed.")') F1(:LDOT-1)
      CALL SCN(J); IF(J<0) GOTO 60; IF(J>0) GOTO 19
      IF(KIND==2 .AND. IE==0) THEN         ! IE now flags KIND change; schema
        F2(4:4) = 'R'; KIND = 4; IE = -1   ! is recursive but not subdiagonal.
        N=-1; CALL LOOK(1,F2(:LDOT)//'*',NAME,80,N)
        NBK = MOD(N,10); N = N/100; F2(LDOT+1:) = CF(:JF(N))
      END IF
      LDIF = 0
      DO I = 0,3; DO J = 1,LLET
        IF(LKOD(I,J)/=LBB(I,J)) LDIF = LDIF+1
      END DO; END DO  ! LDIF > 0 iff schema specs have been changed
      WRITE(6,'(" To quit without saving any product from this run, e",
     +  "nter anything."/" Otherwise, hit RETURN to save this schema",
     +  " in the ",A," collection.")') F2(:LDOT-1)
      IF(LDIF==0) WRITE(6,'(" Note that its settings are identical w",
     +  "ith those already saved in ",A,".")') F2(:LAST(F2))
      IF(IE<0) WRITE(6,'(" (Note its classification as recursive des",
     +  "pite not being subdiagonal.)")')    ! Neg IE circa 15 lines up.
      CALL SCN(J)
      IF(J/=0) THEN
        WRITE(6,'(" ***** Schema work abandoned without issue - come",
     +    " again soon.")'); STOP
      END IF
      F1 = F2(:LDOT)//CF(:JF(NLST+1)); IF(LOAD==0) GOTO 90
C       F2 is the uploaded schema; NLST is index of last in list
88    WRITE(6,'(/3X,"To add this new ",A,"-schema to your collection ",
     +  "of these, hit RETURN."/3X,"Otherwise, enter anything to repl",
     +  "ace ",A," with this revision thereof.")') F2(:LDOT-1),
     +  F2(:LF2)
      CALL SCN(J); IF(J==0) GOTO 90
      WRITE(6,'(3X,"Hit RETURN to confirm rewriting your previously s",
     +  "tored ",A,"."/3X,"Otherwise, enter anything to reconsider.")')
     +  F2(:LF2)
      CALL SCN(J); IF(J/=0) GOTO 88
90    OPEN(7,FILE=F1,FORM='UNFORMATTED')
      L0 = LST(0); KAT = KIND*10000 + NY*100 + NF   ! KAT heads backup list
      WRITE(7) (LST(I),I=0,L0)           ! Rem: L0 starts LST
      WRITE(7) LLET, ((LKOD(I,J),I=0,3),J=1,LLET)
      CLOSE(7)

CC TEST LINES
C      OPEN(7,FILE=F1,FORM='UNFORMATTED')
C      READ(7) L0
C      WRITE(21,'(" In new schema ",A,", L0 =",I3)') F1(:LAST(F1)), L0
C      WRITE(6,'(" In new schema ",A,", L0 =",I3)') F1(:LAST(F1)), L0
C      REWIND 7
C      READ(7) (LST(I),I=0,L0)
C      WRITE(21,'(" The rest is",3(/10I8))') (LST(I),I=1,L0)
C      CLOSE(7); PAUSE

C Check if backup-partial is new; if not, don't store it.
      F1 = F2
      DO L = 1,NKN(KIND); KD = 0
        IF(KAT/=BAK(KIND,L,-1) .OR. L0/=BAK(KIND,L,0)) CYCLE
        DO I = 1,L0; IF(LST(I)/=BAK(KIND,L,I)) KD = KD+1; END DO
        IF(KD==0) GOTO 95
      END DO
      OPEN(7,FILE='ZZZ')
      WRITE(7,'(10I7)') (KAT,LST(I)-64,I=0,L0); CLOSE(7)
      DO K = 1,9; F2 = F2(:LDOT)//'BK'//CHAR(48+K)   ! ^Last use of LST
        INQUIRE(FILE=F2,EXIST=QY)
        IF(QY) CALL SYSTEM(' RENAME '//F2//' '//'$$$')
        CALL SYSTEM('RENAME ZZZ '//F2)
        IF(QY) CALL SYSTEM('RENAME $$$ '//'ZZZ')
        IF(.NOT.QY) EXIT  ! F2 didn't exist before ZZZ renamed this
      END DO
      INQUIRE(FILE='ZZZ',EXIST=QZ); IF(QZ) CALL SYSTEM('DEL ZZZ')
      INQUIRE(FILE='$$$',EXIST=QZ); IF(QZ) CALL SYSTEM('DEL $$$')

95    WRITE(6,'(6X,"**** All done here; the new schema is saved in ",
     +  A,".")') F2(:LAST(F2))   ! F2 respecified 6 lines up
      WRITE(6,'(6X,"It''s written in binary code, but you can view ",
     +  "it in SCHEMAS or SEMCOV.")')
      WRITE(6,'(6X,"To see it in a textfile along with the other av",
     +  "ailable schemata of"/6X,"its type, enter any letter.  Othe",
     +  "rwise, enter an integer to work on"/6X,"another schema or ",
     +  "hit RETURN to sign off.")')
      CALL SCN(J); IF(J>0) GOTO 11; IF(J==0) STOP

888   F2(LDOT+1:) = 'LST'     ! Write LST-file
      OPEN(8,F2); CALL DAY(8)
      N = -1; CALL LOOK(1,F2(:LDOT)//'*',NAME,80,N); N = N/100
      DO K = 1,N; F1 = NAME(K); CLOSE(7)
        OPEN(7,F1,FORM='UNFORMATTED')
        READ(7,ERR=890) NL, (LST(I),I=1,NL); LST(0) = NL
        READ(7,ERR=890) LLET, ((LKOD(I,J),I=0,3),J=1,LLET)
        WRITE(8,'(/29X,"Ŀ"/29("")," ",A12,"",
     +     35("")/29X,"")') F1
C                             Ŀ
C͵ APATH5.2    
C                             
        CALL SHO(NY,NF,KIND,F1,GRID,LST,LKOD,LLET,3,8)
        CYCLE
890     WRITE(8,'(/29X,"Ŀ"/29("")," ",A12,"",
     +     35("")/29X,"")') F1
        WRITE(8,'(7X,10("")," This file has become corrupted.")')
      END DO
      WRITE(6,'(" The schemata of this type archived here can be seen",
     +  " in textfile ",A,".")') F2(:LAST(F2))
      STOP
      END
C
      FUNCTION JF(N)
C Return character expression of integer N left-justified in field CF; then
C CF(:JF(N)) writes N with exactly the right length in format specifier A.
C *** Haven't found any way to avoid requiring N to be INTEGER(4).
      CHARACTER(12) CF
      INTEGER(4) K
      COMMON /CF/ CF
      K = ABS(N)
      CF = '            '
      J = 13
10    J = J-1
      CF(J:J) = CHAR(48+MOD(K,10))
      K = K/10
      IF(K>0) GOTO 10
      IF(N<0) CF(J-1:J-1) = '-'
      CF = ADJUSTL(CF)
      JF = LEN_TRIM(CF)
      END FUNCTION
C
      FUNCTION CLN(X,NFF,ND)
C Express real number X as a character string in fieldwidth NF with LD decimals
C when room, where LD = ABS(ND).  ND<0 tries to precede all positive numbers
C with a blank. LD > 9 displays zero decimals and no decimal point while
C returning X = 0 as ND-10 zeros right-justified in selected field.
C ***** WARNING: If a call of CLN prints garbage, you have forgotten to
C       declare CLN as CHARACTER*8 in the calling routine.
      PARAMETER (KW=16)
      CHARACTER CLN*8, WK(KW)
      CLN = '        '
      NF = MIN(8,NFF)  ! Limit fieldwidth to 8 chars
      LD = ABS(ND)
      IF(ABS(X)<1.0E-12) THEN !  Special for vanishingly small X
        N = MIN(NF-1,MOD(LD,10))
        IF(LD<10) CLN(NF-N:NF+1-N) = '.0'
        IF(LD<10) RETURN
        DO I = 1,N
          CLN(NF+1-I:NF+1-I) = '0'
        END DO
        RETURN
      END IF
      M = NF; IF(ABS(X)>1.) M = NF-1-INT(LOG10(ABS(X))) !  M is space free for decimal (or M-1 if X<0) )
      IF(M<0 .OR. M<1.AND.X<0.) GOTO 55
      IF(ND>=10) LD = 0; LD = MIN(LD,M)
      DO I = 1,KW
        WK(I) = ' '
      END DO
      IF(LD==0) N = NINT(ABS(X))         ! Shouldn't be needed, but is
      IF(LD/=0) N = NINT(ABS(X)*10**LD)  ! This can overflow if LD is large
      DO I = KW,KW-LD+1,-1
        WK(I) = CHAR(48+MOD(N,10))
        N = N/10
      END DO
      WK(KW-LD) = '.'
      IF(N==0 .AND. LD==0) WK(KW-LD-1) = '0'
      IF(N==0 .AND. X<0. .AND. LD>0) WK(KW-LD-1) = '-'
      DO I = KW-LD-1,2,-1
        IF(N>0) WK(I) = CHAR(48+MOD(N,10))
        IF(N>0 .AND. X<0.) WK(I-1) = '-'
        N = N/10
      END DO
      KS = KW-NF+1
25    KS = KS-1
C       Field returned will start at WK(KS+1) for initial KS
      IF(KS<=0) GOTO 50
      IF(ND>=0) THEN
        IF(WK(KS)/=' ' .AND. WK(KS+NF)/='.') GOTO 25
      ELSE
        IF(WK(KS+1)/=' '. AND. WK(KS+1)/='-' .AND. WK(KS+NF)/='.')
     +    GOTO 25
      END IF
      IF(ND>=10) KS = MAX(1,KS-1)
      DO I = 1,NF
        CLN(I:I) = WK(KS+I)
      END DO
50    IF(WK(KS)==' ') RETURN
55    CLN = ' *******'
      END FUNCTION
C
      SUBROUTINE DAY(N)
C This date-stamps output file N
      CHARACTER ZZZ*8, WORD*18, CF*12, LST(12)*10
      COMMON /CF/ CF
      DATA LST/'January  7','February 8','March    5','April    5',
     +         'May      3','June     4','July     4','August   6',
     +         'September9','October  7','November 8','December 8'/
      CALL DATE_AND_TIME(ZZZ)  ! Last three outputs not used here
      M = 10*(ICHAR(ZZZ(7:7))-48) + ICHAR(ZZZ(8:8))-48  ! M gets day of month
      READ(ZZZ(5:6),*) L; K = ICHAR(LST(L)(10:10))-48
      WORD = CF(:JF(M))//' '//LST(L)(:K)//' '//ZZZ(:4)
      WRITE(N,'(/20X,"Date of this run:  ",A)') WORD
      END SUBROUTINE

      FUNCTION INDX(F1,L)
C Return the dot-position L in Schema-file F1, and the INDEX in F1's extension
      CHARACTER*12 F1
      N = LAST(F1)
      DO L = 4,12; IF(F1(L:L)=='.') EXIT; END DO   ! Locate dot
      DO M = L+1,N
        IF(LGT( F1(L+1:L+1),'9')) THEN; INDX = 0; RETURN; END IF
      END DO
      INDX = ICHAR(F1(L+1:L+1))-48
      IF(N>L+1) INDX = 10*INDX + ICHAR(F1(L+2:L+2))-48
      IF(N>L+2) INDX = 10*INDX + ICHAR(F1(L+3:L+3))-48
      END FUNCTION

      FUNCTION LAST(WORD)
C This left-justifies leading substring WORD(:M) of WORD, and returns its
C length as L. If the string is empty, LAST is returned as 0.
      CHARACTER WORD*(*)
      M = LEN(WORD)
      WORD(:M) = ADJUSTL(WORD(:M))
      LAST = LEN_TRIM(WORD(:ABS(M)))
      END

      FUNCTION LOOP(NF,LST,IE,LPP)
C Determine if sparce NFNF matrix compressed in LST is recursive.  Each of NL
C integers in LST is 10000*i + 100*j + L for nonzero entry in KTL cell <i,j>.
C Function value returned is count LOOP of looped nodes; list of indices that
C are in loops are returned in LPP. IE is count of upper-triangle entries.
      INTEGER LST(0:*), KTL(NF,NF), LPP(*)
      KTL = 0; LOOP = 0; LK = 1; NL = LST(0); IE = 0
      DO I = 1,NL
        KTL( LST(I)/10000, MOD(LST(I)/100,100) ) = 1
        IF( LST(I)/10000 >= MOD(LST(I)/100,100) ) IE = IE+1
      END DO
      DO WHILE(LK<NF)
        DO I = 1,NF; DO J = 1,NF; DO K = 1,NF
           IF(KTL(I,K)*KTL(K,J)==1) KTL(I,J) = 1
        END DO; END DO; END DO
        LK = LK*2
      END DO
      DO I = 1,NF
        IF(KTL(I,I)>0) THEN
          LOOP = LOOP+1; LPP(LOOP) = I
        END IF
      END DO
      END FUNCTION

      SUBROUTINE LOOK(K,GET,NAME,ML,KNT)
C LOOK calls DOS to delete or report files named in GET, with action set by K.
C K/2 = 0,1 initial-lists/append-lists GET in buffer file ZZZ. MOD(K,2) = 0,1
C stores/shows-to-screen the GET list. So K=0 initial-stores; K=1 initial-
C shows; K=2 append-stores; and K=3 append-shows. The last filename matching
C the GET template is returned in WORD with its length M.  NAME returns the
C list of template matches, the number of which is NL, and prints the numbered
C list to screen.  ML is max NL allowed by array allocation.
C ***** This variant uses negative input on KNT to suppress screen write and,
C       called only for schemata, also separates full schemata from ASCII backups
C >>>>> This variant also uses K>3 to complete list collection but suppress write
      LOGICAL PRM, QY, NOGO
      CHARACTER*12 GET*(*), NAME(*), WORD*40, WD*40, TMP
      CHARACTER E, CH2*2   ! <<<  Special characters as needed
      SAVE NL  ! NL must NOT be disturbed by KNT if K > 1
      NOSHO = KNT; IF(K<2) NL = 0  ! Shd always have K  1 on 1st call
      JOB = K; K = MIN(K,3)
      WD = GET; M = LAST(WD); LL = M
CC      LL = 1    ! Why set LL this old way, or distinguish it from M ???
CC5     LL = LL+1; IF(LL<M) GOTO 5   ! Some old code glitch ??
      WD(M+2:M+LL+1) = WD(:LL); WD(40:40) = ' '  ! Shd now always have LL = M
      DO I = M+2,M+LL+1
        IF(WD(I:I)=='*' .OR. WD(I:I)=='?' ) THEN
          WD(40:40) = '!'; WD(I:I) = '!'
        END IF
      END DO
      INQUIRE(FILE=WD(M+2:M+LL+1),EXIST=QY)
      IF(.NOT.QY) OPEN(19,FILE=WD(M+2:M+LL+1)) ! Precludes no-match error message
      IF(K/2==0) CALL SYSTEM('dir '//WD(:M)//' >ZZZ')
      IF(K/2>0) CALL SYSTEM('dir '//WD(:M)//'>>ZZZ')  ! Append
      IF(.NOT.QY) CLOSE(19,STATUS='DELETE')
      IF(MOD(K,2)==0) RETURN
      OPEN(4,FILE='ZZZ')
10    READ(4,'(A)',END=50) WORD
      IF(WORD(25:26)==' 0' .OR. WORD(16:16)=='<') GOTO 10  ! No directory names
C Special filters for schemata
      IF(LGT(WORD(10:10),'9') .AND. WORD(10:11)/='BK') GOTO 10
      E = WORD(:1); IF(E==' ' .OR. E=='.') GOTO 10
      IF(WORD(10:12)=='SEE' .OR. WORD(10:10)==' ') GOTO 10
      IF(WORD(:3)=='COV' .AND. NOGO(WORD(4:8))) GOTO 10
      IF(WORD(:4)=='CCOV' .AND. NOGO(WORD(5:8))) GOTO 10
      IF(WORD(:3)=='PAT' .AND. NOGO(WORD(4:8))) GOTO 10
      IF(WORD(:3)=='APATH' .AND. NOGO(WORD(6:8))) GOTO 10
      IF(WORD(:3)=='APATR' .AND. NOGO(WORD(6:8))) GOTO 10
      IF(WORD(:3)=='AV' .AND. NOGO(WORD(3:8))) GOTO 10
      L = LAST(WORD(:14))      ! ^ Lexically Greater Than
      DO I = 1,L; IF(WORD(I:I)=='!') GOTO 10; END DO
      IF(WORD(10:11)=='BK') WORD(1:1) = CHAR(ICHAR(WORD(1:1))+32)
      L = LAST(WORD(:8));   !  ^^^ Contrive to list last
      IF(WORD(10:10)/=' ') WORD(L+1:L+4) = '.'//WORD(10:12)
      DO I = 1,NL  !  Eliminate possible duplications
        IF(NAME(I)(:L+4)==WORD(:L+4) .AND. NAME(I)(L+5:L+5)==' ')
     +    GOTO 10
      END DO
      NL = NL+1
      NAME(NL) = WORD(:L+4)//'     '
      IF(NL<ML) GOTO 10
50    CLOSE(4,STATUS='DELETE')
      DO J = 2,NL; TMP = NAME(J)
        DO I = J-1,1,-1
          IF(.NOT.PRM(NAME(I),TMP)) GOTO 55    ! Increasing order
          NAME(I+1) = NAME(I)
        END DO
        I = 0
55      NAME(I+1) = TMP
      END DO
      KNT = NL; KB = 0  ! Must NOT respecify K (job-selection input)
      DO KK = KNT,1,-1  ! Get count of complete schemata; excluding backups
        L = LAST(NAME(KK)); CH2 = NAME(KK)(L-2:L-1)
        IF(CH2=='BK') THEN
          NAME(KK)(1:1) = CHAR(ICHAR(NAME(KK)(1:1))-32); KB = KB+1
        ELSE; EXIT
        END IF
      END DO
      KNT = 100*KK + KB  ! KNT decomposed on return
      IF(NOSHO<0) RETURN
      IF(JOB<4 .AND. KK>0) WRITE(6,'(20(:/4(I5,". ",A)))') (I,NAME(I),
     +  I=1,KK)
      RETURN
      END

      FUNCTION PRM(NAM1,NAM2)
C Consider both base and extension when flagging which filename comes first
C in alphanumeric listing.  PRM=t says that NAM2 comes before NAM1.
      LOGICAL PRM
      CHARACTER NAM1*(*), NAM2*(*)
      PRM = .FALSE.
      L1 = LAST(NAM1); L2 = LAST(NAM2)
      N1 = L1+1; N2 = L2+1  ! Find dot positions, if any
10    N1 = N1-1; IF(NAM1(N1:N1)/='.' .AND. N1>1) GOTO 10
20    N2 = N2-1; IF(NAM2(N2:N2)/='.' .AND. N2>1) GOTO 20
      IF(N1==1) N1=L1+1; IF(N2==1) N2=L2+1  ! Where dot would be were there one
      JJ = KPRM(NAM1(:N1-1),NAM2(:N2-1))
      IF(JJ==-1) PRM = .TRUE.; IF(JJ/=0) RETURN  ! JJ=0 if basenames are same
      IF(JJ==0 .AND. (N1>L1 .OR. N2>L2)) THEN  ! An extension is blank
        IF(N2>L2) PRM = .TRUE.; RETURN
      END IF
      JJ = KPRM(NAM1(N1:L1),NAM2(N2:L2))  ! Include extension dot
      PRM = .FALSE.; IF(JJ==-1) PRM = .TRUE.
      END FUNCTION

      FUNCTION KPRM(WRD1,WRD2)
C Return value 0 if WRD1=WRD2; otherwise  -1 or +1 according to whether WRD2
C comes before or after WRD1 in alphanumeric sequence.
      INTEGER KPRM
      CHARACTER WRD1*(*), WRD2*(*)
      L1 = LAST(WRD1); L2 = LAST(WRD2)
      KPRM = 0; IF(WRD1(:L1)==WRD2(:L2)) RETURN
      N1 = L1+1; N2 = L2+1    ! Find position preceding terminal number string
10    N1 = N1-1; N = ICHAR(WRD1(N1:N1))
         IF(N>47.AND.N<58 .AND. N1>1) GOTO 10
20    N2 = N2-1; N = ICHAR(WRD2(N2:N2))
         IF(N>47.AND.N<58 .AND. N2>1) GOTO 20
      IF(LLT(WRD1(:N1),WRD2(:N2))) KPRM = 1
      IF(LLT(WRD2(:N2),WRD1(:N1))) KPRM = -1
      IF(WRD1(:N1)/=WRD2(:N2)) RETURN
      IF(N1==L1 .OR. N2==L2) THEN  ! A mumber terminus is blank
        KPRM = 1; IF(N2==L2) KPRM = -1; RETURN
      END IF
      READ(WRD1(N1+1:L1),*) K1; READ(WRD2(N2+1:L2),*) K2
      KPRM = 1; IF(K2<K1) KPRM = -1
      END FUNCTION

      FUNCTION NOGO(WRD)
C Return NOGO=true iff char string WRD isn't purely numeric
      LOGICAL NOGO
      CHARACTER WRD*(*)
      NOGO = .FALSE.
      DO I = 1,LAST(WRD); M = ICHAR(WRD(I:I))
        IF(M<48 .OR. M>57) THEN; NOGO = .TRUE.; RETURN; END IF
      END DO
      END FUNCTION

      SUBROUTINE SCN(NL)
C This is a baby SCAN that responds to keyboard entry KB by returning NL = 0
C if KB is RETURN, NL = 1 if KB is a number, and NL = -1 KB is a letter.
      CHARACTER CH
      READ(6,'(A)') CH; N = ICHAR(CH)
      NL = 0; IF(N<=32) RETURN
      IF(N<58) NL = 1; IF(N>64) NL = -1
      END SUBROUTINE
C
      SUBROUTINE SCANR(NL,NS,SEQ,KND)
C This reads the keyboard string, cleans it for list-directed reading of
C the numbers therein, and checks whether it contains NS integers/reals in
C the sequence of Is and Rs received in SEQ if NS>0, or, if NS<1, whether
C all its numbers are of the first I/R kind listed in SEQ. (Integers are
C accepted also as reals.  Termination of an input line by "*" allows up to
C two continuation lines.)  NL returns 0 if the input string is blank, -1 if
C this contains only non-numeric characters, -2 if the cleaned number string
C returned in File 2 is non-null but does not match SEQ, and gives the total
C count of numbers in the returned string otherwise.
C *** If SEQ is "B", NL returns 0 if the input line is blank or -1 otherwise.
C *** Version R: Unless KND(1)=0, KND(J) returns 1 if Jth entry has a decimal
      CHARACTER  AA, SEQ*(*), WA*240, WB*240         !  else KND(J) returns 0
      INTEGER KND(*)
      NL = 0
5     NLL = NL + 80
      READ(5,'(A80)') WA(NL+1:NLL)
      IP = NL
      NL = NLL+1
10    NL = NL-1
      IF(NL==0) RETURN
      IF(WA(NL:NL)==' ') GOTO 10
      IF(WA(NL:NL)=='*' .AND. NL>IP) GOTO 5
      IF(SEQ(1:1)=='B') NL = -1
      IF(SEQ(1:1)=='B') RETURN
      IP = 0; WB = ' '
      DO I = 1,NL
        IF(WA(I:I)<CHAR(48) .OR. WA(I:I)>CHAR(57)) CYCLE
        WB(I:I) = WA(I:I); WA(I:I) = '0' ! All digits transferred to WB
      END DO
CC      IP = 0  ! Already initialized ?? (Flags whether transfer of . is ok)
      IF(WA(:3)=='-.0'.OR.WA(:2)=='-0') WB(:1) = '-'       ! WA starts with - ?
      IF(WA(:2)=='.0') THEN; WB(:1) = '.'; IP = 1; END IF  ! WA starts with . ?
      DO I = 2,NL    ! REM: '0' in WA now flags integers transferred to WB
        IF(WA(I:I)=='-') THEN
          IF(WB(I-1:I-1)==' ' .AND. (WA(I+1:I+1)=='.'.OR.WA(I+1:I+1)
     +      =='0')) WB(I:I) = '-'; IP = 0
        ELSE IF (WA(I:I)=='.') THEN
          IF( (WA(I-1:I-1)=='0'.OR.WA(I+1:I+1)=='0') .AND. IP==0) THEN
            WB(I:I) = '.'; IP = 1
          END IF
        ELSE IF(WA(I:I) /= '0') THEN
          IP = 0
        END IF
      END DO
C Identify Integer/Real sequence in WB and put I/R string in start of WA
      NN = 0  ! Count numbers in the input sequence
      AA = 'I'; IF(WB(1:1)=='.') AA = 'R'
      DO I = 2,NL+1
        IF(WB(I:I)==' ' .AND. WB(I-1:I-1)/=' ') THEN
          NN = NN + 1; WA(NN:NN) = AA; AA = 'I'
        ELSE IF(WB(I:I)=='.') THEN    !   ^  Default for next entry
          AA = 'R'
        END IF
      END DO
      IF(NN==0) THEN; NL = -1; RETURN; END IF
      IF(KND(1)/=0) THEN
        DO J = 1,NN; KND(J) = 1; IF(WA(J:J)=='I') KND(J) = 0; END DO
      END IF                   ! ^ Return 0,1 coding of I,R kinds
      AA = '+'
      IF(NS<=0 .AND. SEQ(1:1)=='R') GOTO 60
      IF(NS<=0) GOTO 50
      IF(NN<NS) GOTO 57
      DO I = 1,NS
        IF(SEQ(I:I)=='I' .AND. WA(I:I)/='I') AA = '0'
      END DO
      GOTO 55
50    DO I = 1,NN
        IF(WA(I:I)/=SEQ(1:1)) AA = '0'
      END DO
55    IF(AA=='+') GOTO 60
57    NL = -2
      IF(NL<=-2) WRITE(6,'(/" Your input does not contain the ",
     +  "number sequence requested. Try again.")')
      RETURN
60    REWIND 2
      WRITE(2,'(A)') WB(1:NL)
      NL = NN
      REWIND 2
      RETURN
      END

      SUBROUTINE SHO(NY,NF,KIND,F1,GRID,LST,LKOD,LLET,JOB,KF)
C JOB<=1 shows matrix schema; JOB=2 shows its letter specs; JOB > 2 shows both
C Only negative SHO job in Gendata package so far is -3.
      CHARACTER*4  C0,C1,C2,C3,C4, CH3*3, CK*1, CLN*8, FMT*50
      CHARACTER*12  CF, F1, WORD*80, WRD(51)*3, CC*2
      INTEGER GRID(NY,NF), LKOD(0:3,*), LST(0:*)
      COMMON /CF/ CF
C ========= Start of schema display ==========
      MM = 24; IF(KF/=6) MM = 50
      IF(ABS(JOB)==2) GOTO 11
      GRID = 249    ! Show grid zeros by 
      CK = 'A'; IF(KIND==3) CK = 'C'; IF(KIND==5) CK = 'M'
      CC = '24'; IF(KF/=6) CC = '50'
      NL = LST(0); IE = 0             ! "//CC//"
      DO K = 1,NL  ! Unpack grid saved in LST
        I = LST(K)/10000; J = MOD(LST(K)/100,100)
        GRID(I,J) = MOD(LST(K),100); IF(KIND/=2) CYCLE
        IF(I<=J) IE = IE+1  ! IE>0 flags not subdiagonal
      END DO
      WORD(:11) = ' recursive '; J = 1; IF(KIND==4) J=11
      IF(KF==6) WRITE(KF,'(5X,A," by ",3A,"-schema ",A," is")')
     +  CF(:JF(NY)), CF(:JF(NF)), WORD(:J), CK, F1(:LAST(F1))
      IF(KF/=6) WRITE(KF,'(4X,"Schema ",A," is")') F1(:LAST(F1))
      WRITE(KF,'(4X,'//CC//'I3,3(:/4X,'//CC//'I3))') (I,I=1,NF)  ! Indices on top line
      CH3 = 'Ŀ '; IF(NF>MM) CH3 = '   '  ! IF(NF>MM.OR.KIND==3) CH3 = '   '
      WRD=' '; N1 = NF+1 ! ^ MM is number of 3-fields in show line
      IF(KIND==3 .AND. NF<=24) THEN
        WRD = ' '; N1 = NF+1; WRD(NF:NF) = 'sym'; WRD(N1:N1) = '  '
      END IF
      WRITE(KF,'(3X,"",'//CC//'A3,2A3)') ('',I=1,MIN(NF,MM)), CH3
      CH3 = '  '; IF(KIND==3) CH3 = '  1'  ! Rem: MaxEntries^ in line
      L = 1+(NF-1)/MM; LSHN = 3; LSHB = 0       ! L is lines per table row
      FMT = '(I3,"",'//CC//'A3,2A3)'
      IF(NF>MM) FMT(13:) = '/3(:3X,"",'//CC//'A3))'
      DO K = 1,NY; JJ = NF; IF(KIND==3) JJ = K-1
        IF(NF<=MM) WRITE(KF,FMT) K, ('  '//CHAR(GRID(K,I)),I=1,JJ),
     +     CH3, WRD(JJ+1:N1)
        IF(NF>MM) WRITE(KF,FMT) K, ('  '//CHAR(GRID(K,I)),I=1,JJ) !, CH3
        IF(K==1 .AND. KIND==3) WRD(:NF) = '   '
        IF(KF/=6) CYCLE; LSHN = LSHN+L
        IF(LSHN-LSHB>20.AND.(NY-K)*L>4) THEN
          CALL WAIT(0); LSHB = LSHN
        END IF
      END DO
      WRITE(KF,'(3X,"",'//CC//'A3,A3)') ('',I=1,MIN(NF,MM))," "
      IF(ABS(JOB)<2) RETURN
C ==================== End of schema display ======================
11    IF(JOB>1) WRITE(KF,'(3X,"Its current parameter assignments are")')
      MM = 17; IF(KF/=6) MM = LLET
      C1 = 'Ŀ  '; C2 = '   '; C3 = 'Ĵ  '; C4 = '  '; C0 = '   '
      IF(LLET>MM) THEN; C1 = ' '; C2 = ' '; C3 = ' '; C4 = ' '; END IF
      WRITE(KF,'(6X,"",20A)') ((""),I=1,MIN(LLET,MM)), C1
      WRITE(KF,'(6X,"",40A)') ('   ',CHAR(MOD(LKOD(0,I),100)),I=1,
     +  MIN(LLET,MM)), C2
      WRITE(KF,'(" ",60A)') ((""),I=1,MIN(LLET,MM)), C3
      WRITE(KF,'("  Hi ",60(1X,A3))') (CLN(.001*LKOD(1,I),3,2),I=1,
     +  MIN(LLET,MM)), C0
      WRITE(KF,'("  Lo ",60(1X,A3))') (CLN(.001*LKOD(2,I),3,2),I=1,
     +  MIN(LLET,MM)), C0
      WRITE(KF,'("  Pr ",60(1X,A3))') (CLN(.001*LKOD(3,I),3,2),I=1,
     +  MIN(LLET,MM)), C0
      WRITE(KF,'(" ",60A)') ((""),I=1,MIN(LLET,MM)), C4
      IF(LLET>MM) THEN; K = 34-LLET    ! K + LLET-17 = 17
        C1 = ''; C2 = ''; C3 = ''; C4 = ''
        WRITE(KF,'(7X,20A)') ('    ',I=1,34-LLET), ('',I=18,LLET),C1
        WRITE(KF,'(7X,20A4)') ('    ',I=1,34-LLET),  ('   ',CHAR(MOD(
     +    LKOD(0,I),100)),I=18,LLET), C2
        WRITE(KF,'(7X,20A)') ('    ',I=1,34-LLET), ('',I=18,LLET),C3
        WRITE(KF,'(7X,20(1X,A3))') ('    ',I=1,34-LLET),(CLN(.001*LKOD(
     +    1,I),3,2),I=18,LLET), C0
        WRITE(KF,'(7X,20(1X,A3))') ('    ',I=1,34-LLET),(CLN(.001*LKOD(
     +    2,I),3,2),I=18,LLET), C0
        WRITE(KF,'(7X,20(1X,A3))') ('    ',I=1,34-LLET),(CLN(.001*LKOD(
     +    3,I),3,2),I=18,LLET), C0
        WRITE(KF,'(7X,20A)') ('    ',I=1,34-LLET), ('',I=18,LLET),C4
      END IF
      END SUBROUTINE
C
      SUBROUTINE WAIT(N)
C  N > 0 calls for space before screen display
      DO I = 1,N; WRITE(6,'()'); END DO
      WRITE(6,'(" Hit RETURN to continue")')
      READ(5,'()')
      RETURN
      END

C 
c
c           BACKUP SCHEMATA:  Their Character and Manual Creation
c
c       Whenever program SCHEMAS saves a new or revised schema with basename
c   <type^dims>, it also writes the letter-instantiated frame of this (unless
c   it already exists in your active directory) to an ASCII backup file named
c   <type^dims>.BKi, with i an integer between 1 and 9, that you can read and
c   alter in a text-editor once you understand how its entries are composed.
c   When a backup is first written, it is given index i=1 while the indices
c   of older backups with this same basename are changed as needed to contrive
c   that indices for the <type^dims>.BK* backups are in increasing order of
c   age with deletion of the oldest if pushed out by nine more recent ones.
c   (You can override this age ordering, however, by renaming these manually.)
c   When you run SCHEMAS to create another schema whose type and dimensions
c   are respectively named by letters <type> and numbers <dims>, one option
c   is to review all the available backups with basename <type^dims> and, if
c   you find one similar if not identical to the lettered frame you want, to
c   start your new production with this.  These backups are "partial" in not
c   retaining any letter specifications you may have assigned to the schemata
c   for which these are backups; but once a schema's lettered frame is in
c   hand, letter specifications are simple to append.
c
c       There are two motives for these backups, both becoming salient when
c   a schema's dimensionality aproaches a size that can't be shown on screen
c   without row wrap or column splitting.  One is your having deleted or
c   substantially altered a complex schema created with considerable effort
c   previously, only to find now that you still want that.  The other is that
c   any backup file which SCHEMAS is now programmed to archive can also be
c   written by a text-editor to an ASCII textfile which, when suitbly named,
c   will be accepted by SCHEMAS as one of its own.  After a little practice,
c   you may well find it easier to create large-dimensional schemata with many
c   lettered cells this way than to enter the schema frame by keyboard during
c   the SCHEMAS run.  As you can discern after present advice by inspecting
c   any SCHEMAS-created backup in a text-editor, the backup for a frame
c   comprising NR rows and NC columns with L cells assigned letter proxies
c   for nonzero elements is a list of L+2 integers, each of which except
c   the second concatenates three information integers.  Listed first is
c   the integer that equals TYP*10000 + NR*100 + NC, where TYP is position
c   (1,2,..,5) in the sequence <PAT, APATH, APATR, COV, AV> of this backup's
c   type label that must start its basename.  Second comes the number L of
c   lettered cells to be declared.  And finally, in any order, come L integers
c   each having composition of form I*10000 + J*100 + K to code assignment
c   of the Kth alphebet letter (1 for A, ..., 26 for Z) to the matrix cell
c   in row I and column J.

