C                 Last revised:  10 September 2003
C
C   This routine generates an order-NF matrix Cff of normalized covariances
C having a stipulated structure defined by a causal-path model.  This Cff is
C intended for upload by program GENSCOR to be the common-factor covariances
C in production of simulation data having a stipulated raw pattern on these
C factors.

      CHARACTER(12) F1,F2,FF1,FF2, CF, NAME(40), C1*1, WORD*80, CLN*8
      INTEGER LKOD(0:3,26)
      CHARACTER,ALLOCATABLE:: FN(:)*3
      REAL,ALLOCATABLE:: A(:,:), Q(:,:), CFF(:), CU(:), R(:), D(:)
      INTEGER,ALLOCATABLE:: LST(:)
      DATA BL,BH,ZLO/-.2,.6,.2/
      LO(I,J) = J*(J-1)/2 + I
      LOC(I,J) = LO(MIN(I,J),MAX(I,J))
      COMMON /CF/ CF
      OPEN(2,STATUS='SCRATCH'); NUL = 0

CC TEST LINES
C      OPEN(21,FILE='JUNK')

C  Ŀ
C        SEMCOV's job is to compute the standardized covariances Cff among  
C   NF endogenous factors F = {fi} satisfing specified structural equation  
C                            F = AF + U                                    
C   wherein each ui in NF-tuple U = {ui} is an "exo-root" (disturbance      6
C   composite) of all exogenous influences on fi not mediated by other      6
C   factors in F. As pointed out in SEMCOV.TXT, numeric specification of    
C   path-structure A and exo-root covariances Cuu suffices to fix Cff.      
C                                                                           
C      Accordingly, SEMCOV (a) uploads an NF-factor path schema A you have  
C   created with program SCHEMAS, (b) assigns random values to A's dummy    
C   path coefficients within limits you stipulate, (c) imports or creates   
C   the model's matrix Cuu of exo-root covariances, and (d) saves the       7
C   standardized F-covariances these entries entail in an ASCII file having 
C   basename KOV<nf>, where <nf> is this production's numeric NF.  You can  
C   then upload this to be your endogenous-factor covariances when creating 
C   correlations among indicators for NF latent factors by applying GENCOV  
C   (which also generates population scores if wanted) to a raw measurement 
C   pattern, previously created by GENPAT or SCHEMAS, of NV data variables  5
C   on NF common factors.                                                   52
C  

      CALL SYSTEM('cls')
      WRITE(6,'("  ",73(""),"")')
      WRITE(6,'("        SEMCOV''s job is to compute the standardize",
     +  "d covariances Cff among  "/"   NF endogenous factors F = {",
     +  "fi} satisfing specified structural equation  "/"  ",26X,"F",
     +  " = AF + U",36X,""/"   wherein each ui in NF-tuple U = {ui",
     +  "} is an ""exo-root"" (disturbance      "/"   composite) of",
     +  " all exogenous influences on fi not mediated by other      "/
     +  "   factors in F. As pointed out in SEMCOV.TXT, numeric spec",
     +  "ification of    "/"   path-structure A and exo-root covari",
     +  "ances Cuu suffices to fix Cff.      "/"  ",73X,""/"  ",4X,
     +  "Accordingly, SEMCOV (a) uploads an NF-factor path schema A y",
     +  "ou have  "/"   created with program SCHEMAS, (b) assigns r",
     +  "andom values to A''s dummy    "/"   path coefficients with",
     +  "in limits you stipulate, (c) imports or creates   "/"   th",
     +  "e model''s matrix Cuu of exo-root covariances, and (d) saves",
     +  " the       "/"   standardized F-covariances these entries ",
     +  "entail in an ASCII file having "/"   basename KOV<nf>, whe",
     +  "re <nf> is this production''s numeric NF.  You can  "/"   ",
     +  "then upload this to be your endogenous-factor covariances wh",
     +  "en creating "/"   correlations among indicators for NF lat",
     +  "ent factors by applying GENCOV  "/"   (which also generate",
     +  "s population scores if wanted) to a raw measurement "/"   ",
     +  "pattern, previously created by SCHEMAS or GENPAT, of NV data",
     +  " variables  "/"   on NF common factors.",51X,"")')
      WRITE(6,'("  ",73(""),"")')  ! ; CALL WAIT(0)

11    WRITE(6,'(/3X,"Enter the number NF of endogenous factors wanted"
     +  " (not exceeding 99)."/)')
      CALL SCANR(J,0,'I',NUL); IF(J<1) GOTO 11
      READ(2,*) NF; IF(NF>99.OR.NF<1) GOTO 11
      FF1 = 'APATH'//CF(:JF(NF))//'.*'; FF2 = FF1; FF2(5:5) = 'R'
      L1 = -1; CALL LOOK(1,FF1,NAME,40,L1); MSG = 0
      L2 = -1; CALL LOOK(1,FF2,NAME,40,L2); LDT = 5+JF(NF)+1
      IF(L1+L2==0) THEN
        WRITE(6,'(8X,"There are no ",A,"-factor path schemata avail",
     +    "able here."/8X,"Call program SCHEMAS and create one.")')
     +    CF(:JF(NF)); STOP
      END IF
13    WRITE(6,'(3X,"The ",A,"-factor path schemata available here ",
     +  "are")') CF(:JF(NF))
      CALL LOOK(0,FF1,NAME,40,J1)
      CALL LOOK(3,FF2,NAME,40,J2); WRITE(6,'()')
      IF(MSG==0) WRITE(6,'(3X,"If the ",A," you typed was the wrong ",
     +  "NF, enter a letter.  Otherwise,")') CF(:JF(NF))  ! Only at startup
15    IF(J2>1) THEN; C1 = 'e'; IF(MSG/=0) C1 = 'E'  ! More than one APATs
        WRITE(6,'(3X,A,"nter the index of a here-listed APAT you want",
     +    " to consider.  Note")') C1
        IF(L1==0) WRITE(6,'(3X,"that these are all recursive.")')
        IF(L2==0) WRITE(6,'(3X,"that these are not subdiagonal and may",
     +    " be nonrecursive.")')
        IF(L1*L2>0) WRITE(6,'(3X,"APATH schemata, unlike APATR, are ",
     +    "not subdiagonal and may be nonrecursive.")')
        WRITE(6,'()')
        CALL SCANR(J,0,'I',NUL); IF(J<0) GOTO 11; IF(J<1) GOTO 17
        READ(2,*) KK; KK = MAX(1,MIN(L1+L2,KK)); GOTO 20
      ELSE
        L=6;IF(L1==0) L=2;WORD(:10)='may be non';IF(L==2) WORD(:3)='is '
        WRITE(6,'(3X,"hit RETURN to examine the listed schema.  It ",
     +    A," recursive.")') WORD(:L)
        CALL SCN(J); IF(J<0) GOTO 11; IF(J>0) GOTO 17
        KK = 1; GOTO 20
      END IF
17    WRITE(6,'(" ***** Enter anything to confirm that you want to ",
     +  "quit."/9X,"Otherwise, hit RETURN to reconsider.")')
      CALL SCN(J); IF(J==0) GOTO 15; STOP
20    F1 = NAME(KK); LL=L1; IF(KK>L1) LL=L2; NFF = LO(NF,NF)
      READ(NAME(LL)(LDT+1:),*) MM  ! Largest listed extension of selected kind
      IF(.NOT.ALLOCATED(A)) ALLOCATE ( A(NF,NF), Q(NF,NF), CFF(NFF),
     +        LST(0:NF*NF), CU(NFF), R(NF), D(NF) )
      CALL SKEME(NF,NF,F1,MM,A,FUZ,LST,LKOD,LLET,MSG)
      IF(MSG/=0) THEN
        WRITE(6,'(4X,"Enter anything to redisplay the schema list f",
     +    "or another pick."/4X,"Otherwise, hit RETURN to quit.")')
        CALL SCN(J); IF(J==0) GOTO 17; GOTO 13
      END IF
      WRITE(6,'("  Presumably, you are satisfied with the raw path s",
     +  "tructure now in place and"/"  are ready to fix disturbance ",
     +  "(exo-root) correlations.  If so, hit RETURN"/"  to continue",
     +  ".  If not, enter anything to quit and ponder why.")')
      CALL SCN(J); IF(J/=0) STOP
      CALL SYSTEM('cls'); FF1 = F1; FF2 = ' ' ! FF1 saves the input pattern file

C ============== A-matrix is set; now get Cuu ====================
C   Ŀ
C    You can enter disturbance correlations Cuu in one of three ways:     
C      1) Randomize Cuu here under loose obliquity controls.              
C      2) Retrieve a COV-schema previously created by program SCHEMAS.    
C      3) Upload the Cff with basename KOVxx derived from a structural    
C           model F = BF + G or EFA model F = WF2 + E of F's exo-roots  
C           by previous application of Gendata resources.                 17
C   

C  Option 1 requires the least advance planning - you create Cuu here and
C  now with only two or three control decisions - and should probably be
C  your first choice if you don't want to posit fully uncorrelated exo-roots
C  yet are hazy on how best to relax that.  But you will also find it easy
C  to create Cuu by a prior run of SCHEMAS once you decide where to put its
C  obliquities.  In contrast, Option 3 is a planning-intensive concatenation
C  of path structures that you should avoid until your experience with Gendata
C  procedures has become considerable.

      WRITE(6,'(4X,"",70(""),"")')
      WRITE(6,'(4X," You can enter disturbance correlations Cuu in ",
     +  "one of three ways:",5X,"")')
      WRITE(6,'(4X,"   1) Randomize Cuu here under loose obliquity",
     +  " controls.",14X,"")')
      WRITE(6,'(4X,"   2) Retrieve a COV-schema previously created ",
     +  "by program SCHEMAS.",4X,"")'); K = JF(NF); WORD = ' '
      WRITE(6,'(4X,"   3) Upload the Cff with basename KOV",A," der",
     +  "ived from a structural",A," "/4X,"",8X,"model F = BG + E or",
     +  " EFA model F = WF2 + U of F''s exo-roots",2X,""/4X,"",8X,
     +  "by previous application of Gendata resources.",17X,"")')
     +  CF(:JF(NF)), WORD(:5-K)
      WRITE(6,'(4X,"",70(""),""/)')

      WRITE(6,'(4X,"Option 1 requires the least advance planning - y",
     +  "ou create Cuu here and"/4X,"now with only two or three contr",
     +  "ol decisions - and should probably be"/4X,"your first choic",
     +  "e if you don''t want to posit fully uncorrelated exo-roots "/
     +  4X,"yet are hazy on how best to relax that.  But you will al",
     +  "so find it easy"/4X,"to create Cuu by a prior run of SCHEMA",
     +  "S once you decide where to put its"/4X,"obliquities.  In co",
     +  "ntrast, Option 3 is a planning-intensive concatenation"/4X,
     +  "of path structures that you should avoid until your experie",
     +  "nce with Gendata"/4X,"procedures has become considerable.")')
      WRITE(6,'(/6X,"If you aren''t sure of what you want in Cuu and ",
     +  "are willing to let the"/6X,"program arrogate most of that, h",
     +   "it RETURN to accept Option 1.  Otherwise,"/6X,"enter anythi",
     +   "ng to upload a ",A,"-factor COV-file created previously.")')
     +   CF(:JF(NF))
      CALL SCN(J); IF(J==0) GOTO 51  ! If J=0 goto Option (1) old code
      F1 = 'COV'//CF(:JF(NF))//'*.*'
      N2 = -1; N3 = -1  ! Suppress screen output from LOOK
      CALL LOOK(1,F1(:LAST(F1)),NAME,40,N2)         ! Option (2) calls COV<nf>*.<i>
      CALL LOOK(1,'K'//F1(2:LAST(F1)),NAME,40,N3)   ! Option (3) calls KOV<nf>*.*
      IF(N3==0) THEN
        WRITE(6,'(9X,"No previously prepared Cuu is available here.",
     +    "  Enter"/9X,"anything to go with Option 1 or hit RETURN ",
     +    "to quit.")')
        CALL SCN(J); IF(J==0) STOP; GOTO 51
      END IF
      C1 = '2'; IF(N2==0) C1 = '3'; J = JF(NF)
      IF((N3-N2)*N2==0 ) WRITE(6,'(" Your Cuu candidates (Option ",A,
     +  " files only) are")') C1
      IF((N3-N2)*N2>0 ) WRITE(6,'(" Your COV",A," (Option 2) and KOV",
     +  A," (Option 3) candidates for Cuu are")') CF(:J), CF(:J)
      CALL LOOK(1,F1(:LAST(F1)),NAME,40,N2)
      CALL LOOK(1,'C'//F1(:LAST(F1)+1),NAME,40,N3); NN = N3
27    F1 = NAME(NN)
      IF(N3==1) WRITE(6,'(/6X,"Hit RETURN to upload ",A," for your ",
     +  "Cuu.  Otherwise enter"/6X,"any letter to go with Option 1,",
     +  " or any numeral to quit.")') F1(:LAST(F1))
      IF(N3>1) WRITE(6,'(/6X,"Hit RETURN to upload ",A," for your Cu",
     +  "u.  Otherwise, enter the"/6X,"index of another listed file",
     +  " or any letter to accept Option 1.")') F1(:LAST(F1))
      CALL SCANR(J,1,'I',NUL); IF(J==-1) GOTO 51; IF(J>-1) GOTO 27
      IF(J==0) GOTO 30; IF(J>0.AND.N3==1) STOP
      READ(2,*) K; NN = MIN(ABS(K),N3); GOTO 27
30    IF(F1(:3)=='COV') THEN ! Return instantiated COV<nf> in CFF
        CALL SKEME(NF,NF,F1,N2,Q,FUZ,LST,LKOD,LLET,MSG)   ! SKEME starts by uploading F1
        IF(MSG/=0.AND.N3>1) THEN     ! returns instantiated Cuu in square Q
          WRITE(6,'(4X,"Enter anything to redisplay the schema listing",
     +      " for another pick."/4X,"Otherwise, hit RETURN to quit.")')
          CALL SCN(J); IF(J==0) GOTO 17; GOTO 13
        ELSE IF(MSG/=0) THEN
          WRITE(6,'(/6X,"Since Options 2 and 3 aren''t productive on ",
     +      "this run, hit RETURN"/6X,"to create Cuu by Option 1.  Ot",
     +      "herwise, enter anything to quit.")')
          CALL SCN(J); IF(J==0) GOTO 51; STOP
        ELSE   ! Upload from schema is OK, so copy from square storage to symm
          DO J = 1,NF; DO I = 1,J
            CU(LO(I,J)) = Q(I,J)  ! So far, Q is just a workspace
          END DO; END DO
        END IF
        GOTO 55
      ELSE IF(F1(:4)=='KOV') THEN
        CALL START(7,F1)
        READ(7,*) M, MM
        IF(M/=NF .OR. MM/=NFF) GOTO 31
        READ(7,*,ERR=31) (CU(I),I=1,NFF)
        S = CU(1); CU = CU/S
        CLOSE(7)
      END IF
      FF2 = F1  ! FF2 will be blank if Option 1 bypasses this line
      GOTO 55   ! If upload is successful
31    WRITE(6,'(" File ",A," has become corrupt.")') F1(:LAST(F1))
      GOTO 13
C  Option 1
51    FF2 = ' '  ! Blank flags internally created Cuu
      CALL EZCOV(NF,NFF,BL,BH,CU,IER)  ! Covs returned in CU which must be sym-storage
55    ZL=ZLO; CALL TWEAK(NF,NFF,CU,R,ZL,'Cuu',IER,1)  ! Make this a goto common to all Options
C   If you are satisfied with the endogenous path structure and exogenous
C   source correlations (A and Cuu) you have specified and are ready to
C   compute the endogenous factor correlations these entail, hit RETURN to
C   finish.  Otherwise, enter anything to quit and rethink what you want.

        WRITE(6,'(/"  If you are satisfied with the endogenous path ",
     +    "structure and exogenous"/"  source correlations (A and Cu",
     +    "u) you have specified and are ready to"/"  compute the en",
     +    "dogenous factor correlations these entail, hit RETURN to"/
     +    "  finish.  Otherwise, enter anything to quit and rethink",
     +    " what you want.")')
        CALL SCN(J); IF(J/=0) STOP
      Q = 0; DO I = 1,NF; Q(I,I) = 1.; END DO
      Q = Q - A   ! Q = I-A, now convert to inverse
      CALL MINV(NF,Q,NF,IER)
      IF(IER/=0) THEN
        WRITE(6,'(" >>> ERROR: Unable to invert I-A.  Respecify A and",
     +    " try again.")'); STOP
      END IF
C Get CFF from Q = Inv(I-A) and Cuu:  F = QU so Cff = QCuuQ'
C In C:\MV\TRICKS.SEE for sym-storage of square CF and CU. CF = Q*CU*Q':
C CF(i,j) = kl Q(i,k)*CU(k,l)*Q'(l,j) = k Q(i,k)*(l CU(k,l)*Q(j,l) ); so
      CFF = 0.
      DO J = 1,NF
        DO K = 1,NF; S = 0.
          DO L = 1,NF
            S = S + CU(LOC(K,L))*Q(J,L)
          END DO
          DO I = 1,J
            CFF(LO(I,J)) = CFF(LO(I,J)) + Q(I,K)*S
          END DO
        END DO
      END DO

C Now rescale F to have unit variances with effects on A and CU
C Theorem: Let D be the diagonal matrix of SDs in Cff while F = AF + U.
C   And let M =def Inv(M) for any invertable M.  Then G = DF is the unit-
C   variance rescaling of F, and G = DADG + DU.  Hence in reduced form
C   G = [I-(DAD)](DU).  So if F = AF + U and we want coefficients B
C   and multiplicative rescaling V of U such that G = BG + V for the unit-
C   variance rescaling G of F,  B = DAD, V = DU, and Cvv = DCuuD.

C  #########   B (or A below) is the normed A-matrix wanted by MORSCOR

      DO J = 1,NF; D(J) = SQRT(CFF(LO(J,J))); END DO
      DO J = 1,NF
        DO I = 1,NF
          A(I,J) = A(I,J)*D(J)/D(I)
        END DO
        DO I = 1,J
          CU(LO(I,J)) = CU(LO(I,J))/(D(I)*D(J))
        END DO
      END DO

C A (Af) is now the path matrix for unit-norm endogenous factors G = DF;
C CU contains the covariances of V in G = AG + V.
CC >>> Silly: Cgg = DCffD is all that is needed but can use this to check
CC      Q = 0; DO I = 1,NF; Q(I,I) = 1.; END DO
CC      Q = Q - A  ! Q = I-A, now convert to inverse
CC      CALL EIGS(NF,0,Q,NF,R,Z,0,NF,IER,6)  ! Z is a dummy; don't need eivecs
CCC So now F = QV, Cff = QCvvQ' with unities on Cff's diagonal. (Cvv is in CU)
CC      CFF = 0.
CC      DO J = 1,NF
CC        DO K = 1,NF; S = 0.
CC          DO L = 1,NF
CC            S = S + CU(LOC(K,L))*Q(J,L)
CC          END DO
CC          DO I = 1,J
CC            CFF(LO(I,J)) = CFF(LO(I,J)) + Q(I,K)*S
CC          END DO
CC        END DO
CC      END DO

      DO J = 1,NF
        CFF(LO(J,J)) = 1.
        DO I = 1,J-1
          CFF(LO(I,J)) = CFF(LO(I,J))/(D(I)*D(J))
        END DO
      END DO
C Cff is finished; save in ASCII KOV<nf> file
      JJ = JF(NF); F1 = 'KOV'//CF(:JJ)//'.*'; LDT = 4+JJ
      F2 = F1; LL = 0; N = 0
71    L1 = -1; CALL LOOK(1,F2,NAME,40,L1)
72    N = N+1; IF(N>9) N=0; F2(LDT+LL+1:) = CF(:JF(N))
      IF(N==0) GOTO 75 ! only if maxed out on count
      DO I = 1,L1; IF(F2==NAME(I)) GOTO 72; END DO  ! Scan Namelist for match
75    WRITE(6,'(4X,"Endogenous factor correlations Cff are ready for",
     +  " GENDATA to conjoin with"/4X,"a measurement pattern.  Hit ",
     +  "RETURN to approve their storage under name "/4X,A,".  Othe",
     +  "rwise, enter one or two letters to start an alternative"/4X,
     +  "extension for basename ",A,".  (The extension''s finish is",
     +  " reserved")') F2(:LAST(F2)), F2(:3+JJ)
      IF(L1==0) WRITE(6,'(4X,"for a numeric index.)  No older ",A,
     +  "* files are now in store.")') F2(:LAST(F2)-1)
      IF(L1>0) WRITE(6,'(4X,"for a numeric index.)  The older ",A,
     +  "* files now in store are",10(/4X,6A12))') F2(:LAST(F2)-1),
     +  (NAME(I)(:10),I=1,L1)
      WRITE(6,'()'); LL = LDT
      READ(5,'(A)') WORD; M = LAST(WORD)
      IF(M==0) GOTO 80; F2 = F1; N = 0
      DO I = 1,M; N1 = ICHAR(WORD(I:I)); IF(N1>96) N1 = N1-32
        IF(N1>64.AND.N1<91) THEN ! ^N1 is ASCII code for letter
          LL=LL+1; F2(LL:LL) = CHAR(N1); IF(LL==LDT+2) EXIT
        END IF
      END DO   ! F1's extension is still just *
      F2(LL+1:) = '*'; N = 0; LL = LL-LDT
      GOTO 71
80    OPEN(8,FILE=F2)
      WRITE(8,'(" The Cff above the date-stamp here, originally and p",
     +  "robably still named ",A,","/" comprises correlations to thre",
     +  "e decimals with point omitted.  It was created"/" by SEMCOV ",
     +  "using A-schema ",A," for ",A," endogenous factors F having")')
     +  F2(:LAST(F2)), FF1(:LAST(FF1)), CF(:JF(NF))
      M=ICHAR(FF2(1:1)); K=2; IF(M<65) K = 1; IF(M==75) K = 3
      IF(K<2) WRITE(8,'(" semi-random exo-root correlations generated",
     +  " internally (Cuu by Option 1).")')
      IF(K==2) WRITE(8,'(" exo-root correlations instantiating schema",
     +  1X,A," (Cuu by Option 2).")') FF2(:LAST(FF2))
      IF(K>2) WRITE(8,'(" SE-modeled exo-root correlations uploaded ",
     +  "from file ",A," (Cuu by Option 3).")') FF2(:LAST(FF2))
      WRITE(8,'(/I3,1X,A)') NF, CF(:JF(NFF))
      DO J = 1,NF
        WRITE(8,'(25I5,4(/2X,25I5))') (NINT(1000*CFF(LO(I,J))),I=1,J)
      END DO
      WRITE(8,'()'); CALL DAY(8); WRITE(8,'()'); WORD = ' '
      ALLOCATE ( FN(NF) ); FN = ' '; IF(NF<25) WORD(:3) = ''
      DO I = 1,NF
        FN(I)(2-MIN(1,I/10):) = 'f'//CF(:JF(I))
      END DO
      WRITE(8,'(" The causal-path structure (A-matrix) in this Cff''s",
     +  " production is:")') ! ######### Put code in GENSCOR to read this A
      WRITE(8,'(5X,"",25(2X,A,1X),3(:/5X,"  ",25(2X,A,1X)))')
     +  (FN(I),I=1,NF), WORD(1:1)
      WRITE(8,'("",27A)') ('',I=1,MIN(NF,25)), '',
     +  WORD(2:2)            ! Line length: 6 + 6*NF + 6 = 6*NF+2  $$$$$$$$
      DO I = 1,NF            ! Col count 3 + (NF+1)/25
        WRITE(8,'(1X,A," ",25A6, 3(:/5X,"  ",25(A6)))') FN(I),
     +     (CLN(A(I,J),6,3),J=1,NF), '  '//WORD(1:1)//'   '
      END DO
      WRITE(8,'(5X,"",27A)') ('',I=1,MIN(NF,25)), '',
     +  WORD(3:3)

C        f1 .  f2 .  f3 .  f4 .  f5 .  f6 .  f7 .  f8 .  f9 . f10 . f11 . f12 . f13 . f14 . f15 . f16 . f17 . f18 . f19 . f20 . f21 . f22 . f23 . f24 . f25 .
C          f1 .  f2 .  f3 .  f4 .  f5 .  f6 .  f7 .  f8 .  f9 . f10 . f11 . f12 . f13 . f14 . f15 . f16 . f17 . f18 . f19 . f20 . f21 . f22 . f23 . f24 . f25 .
C  
C  f1  x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333
C        x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333 x.222 x.123 x.333

      IF(FUZ<.001) WRITE(8,'(/" With no background fuzz, this instant",
     +  "iated schema ",A,":"/)') FF1(:LAST(FF1))
      IF(FUZ>=.001) WRITE(8,'(/" With background fuzz level ",A4,
     +  ", this instantiated schema ",A,":"/)') CLN(FUZ,4,3),
     +  FF1(:LAST(FF1))
      CALL SHO(NF,NF,KIND,FF1,LKOD,LST,LLET,-3,8)
      WRITE(8,'(/" The covariances imposed on these factors'' exo-root",
     +  "s (to three decimals, point omitted),"/" scaled to give them ",
     +  "unit weights in standardized-F production F = AF + U, are")')
      DO J = 1,NF
        WRITE(8,'(25I5,4(/2X,25I5))') (NINT(1000*CU(LO(I,J))),I=1,J)
      END DO

c Done! File xxxxxxxx is ready for GENSCOR to upload.  Since it is written
c       in ASCII, it can be inspected in a text-editor. It also contains the
c       finalized pathweight matrix A and exo-root correlations Cuu from which
c       this Cff was constructed, which you will need if you plan to test how
c       accurately analysis of simulation data with this composition can be
c       be solved for its source parameters.

      WRITE(6,'(/" Done. File ",A," is ready for GENSCOR to upload.  ",
     +  "Since it is written"/7X,"in ASCII, it can be inspected in a ",
     +  "text-editor. It also contains the"/7X,"finalized pathweight ",
     +  "matrix A and exo-root correlations Cuu from which "/7X,"this",
     +  " Cff was constructed, which you will need if you plan to tes",
     +  "t how"/7X,"accurately analysis of simulation data with this ",
     +  "composition can be"/7X,"solved for its source parameters.")')
     +  F2(:LAST(F2))
      STOP
      END
C
      FUNCTION CLN(X,NFF,ND)
C Express real number X as a character string in fieldwidth NF with LD decimals
C when room, where LD = ABS(ND).  ND<0 tries to precede all positive numbers
C with a blank. LD > 9 displays zero decimals and no decimal point while
C returning X = 0 as ND-10 zeros right-justified in selected field.
C ***** WARNING: If a call of CLN prints garbage, you have forgotten to
C       declare CLN as CHARACTER*8 in the calling routine.
      PARAMETER (KW=16)
      CHARACTER CLN*8, WK(KW)
      CLN = '        '
      NF = MIN(8,NFF)  ! Limit fieldwidth to 8 chars
      LD = ABS(ND)
      IF(ABS(X)<1.0E-12) THEN !  Special for vanishingly small X
        N = MIN(NF-1,MOD(LD,10))
        IF(LD<10) CLN(NF-N:NF+1-N) = '.0'
        IF(LD<10) RETURN
        DO I = 1,N
          CLN(NF+1-I:NF+1-I) = '0'
        END DO
        RETURN
      END IF
      M = NF; IF(ABS(X)>1.) M = NF-1-INT(LOG10(ABS(X))) !  M is space free for decimal (or M-1 if X<0) )
      IF(M<0 .OR. M<1.AND.X<0.) GOTO 55
      IF(ND>=10) LD = 0; LD = MIN(LD,M)
      DO I = 1,KW
        WK(I) = ' '
      END DO
      IF(LD==0) N = NINT(ABS(X))         ! Shouldn't be needed, but is
      IF(LD/=0) N = NINT(ABS(X)*10**LD)  ! This can overflow if LD is large
      DO I = KW,KW-LD+1,-1
        WK(I) = CHAR(48+MOD(N,10))
        N = N/10
      END DO
      WK(KW-LD) = '.'
      IF(N==0 .AND. LD==0) WK(KW-LD-1) = '0'
      IF(N==0 .AND. X<0. .AND. LD>0) WK(KW-LD-1) = '-'
      DO I = KW-LD-1,2,-1
        IF(N>0) WK(I) = CHAR(48+MOD(N,10))
        IF(N>0 .AND. X<0.) WK(I-1) = '-'
        N = N/10
      END DO
      KS = KW-NF+1
25    KS = KS-1
C       Field returned will start at WK(KS+1) for initial KS
      IF(KS<=0) GOTO 50
      IF(ND>=0) THEN
        IF(WK(KS)/=' ' .AND. WK(KS+NF)/='.') GOTO 25
      ELSE
        IF(WK(KS+1)/=' '. AND. WK(KS+1)/='-' .AND. WK(KS+NF)/='.')
     +    GOTO 25
      END IF
      IF(ND>=10) KS = MAX(1,KS-1)
      DO I = 1,NF
        CLN(I:I) = WK(KS+I)
      END DO
50    IF(WK(KS)==' ') RETURN
55    CLN = ' *******'
      END FUNCTION
C
      SUBROUTINE DAY(N)
C This date-stamps output file N
      CHARACTER ZZZ*8, WORD*18, CF*12, LST(12)*10
      COMMON /CF/ CF
      DATA LST/'January  7','February 8','March    5','April    5',
     +         'May      3','June     4','July     4','August   6',
     +         'September9','October  7','November 8','December 8'/
      CALL DATE_AND_TIME(ZZZ)  ! Last three outputs not used here
      M = 10*(ICHAR(ZZZ(7:7))-48) + ICHAR(ZZZ(8:8))-48  ! M gets day of month
      READ(ZZZ(5:6),*) L; K = ICHAR(LST(L)(10:10))-48
      WORD = CF(:JF(M))//' '//LST(L)(:K)//' '//ZZZ(:4)
      WRITE(N,'(/" Date of this run:  ",A)') WORD
      END SUBROUTINE

      SUBROUTINE EZCOV(NF,NFF,BL,BH,CFF,IER)
C The random selection of covs returned in CFF requires CFF to be sym-storage
      CHARACTER CLN*8, CF*12, C4*4
      INTEGER KOV(NFF)
      REAL CFF(NFF), R(NF), X(2)
      COMMON /CF/ CF
      LO(I,J) = J*(J-1)/2 + I
cc      LOC(I,J) = LO(MIN(I,J),MAX(I,J))

C  Ŀ
c    Creation here of a semi-random Cff for xx factors requires you to enter 
c                                                                            
c    1) an integer NC and if NC>0 an interval <BL,BH> within limits -1 to +1 1
c       such that NC of the xxx distinct proper correlations are to receive  2
c       random values provisionally between BL and BH while the rest are     5
c       zero.  And unless you make Cff fully orthogonal by stipulating       7
c       NC = 0, you will also be invited to choose                           
c                                                                            
c    2) a value LOW between 0 and 1 to be the smallest eigenvalue of the     
c       created correlation matrix.                                          
c                                                                            
c       Given these parameters, SEMCOV first generates an order-NF symmetric 1
c    matrix Q with unit diagonal and zeros or random values between BL and   3
c    BH elsewhere.  It then tweaks Q into a correlation matrix Cff having    4
c    the same off-diagonal correlation ratios and zeros (orthogonalities)    4
c    as Q while making LOW its smallest eigenvalue.                          26
C  

      CALL SYSTEM('cls');  NT = NFF-NF; NC = 0
      WRITE(6,'("  ",74(""),"")'); JJ = JF(NF); C4 = '    '
      WRITE(6,'("    Creation here of a semi-random Cff for ",A,
     +  " factors requires you to enter",A,"")') CF(:JJ), C4(:3-JJ)
      WRITE(6,'("  ",74(" "),"")'); JJ = JF(NT)
      WRITE(6,'("    1) an integer NC and if NC>0 an interval <BL,B",
     +  "H> within limits -1 to +1 "/2X,"",5X,"such that NC of th",
     +  "e ",A," distinct proper correlations are to receive",A,""/
     +  2X,"",5X,"random values provisionally between BL and BH whi",
     +  "le the rest are",5X,""/2X,"",5X,"zero.  And unless you ma",
     +  "ke Cff fully orthogonal by stipulating",7X,""/2X,"",5X,
     +  "NC = 0, you will also be invited to choose",27X,"")')
     +  CF(:JJ), C4(:5-JJ )
      WRITE(6,'("  ",74(" "),"")')
      WRITE(6,'("    2) a value LOW between 0 and 1 to be the small",
     +  "est eigenvalue of the",5X,""/2X,"",5X,"created correlation",
     +  " matrix.",42X,"")')
      WRITE(6,'("  ",74(" "),"")')
      WRITE(6,'("  ",5X,"Given these parameters, SEMCOV first gen",
     +  "erates an order-NF symmetric "/2X,"  matrix Q with unit ",
     +  "diagonal and zeros or random values between BL and   "/2X,
     +  "  BH elsewhere.  It then tweaks Q into a correlation matri",
     +  "x Cff having    "/2X,"  the same off-diagonal correlation",
     +  " ratios and zeros (orthogonalities)    "/2X,"  as Q while",
     +  " making LOW its smallest eigenvalue.",26X,"")')
      WRITE(6,'("  ",74(""),"")'); CALL WAIT(0)
      CFF = 0.; DO J = 1,NF; CFF(LO(J,J)) = 1.; END DO   ! Orthnorm Cff default
11     WRITE(6,'(/3X,"The count NC of distinct factor correlations to ",
     +  "make oblique (nonzero)"/3X,"is now set at ",A," out of a maxi",
     +  "mum ",A,".  Hit RETURN if OK, or enter the"/3X,"number of obl",
     +  "iquities you prefer in Cff."/)') CF(:JF(NC)), CF(:JF(NT))
      CALL SCANR(J,1,'I',NUL); IF(J<0) GOTO 11
      IF(J>0) THEN; READ(2,*) M; NC=MIN(ABS(M),NT); GOTO 11; END IF
      IF(NC*(NT-NC)==0) THEN
        IF(NC==0) WRITE(6,'(" Hit RETURN to confirm that you want ",
     +    "only orthogonal factors.")')
        IF(NC==NT) WRITE(6,'(" Hit RETURN to confirm that you don''t",
     +    " require any factor orthogonalities.")')
        WRITE(6,'(" Otherwise, enter anything to reconsider your NC ",
     +     "setting.")')
        CALL SCN(J); IF(J/=0) GOTO 11
        IF(NC==0) RETURN     ! Orthogonal Cff already set as default
      END IF
      KOV = (/(I,I=1,NFF)/)
      IF(NC==NT) GOTO 30  ! In this case exend NC to NFF and later fix diagonal
      DO I = 1,NF; KOV(LO(I,I)) = 0; END DO
      DO I = 0,NC-1
        I1 = I+1
21      K = MIN(NFF,I1+INT((NFF-I)*RANDY()))
        IF(KOV(K)==0) GOTO 21
        L = KOV(K); KOV(K) = KOV(I1); KOV(I1) = L
      END DO ! ^KOV now lists NC random off-diagonal sym-storage coordinates
30    WRITE(6,'(/" Ready to randomize oblique factor correlations be",
     +  "tween limits now set at"/" <",A3,",",A4,">.  Hit RETURN if ",
     +  "these limits are OK, or enter new pair."/)') CLN(BL,3,2),
     +  CLN(BH,4,2)
      CALL SCANR(J,0,'R',NUL)
      IF(J==0) GOTO 40
      IF(J<0) GOTO 30
      READ(2,*) (X(I),I=1,MIN(J,2)); IF(J==1) X(2) = X(1)
      IF( ABS(X(1)) >1. .OR. ABS(X(1)) >1. ) THEN
        DO I = 1,2; IF( ABS(X(I)) >1.) X(I) = X(I)/10; END DO
      END IF
      BL = MAX(-1.,MIN(1.,X(1),X(2)))
      BH = MIN(1.,MAX(-1.,X(1),X(2)))
      GOTO 30
40     IF(ABS(BH)<.01) THEN
        WRITE(6,'(" Hit RETURN to confirm your belated call for all-o",
     +    "rthogonal factors."/" Otherwise, enter anything to reconsi",
     +    "der.")')
        CALL SCN(J); IF(J/=0) GOTO 30
        CFF = 0.; DO I = 1,NF; CFF(LO(I,I)) = 1.; END DO
        ZLO = 1.;  RETURN
      END IF
C Generate raw Cuu
      BD = BH-BL; NN = 0; MM = 20
50    DO I = 1,NC
        CFF(KOV(I)) = BL + BD*RANDY()
      END DO
      DO I = 1,NF; CFF(LO(I,I)) = 1.; END DO
      CALL EIGS(NF,NF,CFF,NFF,R,X,NV,0,IER,6); ZLO = R(NF); NN = NN+1
      IF(ZLO<.001.AND.NN<=MM) GOTO 50    ! Precaution surely never needed
      ZLO = .1; CALL TWEAK(NF,NFF,CFF,R,ZLO,'Cuu',IER,0)
      END SUBROUTINE ! ^ wants the covs to be in sym-storage

      FUNCTION JF(N)
C Return character expression of integer N left-justified in field CF; then
C CF(:JF(N)) writes N with exactly the right length in format specifier A.
C *** Haven't found any way to avoid requiring N to be INTEGER(4).
      CHARACTER(12) CF
      INTEGER(4) K
      COMMON /CF/ CF
      K = ABS(N)
      CF = '            '
      J = 13
10    J = J-1
      CF(J:J) = CHAR(48+MOD(K,10))
      K = K/10
      IF(K>0) GOTO 10
      IF(N<0) CF(J-1:J-1) = '-'
      CF = ADJUSTL(CF)
      JF = LEN_TRIM(CF)
      END FUNCTION

      SUBROUTINE SKEME(NY,NF,F1,MM,B,FUZ,LST,LKOD,LLET,MSG)
C F1 is the uploaded schema, MM the largest index of stored files of F1's kind.
C B returns a full instantiation of schema F1.
      CHARACTER*12  CF, F1, CLN*8, WORD*7, PL*2    ! , CK*1
      INTEGER  LKOD(0:3,26), LKBK(0:3,26), LST(0:NY*NF), LTRS(0:NY*NF)
      REAL  X(20), B(NF,NF)
      NDIG(N) = (MAX(1,N)/48)*(57/MAX(1,N))  ! 1 if N is ICHAR for digit; otherwise, 0
      NLET(N) = (MAX(1,N)/64)*(90/MAX(1,N))  ! 1 if N is ICHAR for cap letter or @; otherwise, 0
      COMMON /CF/ CF
      SAVE LSHO  ! Flag for info display
      MSG = 0; LSHO = 1
      KIND = 3; IF(F1(5:5)=='H') KIND = 2; IF(F1(5:5)=='R') KIND = 4
CC      CK = 'A'; IF(KIND==3) CK = 'C'
      GOTO 30
23    WRITE(6,'(" Apologies: File ",A," is corrupt.  Try another.")')
     +  F1(:LAST(F1)); CLOSE(7); MSG = -1; RETURN
30    OPEN(7,FILE=F1,FORM='UNFORMATTED')
      READ(7,ERR=23) NL, (LST(I),I=1,NL); LST(0) = NL
      READ(7,ERR=23) LLET, ((LKOD(I,J),I=0,3),J=1,LLET)
      CLOSE(7)
      IF(KIND==2) THEN; IE = 0
        DO K = 1,NL  !
          I = LST(K)/10000; J = MOD(LST(K)/100,100)
          IF(I<=J) IE = IE+1  ! IE>0 flags not subdiagonal
        END DO
      END IF
C ========= Start of schema display ==========
32    CALL SHO(NY,NF,KIND,F1,LKOD,LST,LLET,1,6)
      IF(KIND==2) THEN
        LL = LOOP(NF,LST)
        IF(LL>0) WRITE(6,'(" >>> WARNING: This path structure is non",
     +    "recursive; ",A," factors are looped.")') CF(:JF(LL))
        IF(IE>0.AND.LL==0) WRITE(6,'(5X,"NOTE: Although not subdiago",
     +    "nal, this path structure is recursive.")')
      END IF
      IF(LSHO>0.OR.NF>5) CALL WAIT(0)

C =============== Start of letter specifications ==================
      DO I = 1,NL
        LTRS(I) = MOD(LST(I),100)     ! LTRS collects letter entries with repetitions
      END DO
      LLET = 0
      OUTER: DO L = 65,90    ! Alphabetize LTRS without repetitions
        DO N = LLET+1,NL
          IF(LTRS(N)==L) THEN
            LLET = LLET+1; LTRS(N) = LTRS(LLET); LTRS(LLET) = L
            CYCLE OUTER
          END IF
        END DO; IF(LLET==NL) EXIT
      END DO OUTER
      DO I = 1,LLET           ! Count occurrences of each letter (needed?)
        M = LTRS(I); KL = 0   ! and store with letter in LKOD(0,-)
        DO J = 1,NL
          IF(LTRS(J)==M) KL = KL + 1
        END DO
        LKOD(0,I) = M + KL*100
      END DO

C  As you presumably know, each letter in this schema goes proxy for a triple
C  of adjustable parameters: Hi,Lo,Pr. [Lo,Hi] is the size range within which
C  matrix elements coded L will be randomized (or fixed if Lo = Hi), while
C  this term is made negative with probability Pr.  If you elect to revise
C  the present settings, recall that entering less than three numbers when
C  editing the settings for proxy L will set Pr = 0 and default Lo to Hi
C  if you enter just one.

C  Reminder: Each letter in this schema goes proxy for a triple of adjustable
C  parameters; Hi,Lo,Pr. [Lo,Hi] is the size range within which matrix elements
C  coded L will be randomized (or fixed if Lo = Hi), while this term is made
C  negative with probability Pr.  If you elect to revise the present settings,
C  recall that entering less than three numbers when editing the settings for
C  proxy L will set Pr = 0 and default Lo to Hi if you enter just one.

      IF(LSHO==0) GOTO 43
      WRITE(6,'("  Reminder: Each letter in this schema goes proxy f",
     +  "or a triple of adjustable"/"  parameters: Hi,Lo,Pr. [Lo,Hi]",
     +  " is the size range within which matrix elements"/"  coded L",
     +  " will be randomized (or fixed if Lo = Hi), while this value",
     +  " is made"/"  negative with probability Pr.  If you elect to",
     +  " revise the present settings,"/"  recall that entering less",
     +  " than three numbers when editing the settings for"/"  proxy",
     +  " L will set Pr = 0 and default Lo to Hi if you enter just ",
     +  "one.")'); LSHO = 0
      WRITE(6,'("  >> Note 1:  Numeric entries here cannot exceed thr",
     +  "ee digits and, if entered"/7X,"without a decimal point, are ",
     +  "presumed to start with one.  So make the"/7X," decimal expli",
     +  "cit in entries exceeding .999 or less than .010."/)')
      WRITE(6,'("  >> Note 2: Entry of a letter at any point will ju",
     +  "mp to display of what"/7X,"has been entered so far, followed",
     +  " by option to resume/revise these"/13X,"specifications or qu",
     +  "it with provision for finishing later.")')
      IF(NF>4) CALL WAIT(0)
      PL = 's '  ! PL(K:); want K=2 if LK = 1, otherwise K=1
C
43    KIK = -1; LKBK = LKOD ! Count changes (none/some would suffice)
45    CALL SHO(NY,NF,KIND,F1,LKOD,LST,LLET,2,6)
      IF(KIK<0) THEN ! ******* No need to show pat again if NY<10
        WRITE(6,'(3X,"To accept these parameter specifications, hit ",
     +    "RETURN.  Otherwise, enter")')
        WRITE(6,'(3X,"any letter to revise them, or any numeral to ",
     +    "see the pattern schema again.")')
        CALL SCN(J); IF(J==0) GOTO 99; IF(J>0) GOTO 32; GOTO 51
CC        IF(J>0.AND.NY>9) GOTO 32; GOTO 51
      END IF
      DO I = 1,3; DO J = 1,LLET
          IF(LKOD(I,J)/=LKBK(I,J)) KIK = KIK+1
      END DO; END DO
      IF(KIK>=0) THEN
        IF(KIK==0) WRITE(6,'(/"  You have left these settings unchang",
     +    "ed.  Enter something if you want to"/"  make another edit p",
     +    "ass at them.  Otherwise, hit RETURN to accept them.")')
        IF(KIK>0) WRITE(6,'(/7X,"To accept these revised parameter se",
     +    "ttings, hit RETURN.  Otherwise,"/7X,"enter anything to cor",
     +    "rect them.")')
        CALL SCN(J); IF(J/=0) GOTO 51
      END IF
47    LDT=7; IF(KIND==3) LDT=5; IF(F1(LDT+1:LDT+1)=='.') LDT=LDT+1
      WRITE(6,'("  If you want this schema stored with these altered",
     +  " parameter settings"/"  enter any letter to create a new ",
     +  A," file, or any integer to overwrite"/2X,A,". Otherwise, ",
     +  "hit RETURN to waive archiving these changes.")')
     +  F1(:LDT-1), F1(:LAST(F1))
      CALL SCN(J); IF(J==0) GOTO 99
      IF(J>0) THEN ! Integer calls rewrite
        WRITE(6,'("  Hit RETURN to confirm replacing the parameters ",
     +    "now saved in ",A," with"/"  their present values.  Otherw",
     +    "ise, enter anything to reconsider.")')
        CALL SCN(J); IF(J==0) GOTO 49; GOTO 47
      END IF
      F1 = F1(:LDT)//CF(:JF(MM+1))
49    OPEN(7,FILE=F1,FORM='UNFORMATTED')
      WRITE(7) LST(0),  (LST(I),I=1,LST(0))
      WRITE(7) LLET, ((LKOD(I,J),I=0,3),J=1,LLET)
      CLOSE(7)
      WRITE(6,'("  Changes saved as instructed.")')
      GOTO 99
51    DO L = 1,LLET  ! Start editing
        K = 1; IF(LKOD(0,L)/100==1) K = 2; LTRS(1) = 1  ! KORD must be flagged
54      WRITE(6,'(4X,"Your parameter settings for generating ",A,1X,
     +    "element",A,"coded  ",A,"  are now"/16X,"<Hi,Lo,Pr> = <",
     +    A4,2(1X,A4),">"/4X,"Hit RETURN if OK, or enter preferred ",
     +    "triple with Pr last."/)')  CF(:JF(LKOD(0,L)/100)), PL(K:),
     +    CHAR(MOD(LKOD(0,L),100)), (CLN(.001*LKOD(J,L),4,3),J=1,3)
        CALL SCANR(J,0,'R',LTRS(1))   ! ***** Special return in LTRS
        IF(J==0) CYCLE; IF(J<0) GOTO 32
        JJ = MIN(3,J)
        READ(2,*) (X(I),I=1,JJ)
        DO I = 1,JJ
          IF(X(I)/=NINT(X(I)) .OR. LTRS(I)>0)  CYCLE
57        IF(ABS(X(I))>1.) THEN; X(I) = .1*X(I); GOTO 57; END IF
        END DO
        IF(JJ==1) THEN
          LKOD(1,L) = NINT(1000*X(1)); LKOD(2,L) = LKOD(1,L)
        ELSE IF(JJ>1) THEN
          K = 1; IF(ABS(X(2))>ABS(X(1))) K = 2; M = NINT(SIGN(1.,X(K)))
          LKOD(1,L) = NINT(M*1000*MAX(ABS(X(1)),ABS(X(2))))
          LKOD(2,L) = NINT(M*1000*MIN(ABS(X(1)),ABS(X(2))))
        END IF
        IF(JJ==3) LKOD(3,L) = 1000*ABS(X(3)); IF(JJ<3) LKOD(3,L) = 0
        GOTO 54
      END DO
      GOTO 45
C =============== End of letter specifications ==================
99    WRITE(6,'(" Hit RETURN to instantiate this schema for use in ",
     +  "the SEM model you are"/" building.  Otherwise, enter anyth",
     +  "ing for return to available alternatives.")')
      CALL SCN(J); Z = 1.
      IF(J/=0) THEN
        WRITE(6,'(" >>> Hit RETURN to confirm that you don''t want to",
     +    " use this schema at present,"/5X,"or enter anything to cor",
     +    "rect what may have been an entry error.")')
        CALL SCN(J); IF(J/=0) GOTO 99
        MSG = 1; RETURN
      END IF
      WORD(:7) = '.     '; IF(KIND==4) WORD(:7) = ' except'
      DO L = 1,LLET; Z = MIN(Z,ABS(.001*LKOD(2,L))); END DO  ! Z is smallest Lo
      WRITE(6,'(" This schema''s ""background"" consists of its nons",
     +  "alient (dot-marked) elements."/" If you want those to remai",
     +  "n strictly zero in this instantiation, hit RETURN."/" Other",
     +  "wise, enter a letter to fuzz your schema with background no",
     +  "ise",A)') WORD(:7)
      IF(KIND==4) WRITE(6,'(" where recursive structure proscribes.")')
      CALL SCN(J); IF(J==0) GOTO 120
110   WRITE(6,'(" This schema''s FUZZ parameter, which will randomize",
     +  " its background elements"/" within FUZZ of zero, is now",A5,
     +  ".  Hit RETURN if OK; otherwise, enter your"/" preferred FUZZ",
     +  ". (Usually this should be considerably less than your lowest"/
     +  " salience bound, which at present is",A5," here.)"/)')
     +  CLN(FUZ,5,3), CLN(Z,5,3)
      CALL SCANR(J,1,'R',NUL); IF(J==0) GOTO 114; IF(J<0) GOTO 110
      READ(2,*) FUZ; FUZ = ABS(FUZ)
112   IF(FUZ>=1.) THEN; FUZ = FUZ/10; GOTO 112; END IF
      GOTO 110
114   IF(FUZ>.8*Z .AND. KIND/=3) THEN
        WRITE(6,'(" Do you really want to blur the contrast between ",
     +    "salient and nonsalient"/" loadings here with FUZZ this la",
     +    "rge (",A5,")?  If so, enter anything to"/" confirm.  Othe",
     +    "rwise, hit RETURN to reconsider.")') CLN(FUZ,5,3)
        CALL SCN(J); IF(J==0) GOTO 110
      END IF
120   B=0.; IF(KIND==3) THEN; DO I=1,NF; B(I,I)=1.; END DO; END IF  ! Unities on COV diagonal
      IF(FUZ>=.005) THEN; S = FUZ/.5
        DO I = 1,NY; L = NF; IF(KIND>2) L = I-1  ! KINDs 3,4 are COV,APATR
          DO J = 1,L
            B(I,J) = S*(RANDY()-.5)
          END DO
        END DO
      END IF
      DO K = 1,LST(0)
        I = LST(K)/10000; J = MOD(LST(K)/100,100); L = 0
125     L = L+1
        IF(MOD(LKOD(0,L),100)/=MOD(LST(K),100).AND. L<LLET) GOTO 125
        HO = .001*LKOD(2,L); HI = .001*LKOD(1,L); KP = LKOD(3,L)
        Z = ABS(HO) + ABS(HI-HO)*RANDY(); IF(KP==0) Z = SIGN(Z,HI)
        IF( KP>0 .AND. RANDY()<.001*KP ) Z = -Z
        B(I,J) = Z
      END DO
      IF(KIND/=3) RETURN  ! Return full matrix even if symmetric
      DO J = 1,NF; DO I = 1,J-1
          B(J,I) = B(I,J)
      END DO; END DO
      RETURN
      END SUBROUTINE

      FUNCTION LAST(WORD)
C This left-justifies leading substring WORD(:M) of WORD, and returns its
C length as L. If the string is empty, LAST is returned as 0.
      CHARACTER WORD*(*)
      M = LEN(WORD)
      WORD(:M) = ADJUSTL(WORD(:M))
      LAST = LEN_TRIM(WORD(:ABS(M)))
      END FUNCTION

      FUNCTION LOOP(NF,LST)
C Determine if sparce NFNF matrix compressed in LST is recursive.  Each of NL
C integers in LST is 10000*i + 100*j + L for nonzero entry in KTL cell <i,j>.
C Function value returned is count LOOP of looped nodes; list of indices that
C are in loops are returned in LPP
      INTEGER LST(0:*), KTL(NF,NF)
      KTL = 0; LOOP = 0; LK = 1; NL = LST(0)
      DO I = 1,NL
        KTL( LST(I)/10000, MOD(LST(I)/100,100) ) = 1
      END DO
      DO WHILE(LK<NF)
        DO I = 1,NF; DO J = 1,NF; DO K = 1,NF
           IF(KTL(I,K)*KTL(K,J)==1) KTL(I,J) = 1
        END DO; END DO; END DO
        LK = LK*2
      END DO
      DO I = 1,NF
        IF(KTL(I,I)>0) THEN
          LOOP = LOOP+1
        END IF
      END DO
      END FUNCTION
C
      SUBROUTINE LOOK(K,GET,NAME,ML,KNT)
C LOOK calls DOS to delete or report files named in GET, with action set by K.
C K/2 = 0,1 initial-lists/append-lists GET in buffer file ZZZ. MOD(K,2) = 0,1
C stores/shows-to-screen the GET list. So K=0 initial-stores; K=1 initial-
C shows; K=2 append-stores; and K=3 append-shows. The last filename matching
C the GET template is returned in WORD with its length M.  NAME returns the
C list of template matches, the number of which is NL, and prints the numbered
C list to screen.  ML is max NL allowed by array allocation.
C ***** This variant uses negative input on NL to suppress screen write
      LOGICAL PRM, QY
      CHARACTER*12 GET*(*), NAME(*), WORD*40, WD*40, TMP
      CHARACTER E   ! <<<  Special characters as needed
      SAVE NL  ! NL must NOT be disturbed by KNT if K > 1
      NOSHO = KNT; IF(K<2) NL = 0  ! Shd always have K  1 on 1st call
      WD = GET
      M = LAST(WD)
      LL = 1
5     LL = LL+1; IF(LL<M) GOTO 5
      WD(M+2:M+LL+1) = WD(:LL); WD(40:40) = ' '  ! Shd now always have LL = M
      DO I = M+2,M+LL+1
        IF(WD(I:I)=='*' .OR. WD(I:I)=='?' ) THEN
          WD(40:40) = '!'; WD(I:I) = '!'
        END IF
      END DO
      INQUIRE(FILE=WD(M+2:M+LL+1),EXIST=QY)
      IF(.NOT.QY) OPEN(19,FILE=WD(M+2:M+LL+1)) ! Precludes no-match error message
      IF(K/2==0) CALL SYSTEM('dir '//WD(:M)//' >ZZZ')
      IF(K/2>0) CALL SYSTEM('dir '//WD(:M)//'>>ZZZ')  ! Append
      IF(.NOT.QY) CLOSE(19,STATUS='DELETE')
      IF(MOD(K,2)==0) RETURN
      OPEN(4,FILE='ZZZ')
10    READ(4,'(A)',END=50) WORD
      IF(WORD(25:26)==' 0' .OR. WORD(16:16)=='<') GOTO 10  ! No directory names
      E = WORD(:1); IF(E==' ' .OR. E=='.') GOTO 10
      IF(WORD(:3)=='COV' .AND. LGT(WORD(4:4),'9')) GOTO 10
      IF(WORD(:3)=='KOV' .AND. LGT(WORD(4:4),'9')) GOTO 10
      IF(WORD(:3)=='PAT' .AND. LGT(WORD(4:4),'9')) GOTO 10
      IF(WORD(:4)=='APAT' .AND. LGT(WORD(6:6),'9')) GOTO 10
      IF(WORD(:3)=='KOV') GOTO 15
      IF(LGT(WORD(10:10),'9')) GOTO 10 ! Ext must start with numeral
15    L = LAST(WORD(:14))      ! ^ Lexically Greater Than
      DO I = 1,L; IF(WORD(I:I)=='!') GOTO 10; END DO
      L = 0
20    L = L+1; IF(WORD(L+1:L+1)/=' ' .AND. L<8) GOTO 20
      IF(WORD(10:10)/=' ') WORD(L+1:L+4) = '.'//WORD(10:12)
      DO I = 1,NL  !  Eliminate possible duplications
        IF(NAME(I)(:L+4)==WORD(:L+4) .AND. NAME(I)(L+5:L+5)==' ')
     +    GOTO 10
      END DO
      NL = NL+1
      NAME(NL) = WORD(:L+4)//'     '
      IF(NL<ML) GOTO 10
50    CLOSE(4,STATUS='DELETE')
      DO J = 2,NL
        TMP = NAME(J)
        DO I = J-1,1,-1
          IF(.NOT.PRM(NAME(I),TMP)) GOTO 55    ! Increasing order
          NAME(I+1) = NAME(I)
        END DO
        I = 0
55      NAME(I+1) = TMP
      END DO
      KNT = NL
      IF(NOSHO<0) RETURN
      IF(NL>0) WRITE(6,'(20(:/4(I5,". ",A,:)))') (I,NAME(I),I=1,NL)
      IF(NL>0) WORD(:12) = NAME(NL)  ! Why???
      RETURN
      END

      FUNCTION PRM(NAM1,NAM2)
C Consider both base and extension when flagging which filename comes first
C in alphanumeric listing.  PRM=t says that NAM2 comes before NAM1.
      LOGICAL PRM
      CHARACTER NAM1*(*), NAM2*(*)
      PRM = .FALSE.
      L1 = LAST(NAM1); L2 = LAST(NAM2)
      N1 = L1+1; N2 = L2+1  ! Find dot positions, if any
10    N1 = N1-1; IF(NAM1(N1:N1)/='.' .AND. N1>1) GOTO 10
20    N2 = N2-1; IF(NAM2(N2:N2)/='.' .AND. N2>1) GOTO 20
      IF(N1==1) N1=L1+1; IF(N2==1) N2=L2+1  ! Where dot would be were there one
      JJ = KPRM(NAM1(:N1-1),NAM2(:N2-1))
      IF(JJ==-1) PRM = .TRUE.; IF(JJ/=0) RETURN  ! JJ=0 if basenames are same
      IF(JJ==0 .AND. (N1>L1 .OR. N2>L2)) THEN  ! An extension is blank
        IF(N2>L2) PRM = .TRUE.; RETURN
      END IF
      JJ = KPRM(NAM1(N1:L1),NAM2(N2:L2))  ! Include extension dot
      PRM = .FALSE.; IF(JJ==-1) PRM = .TRUE.
      END FUNCTION

      FUNCTION KPRM(WRD1,WRD2)
C Return value 0 if WRD1=WRD2; otherwise  -1 or +1 according to whether WRD2
C comes before or after WRD1 in alphanumeric sequence.
      INTEGER KPRM
      CHARACTER WRD1*(*), WRD2*(*)
      L1 = LAST(WRD1); L2 = LAST(WRD2)
      KPRM = 0; IF(WRD1(:L1)==WRD2(:L2)) RETURN
      N1 = L1+1; N2 = L2+1    ! Find position preceding terminal number string
10    N1 = N1-1; N = ICHAR(WRD1(N1:N1))
         IF(N>47.AND.N<58 .AND. N1>1) GOTO 10
20    N2 = N2-1; N = ICHAR(WRD2(N2:N2))
         IF(N>47.AND.N<58 .AND. N2>1) GOTO 20
      IF(LLT(WRD1(:N1),WRD2(:N2))) KPRM = 1
      IF(LLT(WRD2(:N2),WRD1(:N1))) KPRM = -1
      IF(WRD1(:N1)/=WRD2(:N2)) RETURN
      IF(N1==L1 .OR. N2==L2) THEN  ! A mumber terminus is blank
        KPRM = 1; IF(N2==L2) KPRM = -1; RETURN
      END IF
      READ(WRD1(N1+1:L1),*) K1; READ(WRD2(N2+1:L2),*) K2
      KPRM = 1; IF(K2<K1) KPRM = -1
      END FUNCTION

      SUBROUTINE MINV(N,A,LDA,IER)
C This returns in A the inverse of N-by-N matrix A, with determinant if
C wanted. LDA is the leading dimension of A declared in the calling program.
      INTEGER R(N), C(N)
      REAL A(LDA,*)
      IF(N>LDA) WRITE(6,'(/" Parameter MV in subroutine MINV ",
     +  "must be increased to ",I3)') N
      IF(N>LDA) STOP
      D = 1.; IER = 0
      BBIG: DO K=1,N
C Search for largest element
        R(K) = K; C(K) = K; BIG = A(K,K)
        DO J=K,N; DO I=K,N
            IF(ABS(BIG)>=ABS(A(I,J))) CYCLE
            BIG = A(I,J); R(K) = I; C(K) = J
        END DO; END DO
C Interchange rows
        I = R(K)
        IF(I<=K) GOTO 60
        DO J=1,N
          TMP = A(K,J); A(K,J) = A(I,J); A(I,J) = TMP
        END DO
C Interchange columns
60      J = C(K)
        IF(J<=K) GOTO 90
        DO I=1,N
          TMP = A(I,K); A(I,K) = A(I,J); A(I,J) = TMP
        END DO
C Divide column by minus pivot (saved in BIG)
90      IF(ABS(BIG)<1.0E-30) IER = 1
        IF(IER==1) RETURN
        DO I=1,N
          IF(I/=K) A(I,K) = -A(I,K)/BIG
        END DO
C Reduce matrix
        DO I=1,N
          TMP = A(I,K)
          DO J=1,N
            IF(I==K .OR. J==K) CYCLE
            A(I,J) = A(I,J) + TMP*A(K,J)
          END DO
        END DO
C Divide row by pivot
        DO J=1,N
          IF(J/=K) A(K,J) = A(K,J)/BIG
        END DO
C Accumulate product of pivots.  At output, D is the matrix's determinant.
        D = D*BIG
C Replace pivot by its reciprocal
        A(K,K) = 1./BIG
      END DO BBIG
C Final row/column interchange to undo permutations
      K = N
200   K = K-1
      IF(K==0) RETURN
      J = R(K)
      IF(J<=K) GOTO 240
      DO I=1,N
        TMP = A(I,K); A(I,K) = A(I,J); A(I,J) = TMP
      END DO
240   I = C(K)
      IF(I<=K) GOTO 200
      DO J=1,N
        TMP = A(K,J); A(K,J) = A(I,J); A(I,J) = TMP
      END DO
      GOTO 200
      END SUBROUTINE

      SUBROUTINE SCN(NL)
C This is a baby SCAN that responds to keyboard entry KB by returning NL = 0
C if KB is RETURN, NL = 1 if KB is a number, and NL = -1 KB is a letter.
      CHARACTER CH
      READ(6,'(A)') CH; N = ICHAR(CH)
      NL = 0; IF(N<=32) RETURN
      IF(N<58) NL = 1; IF(N>64) NL = -1
      END SUBROUTINE
C
      SUBROUTINE SCANR(NL,NS,SEQ,KND)
C This reads the keyboard string, cleans it for list-directed reading of
C the numbers therein, and checks whether it contains NS integers/reals in
C the sequence of Is and Rs received in SEQ if NS>0, or, if NS<1, whether
C all its numbers are of the first I/R kind listed in SEQ. (Integers are
C accepted also as reals.  Termination of an input line by "*" allows up to
C two continuation lines.)  NL returns 0 if the input string is blank, -1 if
C this contains only non-numeric characters, -2 if the cleaned number string
C returned in File 2 is non-null but does not match SEQ, and gives the total
C count of numbers in the returned string otherwise.
C *** If SEQ is "B", NL returns 0 if the input line is blank or -1 otherwise.
C *** Version R: KND(I) returns 1 if Ith entry has a decimal, else 0
      CHARACTER  AA, SEQ*(*), WA*240, WB*240
      INTEGER KND(*)
      NL = 0
5     NLL = NL + 80
      READ(5,'(A80)') WA(NL+1:NLL)
      IP = NL
      NL = NLL+1
10    NL = NL-1
      IF(NL==0) RETURN
      IF(WA(NL:NL)==' ') GOTO 10
      IF(WA(NL:NL)=='*' .AND. NL>IP) GOTO 5
      IF(SEQ(1:1)=='B') NL = -1
      IF(SEQ(1:1)=='B') RETURN
      IP = 0; WB = ' '
      DO I = 1,NL
        IF(WA(I:I)<CHAR(48) .OR. WA(I:I)>CHAR(57)) CYCLE
        WB(I:I) = WA(I:I); WA(I:I) = '0' ! All digits transferred to WB
      END DO
CC      IP = 0  ! Already initialized ?? (Flags whether transfer of . is ok)
      IF(WA(:3)=='-.0'.OR.WA(:2)=='-0') WB(:1) = '-'       ! WA starts with - ?
      IF(WA(:2)=='.0') THEN; WB(:1) = '.'; IP = 1; END IF  ! WA starts with . ?
      DO I = 2,NL    ! REM: '0' in WA now flags integers transferred to WB
        IF(WA(I:I)=='-') THEN
          IF(WB(I-1:I-1)==' ' .AND. (WA(I+1:I+1)=='.'.OR.WA(I+1:I+1)
     +      =='0')) WB(I:I) = '-'; IP = 0
        ELSE IF (WA(I:I)=='.') THEN
          IF( (WA(I-1:I-1)=='0'.OR.WA(I+1:I+1)=='0') .AND. IP==0) THEN
            WB(I:I) = '.'; IP = 1
          END IF
        ELSE IF(WA(I:I) /= '0') THEN
          IP = 0
        END IF
      END DO
C Identify Integer/Real sequence in WB and put I/R string in start of WA
      NN = 0  ! Count numbers in the input sequence
      AA = 'I'; IF(WB(1:1)=='.') AA = 'R'
      DO I = 2,NL+1
        IF(WB(I:I)==' ' .AND. WB(I-1:I-1)/=' ') THEN
          NN = NN + 1; WA(NN:NN) = AA; AA = 'I'
        ELSE IF(WB(I:I)=='.') THEN    !   ^  Default for next entry
          AA = 'R'
        END IF
      END DO
      IF(NN==0) THEN; NL = -1; RETURN; END IF
      IF(KND(1)/=0) THEN
        DO J = 1,NN; KND(J) = 1; IF(WA(J:J)=='I') KND(J) = 0; END DO
      END IF                   ! ^ Return 0,1 coding of I,R kinds
      AA = '+'
      IF(NS<=0 .AND. SEQ(1:1)=='R') GOTO 60
      IF(NS<=0) GOTO 50
      IF(NN<NS) GOTO 57
      DO I = 1,NS
        IF(SEQ(I:I)=='I' .AND. WA(I:I)/='I') AA = '0'
      END DO
      GOTO 55
50    DO I = 1,NN
        IF(WA(I:I)/=SEQ(1:1)) AA = '0'
      END DO
55    IF(AA=='+') GOTO 60
57    NL = -2
      IF(NL<=-2) WRITE(6,'(/" Your input does not contain the ",
     +  "number sequence requested. Try again.")')
      RETURN
60    REWIND 2
      WRITE(2,'(A)') WB(1:NL)
      NL = NN
      REWIND 2
      RETURN
      END

      FUNCTION RANDY()
C Use the compiler's random generator for a random number in the unit interval
      DATA NEW/1/
      IF(NEW.GT.0) THEN; NEW = 0; CALL RANDOM_SEED(); END IF
      CALL RANDOM_NUMBER(RANDY)
      END FUNCTION
C
      SUBROUTINE SCHEM(NV,NF,JV,JF1,CUT,A,LDA)
C Display schematized factor pattern in A with blanks for loadings smaller
C than CUT and others rounded to nearest lst decimal.
      CHARACTER*3 LN(:), FMT*40, C2*2, C1*1, CF*12
      ALLOCATABLE :: LN
      REAL A(LDA,*)
      COMMON /CF/ CF
      ALLOCATE ( LN(NF) )
5     IF(CUT>1.5) CUT = CUT/10
      IF(CUT>1.5) GOTO 5
      C2 = CF(:JF(JF1)); C1 = CF(:JF(75/(2+3*JF1)))
      FMT = '(I4,".",'//C1//'(2X,'//C2//'A),5(:/6X,'//C1//'(2X,'//
     +       C2//'A)))'
      DO I = 1,NV
        IF(MOD(I-1,JV)==0 .AND. I<NV) WRITE(6,'()')
        DO J = 1,NF
          LN(J) = '  .'
          X = ABS(A(I,J)); IF(X<=CUT) CYCLE
          IF(A(I,J)<.01) LN(J)(2:2) = '-'
          LN(J)(3:3) = CHAR(48+NINT(MIN(9.,10*X)))
        END DO
        WRITE(6,FMT) I, (LN(J), J=1,NF)
        IF(((MOD(I,10)==0.AND.NV-I>5).OR.I==NV)) CALL WAIT(1)
      END DO
      END SUBROUTINE
C
      SUBROUTINE SHO(NY,NF,KIND,F1,LKOD,LST,LLET,JOB,KF)
C JOB<=1 shows matrix schema; JOB=2 shows its letter specs; JOB > 2 shows both
C Only negative SHO job in Gendata package so far is -3.
      CHARACTER*4  C0,C1,C2,C3,C4, CH3*3, CK*1, CLN*8, FMT*50
      CHARACTER*12  CF, F1, WORD*80, WRD(51)*3, CC*2
      INTEGER GRID(NY,NF), LKOD(0:3,*), LST(0:*)
      COMMON /CF/ CF
C ========= Start of schema display ==========
      MM = 24; IF(KF/=6) MM = 50
      IF(ABS(JOB)==2) GOTO 11
      GRID = 249    ! Show grid zeros by 
      CK = 'A'; IF(KIND==3) CK = 'C'; IF(KIND==5) CK = 'M'
      CC = '24'; IF(KF/=6) CC = '50'
      NL = LST(0); IE = 0             ! "//CC//"
      DO K = 1,NL  ! Unpack grid saved in LST
        I = LST(K)/10000; J = MOD(LST(K)/100,100)
        GRID(I,J) = MOD(LST(K),100); IF(KIND/=2) CYCLE
        IF(I<=J) IE = IE+1  ! IE>0 flags not subdiagonal
      END DO
      WORD(:11) = ' recursive '; J = 1; IF(KIND==4) J=11
      IF(KF==6) WRITE(KF,'(5X,A," by ",3A,"-schema ",A," is")')
     +  CF(:JF(NY)), CF(:JF(NF)), WORD(:J), CK, F1(:LAST(F1))
      IF(KF/=6) WRITE(KF,'(4X,"Schema ",A," is")') F1(:LAST(F1))
      WRITE(KF,'(4X,'//CC//'I3,3(:/4X,'//CC//'I3))') (I,I=1,NF)  ! Indices on top line
      CH3 = 'Ŀ '; IF(NF>MM) CH3 = '   '  ! IF(NF>MM.OR.KIND==3) CH3 = '   '
      WRD=' '; N1 = NF+1 ! ^ MM is number of 3-fields in show line
      IF(KIND==3 .AND. NF<=24) THEN
        WRD = ' '; N1 = NF+1; WRD(NF:NF) = 'sym'; WRD(N1:N1) = '  '
      END IF
      WRITE(KF,'(3X,"",'//CC//'A3,2A3)') ('',I=1,MIN(NF,MM)), CH3
      CH3 = '  '; IF(KIND==3) CH3 = '  1'  ! Rem: MaxEntries^ in line
      L = 1+(NF-1)/MM; LSHN = 3; LSHB = 0       ! L is lines per table row
      FMT = '(I3,"",'//CC//'A3,2A3)'
      IF(NF>MM) FMT(13:) = '/3(:3X,"",'//CC//'A3))'
      DO K = 1,NY; JJ = NF; IF(KIND==3) JJ = K-1
        IF(NF<=MM) WRITE(KF,FMT) K, ('  '//CHAR(GRID(K,I)),I=1,JJ),
     +     CH3, WRD(JJ+1:N1)
        IF(NF>MM) WRITE(KF,FMT) K, ('  '//CHAR(GRID(K,I)),I=1,JJ) !, CH3
        IF(K==1 .AND. KIND==3) WRD(:NF) = '   '
        IF(KF/=6) CYCLE; LSHN = LSHN+L
        IF(LSHN-LSHB>20.AND.(NY-K)*L>4) THEN
          CALL WAIT(0); LSHB = LSHN
        END IF
      END DO
      WRITE(KF,'(3X,"",'//CC//'A3,A3)') ('',I=1,MIN(NF,MM))," "
      IF(ABS(JOB)<2) RETURN
C ==================== End of schema display ======================
11    IF(JOB>1) WRITE(KF,'(3X,A,"''s current parameter assignments ",
     +  "are")') F1(:LAST(F1))
      IF(JOB<0) WRITE(KF,'(4X,"under specification parameters")')
      MM = 17; IF(KF/=6) MM = LLET
      C1 = 'Ŀ  '; C2 = '   '; C3 = 'Ĵ  '; C4 = '  '; C0 = '   '
      IF(LLET>MM) THEN; C1 = ' '; C2 = ' '; C3 = ' '; C4 = ' '; END IF
      WRITE(KF,'(6X,"",20A)') ((""),I=1,MIN(LLET,MM)), C1
      WRITE(KF,'(6X,"",40A)') ('   ',CHAR(MOD(LKOD(0,I),100)),I=1,
     +  MIN(LLET,MM)), C2
      WRITE(KF,'(" ",60A)') ((""),I=1,MIN(LLET,MM)), C3
      WRITE(KF,'("  Hi ",60(1X,A3))') (CLN(.001*LKOD(1,I),3,2),I=1,
     +  MIN(LLET,MM)), C0
      WRITE(KF,'("  Lo ",60(1X,A3))') (CLN(.001*LKOD(2,I),3,2),I=1,
     +  MIN(LLET,MM)), C0
      WRITE(KF,'("  Pr ",60(1X,A3))') (CLN(.001*LKOD(3,I),3,2),I=1,
     +  MIN(LLET,MM)), C0
      WRITE(KF,'(" ",60A)') ((""),I=1,MIN(LLET,MM)), C4
      IF(LLET>MM) THEN; K = 34-LLET    ! K + LLET-17 = 17
        C1 = ''; C2 = ''; C3 = ''; C4 = ''
        WRITE(KF,'(7X,20A)') ('    ',I=1,34-LLET), ('',I=18,LLET),C1
        WRITE(KF,'(7X,20A4)') ('    ',I=1,34-LLET),  ('   ',CHAR(MOD(
     +    LKOD(0,I),100)),I=18,LLET), C2
        WRITE(KF,'(7X,20A)') ('    ',I=1,34-LLET), ('',I=18,LLET),C3
        WRITE(KF,'(7X,20(1X,A3))') ('    ',I=1,34-LLET),(CLN(.001*LKOD(
     +    1,I),3,2),I=18,LLET), C0
        WRITE(KF,'(7X,20(1X,A3))') ('    ',I=1,34-LLET),(CLN(.001*LKOD(
     +    2,I),3,2),I=18,LLET), C0
        WRITE(KF,'(7X,20(1X,A3))') ('    ',I=1,34-LLET),(CLN(.001*LKOD(
     +    3,I),3,2),I=18,LLET), C0
        WRITE(KF,'(7X,20A)') ('    ',I=1,34-LLET), ('',I=18,LLET),C4
      END IF
      IF(KF/=6 .AND. FUZ>.005) WRITE(KF,'(3X,"and level ",A3," ba",
     +  "ckground fuzz.")') CLN(FUZ,3,2)
      END SUBROUTINE
C
      SUBROUTINE START(J,F1)
C This opens formatted file F1 with unit-number J, and finds its first line
C beginning with a digit.
      CHARACTER F1*12, CH*80
      OPEN(J,FILE=F1)
10    READ(J,'(A)',END=50) CH
      K = 0
12    K = K+1
      L = ICHAR(CH(K:K))
      IF((L==32.OR.L==0.OR.L==45.OR.L==46).AND.K<80) GOTO 12
      IF(L<48 .OR. L>57) GOTO 10
      BACKSPACE J
      RETURN
50    WRITE(6,'(/" File ",A," is defective.")') F1
      STOP
      END

      SUBROUTINE TWEAK(NF,NFF,CFF,R,ZLO,CC,IER,JOB)
C Tweak input COV-matrix CFF to have declared low eigenvalue ZLO.
C When JOB = 0, interaction with user is suppressed. CC is 'Cff' or 'Cuu'
      CHARACTER CF*12, CC*3, CLN*8, C8*8
      REAL CFF(NFF), R(*)
      LO(I,J) = J*(J-1)/2 + I
      COMMON /CF/ CF
      CALL EIGS(NF,NF,CFF,NFF,R,X,NF,0,IER,6); Z = R(NF)  ! Eigvecs not needed
      IF(Z>.99) THEN
        IF(JOB/=0) WRITE(6,'(" >>> This ",A," is orthogonal; it ca",
     +    "n''t be tweaked.")') CC; RETURN
      END IF
      C8='factor  '; J=6; IF(CC=='Cuu') THEN; C8='exo-root'; J=8; END IF
      IF(JOB==0) GOTO 50     !  ^For JOB=0, this is a dummy
      WRITE(6,'(3X,A," TWEAK:")') CC
10    WRITE(6,'(3X,"The smallest eigenvalue LOW of your ",A," correl",
     +  "ation matrix is now ",A4,"."/3X,"By a multiplicative tweak t",
     +  "hat leaves the correlation ratios unchanged,"/3X,"you can de",
     +  "crease these correlations by making LOW larger, or increase ",
     +  "them"/3X,"by decreasing LOW.  Admissible limits are 1  LOW ",
     +  " 0: The ",A,"s are"/3X,"orthogonalized by LOW = 1, whereas L",
     +  "OW = 0 gives them a linear dependency."/)') C8(:J), CLN(Z,4,3),
     +  C8(:J)

C   COV TWEAK:
C   The smallest eigenvalue LOW of your factor-correlation matrix is now xxxx.
c   By a multiplicative tweak that leaves the correlation ratios unchanged,
C   you can decrease these correlations by making LOW larger, or increase them
C   by decreasing Low.  Admissible limits are 1  LOW  0: All the factors are
C   orthogonalized by LOW = 1, whereas LOW = 0 gives them a linear dependency.

      WRITE(6,'(5X,"If you want to adjust your factor correlations th",
     +  "is way, enter a new"/5X,"choice of LOW.  Otherwise, hit RETU",
     +  "RN to accept ",A," with LOW = ",A4,"."/)') CC, CLN(Z,4,3)
      CALL SCANR(J,1,'R',NUL)
      IF(J==0) RETURN; IF(J<0) GOTO 10
      READ(2,*) ZLO; ZLO = ABS(ZLO)
20    IF(ZLO>1.) THEN; ZLO = ZLO/10; GOTO 20; END IF
      WRITE(6,'(5X,"Hit RETURN to confirm choice of ",A4," for ",A,
     +  "''s smallest eigenvalue.")')  CLN(ZLO,4,3), CC
      IF(ZLO<.01) WRITE(6,'(5X,"(WARNING: LOW this small is unwise ",
     +  "unless you are testing limits.)")')
      WRITE(6,'(5X,"Otherwise, enter anything to choose again.")')
      CALL SCN(J); IF(J/=0) GOTO 10
C Theory on 1-parameter tweaking of any unit-diagonal C to fix its jth root:
C For any scalar multiplier a, Q = a(C-I)+I rescales the off-diagonal C-terms
C while leaving unities on its diagonal:  If C = TDT' is C's eigenstructure,
C Q's is Q = T(aD - a+1)T'. So if d is the jth root of C, the jth root d' of
C Q is d' = ad - a+1 = 1+a(d-1) which equals stipulated r iff a = (1-r)/(1-d).
50    IF(JOB==0 .AND. Z>.1) RETURN
      Z = (1-ZLO)/(1-R(NF))
      DO I = 1,NF-1
        DO J = I+1,NF
          CFF(LO(I,J)) = Z*CFF(LO(I,J))
        END DO
      END DO
      DO I = 1,NF
        R(I) = 1 + Z*(R(I)-1)
      END DO
      IF(JOB/=0) WRITE(6,'(" Eigenvalues of your tweaked ",A," are",
     +  20(:/2(4X,5A6)))') CC, (CLN(R(I),6,2),I=1,NF)
      END SUBROUTINE

      SUBROUTINE WAIT(N)
C  N > 0 calls for space before screen display
      DO I = 1,N; WRITE(6,'()'); END DO
      WRITE(6,'(" Hit RETURN to continue")')
      READ(5,'()')
      RETURN
      END

